﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Class Information
'Class: B4XMainPage
'File: B4XMainPage.bas.
'Date: See global APP_VERSION.
'MainPage for the PFDCreator application.
'Documentation: pfdcreator.hlp, DEVNOTES.md, TODO.md, CHANGELOG.md.
'
'Additional External Libraries = Thanks for sharing:
'AsyncCanvas: https://www.b4x.com/android/forum/threads/asynccanvas-b4xcanvas-wrapper-with-invalidate-for-b4j.148736/#content
'jReflection: https://www.b4x.com/android/forum/threads/jreflection-library.35448/#content
'
'PFDCreator Copyright 2024 by Robert W.B. Linn, Pinneberg, Germany under the GNU General Public License v3.0 (see LICENSE).
#End Region

#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip
'See the list of page related events in the B4XPagesManager object. The event name is B4XPage.
#End Region

Sub Class_Globals
	'App information used for the mainpage title and help about dialog
	Private APP_TITLE As String		= $"PFDCreator v20241220"$
	Private APP_COPYRIGHT As String	= $"Copyright (c) 2024 by Robert W.B. Linn, Pinneberg, Germany${CRLF}${CRLF}"$
	Private APP_CREATED As String	= $"Created with B4J v10.0 (64 bit), Java JDK 19.0.2, internal libraries jCore, jFX, B4XPages, XUI Views, Json, DesignerUtils, ByteConverter, BCTextEngine and additional libraries AsyncCanvas, jReflection.${CRLF}${CRLF}"$
	Private APP_CREDITS As String	= $"[b]Credits[/b]${CRLF}[url=https://www.b4x.com]Anywhere Software[/url] and the [url=https://www.b4x.com/android/forum]B4X Community[/url] for sharing libraries, hints&tips.${CRLF}${CRLF}"$
	Private APP_LICENSE As String	= $"[b]GNU General Public License v3.0[/b]${CRLF}This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 3 of the License, or at your option any later version. This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY Or FITNESS For A PARTICULAR PURPOSE. See the GNU General Public License For more details. You should have received a copy of the GNU General Public License along with this program. If not, see [url=https://www.gnu.org/licenses]GNU licenses[/url]."$

	'Base
	Private fx As JFX

	'UI
	Private xui As XUI
	Private Root As B4XView
	Private PaneCanvas As B4XView
	Private PaneCanvasScaleTop As B4XView
	Private PaneCanvasScaleLeft As B4XView
	Private ScrollPanePFDObjectProperties As ScrollPane

	Private LabelStatusbar As B4XView
	Private LabelPFDChanged As B4XView

	Private LabelDrawMode As B4XView
	Private LabelObjects As B4XView
	Private CustomListViewObjects As CustomListView
	Private CustomListViewShapes As CustomListView

	'Object Properties - Layout PFDDesignerObjectProperties
	Private B4XComboBoxObjPFDObject As B4XComboBox
	Private TextFieldObjTag As B4XView
	Private TextFieldObjDescription As B4XView
	Private TextFieldObjUnit As B4XView
	Private TextFieldObjValue As B4XView
	Private B4XComboBoxObjDirection As B4XComboBox
	Private B4XComboBoxObjArrow As B4XComboBox
	Private SpinnerObjCenterX As Spinner
	Private SpinnerObjCenterY As Spinner
	Private SpinnerObjWidth As Spinner
	Private SpinnerObjHeight As Spinner
	Private TextFieldObjImage As B4XView
	Private B4XComboBoxObjFont As B4XComboBox
	Private B4XComboBoxObjTextAlignment As B4XComboBox
	Private CheckBoxObjSeparator As CheckBox
	Private ColorPickerObjBorderColor As ColorPicker
	Private ColorPickerObjFillColor As ColorPicker
	Private ColorPickerObjTextColor As ColorPicker
	Private SpinnerObjFontSize As Spinner
	Private SpinnerObjStrokeWidth As Spinner
	Private LabelObjCornerRadius As B4XView
	Private SpinnerObjCornerRadius As Spinner
	Private LabelObjectPropertiesSizeBottom As B4XView
	Private LabelObjectPropertiesSizeLeft As B4XView
	Private LabelObjectPropertiesSizeRight As B4XView
	Private LabelObjectPropertiesSizeTop As B4XView
	Private CheckBoxObjOperate As B4XView
	Private LabelObjHint As B4XView
	Private LabelCanvasTouchpositionShort As B4XView
	Private LabelObjIndexValue As B4XView

	'ColorPicker Custom Dialog
	Private ColorPickerDialogColor As ColorPicker

	'MenuBar
	Private MenuBarMain As MenuBar
	Private LabelMenuBar As Label
	'Map with all menu entries
	Private MenuItems As Map

	'BCTextEngine used for BBCodeViews
	Private TextEngine As BCTextEngine

	'Dialogs
	Private Dialog As B4XDialog
	Private ColorTemplate As B4XColorTemplate
	Private B4XPlusMinusField As B4XPlusMinus

	'Help & About
	Private BBCodeViewInformation As BBCodeView

	'SelectToCode
	Private BBCodeViewSelectToCode As BBCodeView
	
	'Toolbars
	Private PaneToolbarTop As B4XView
	Private PaneToolbarObjectProperties As B4XView
	Private PaneToolbarObjectPropertiesMove As B4XView
	Private PaneToolbarDrawMode As B4XView
	Private PANETOOLBARTOP_ITEMS_COUNT As Int = 7
	Private PANETOOLBARTOP_ITEMS_WIDTH As Int = 40

	'Designer Utils
	Private DesignerUtils As DDD

	'Canvas
	'The PFD Drawing Board has a canvas for top&left scale and a canvas for the drawing board
	Private CanvasScaleTop As AsyncCanvas		
	Private CanvasScaleLeft As AsyncCanvas
	Private Canvas As AsyncCanvas

	'PFD
	Private PFD As PFDBase														'PFD Instance to manager PFD Drawing Board
	Private PFDObjects As List													'List of PFDObjects; contains TPFDObject members
	Private PFDDescription As String											'Setting holding brief PFD description
	Private PFDLastChange As String												'Setting holding PFD last changed when saved
	Private PFDChanged As Boolean												'Flag to indicate of the PFD has changed.
	Private PFDFile As String = "new"											'Default for new PFD file name

	'PFD Shapes
	Private PFDShapeNames As List												'List of pfd shapes names (pfdobject)
	Private PFDShapes As List													'List of pfd shapes from shape definition file pfdcreator.shp
	
	'DrawMode & Drag&Drop
	'Draw mode for objects, pipes or lines
	Private DRAWMODE_OFF As Int		= 0
	Private DRAWMODE_OBJECTS As Int	= 1
	Private DRAWMODE_LINES As Int	= 2
	Private DRAWMODE_SELECT As Int	= 3
	Private DrawMode As Int
	Private DrawLineX1, DrawLineY1, DrawLineX2, DrawLineY2 As Int

	'Multiple objects selection using drawmode select
	Private DrawSelectX1, DrawSelectY1, DrawSelectX2, DrawSelectY2 As Int
	Private DrawSelectObjectsRect As B4XRect
	Private DrawSelectObjects As List

	Private Dragging As Boolean
	Private DraggingObj As TPFDObject
	Private DraggingMoved As Boolean
	Private DraggingRectID As Int = -1
	
	'Edit Copy/Paste/Cut object
	Private EditObj As TPFDObject

	'Flags - Run the Object Property UI Views Events.
	Private ObjectPropertyEventEnabled As Boolean = False

	'CustomListViewShapes
	Private lblTitle As B4XView
	Private pnlTitle As B4XView
	Private CustomListViewShapes_ExpandedHeight As Int		= 100dip
	Private CustomListViewShapes_CollapsedHeight As Int		= 50dip		'Must match pnlTitle height (see layout customlistviewshapes_expandableitem)
	Private CustomListViewShapes_ShapeHeightWidth As Int	= 50
	Private CustomListViewShapes_ShapesPerRow As Int		= PFDCommon.SHAPE_SELECTOR_SHAPES_PER_ROW

	Private pnlExpanded As B4XView	
	'Flag if image is clicked
	Private CustomListViewShapes_ImageClicked As Boolean = False

	'Keypress
	Public KeyAlt, KeyShift, KeyCtrl As Boolean				'KeyAlt, KeyShift not used
	
	'Settings
	'Show the grid on the PFD Drawing Board
	Private ShowGrid As Boolean = True
	'Flag to show the object index (circle wit texth in small font) at object position
	Private ShowIndex As Boolean = False
	'PFD Color
	Private PFDBackgroundColor As Int
	'Move step site
	Private MoveStepSize As Int	= 10
	'Flag to set Debug options
	Private Debug As Boolean
End Sub

Public Sub Initialize
	B4XPages.GetManager.LogEvents = Debug
	Log($"${APP_TITLE}"$)
End Sub

#Region B4XPage
'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	'Assign the root b4xview
	Root = Root1

	'Define the key event filter which uses the Key_Filter event.
	Dim r As Reflector
	r.Target = Root
	r.AddEventFilter("Key", "javafx.scene.input.KeyEvent.KEY_PRESSED")

	'Init the designer utils mainly used for the toolbars
	DesignerUtils.Initialize
	xui.RegisterDesignerClass(DesignerUtils)

	'Load the mainpage
	Root.LoadLayout("MainPage")
		
	'Set some UI properties
	B4XPages.SetTitle(Me, $"${APP_TITLE}"$)
	B4XPages.GetNativeParent(Me).Icon = xui.LoadBitmap(File.DirAssets, "PFDCreator.png")
	
	'Set the width of the top toolbar
	PaneToolbarTop.Width = PANETOOLBARTOP_ITEMS_COUNT * PANETOOLBARTOP_ITEMS_WIDTH
	'Set default PFD background color
	PFDBackgroundColor = Helper.ColorHexToInt(PFDCommon.COLOR_ISA101_LIGHTGREY224)
	'LabelDrawMode tooltip - not used as annoying text; see help instead
	'LabelDrawMode.As(Label).TooltipText = PFDCommon.HINT_DRAWMODE
		
	'Dialog used for various dialogs like file open, select object and many more
	Dialog.Initialize(Root)
	Dialog.Title = "PFD Creator"
	ColorTemplate.Initialize
	
	'List of pfdobjects like instrument, pipe, pump, valve etc.
	PFDObjects.Initialize

	'List of selected objects (see DrawMode DrawSelect)
	DrawSelectObjects.Initialize

	'Menu Items - List of main menuitems
	MenuItems.Initialize
	CollectMenuItems(MenuItems, MenuBarMain.Menus)
	SetMenuItemsIcon

	'Init the shapes list (clv)
	CallSubDelayed(Me, "InitShapesList")

	'Init the canvas incl. PFDBase instance
	CallSubDelayed(Me, "InitCanvas")

	'Adjust UI
	CustomListViewObjects.DefaultTextColor = xui.color_blue
	CustomListViewShapes.DefaultTextColor = xui.color_blue
End Sub

Private Sub B4XPage_SetTitle(title As String)
	If title.Length == 0 Then title = "No PFD"
	B4XPages.SetTitle(Me, $"${APP_TITLE} - ${title}"$)
End Sub

'Load the lists shapes and shapenames from the external shapes file pfdcreator.shp.
'Populate the customlistview with the shapes grouped by shapetype.
Private Sub InitShapesList
	'Init the shapes & shapenames lists
	PFDShapes.Initialize
	PFDShapeNames.Initialize
	'Load the shapes list in the customlistview
	Wait for (CustomListViewShapes_Load) complete (resultshapes As Boolean)
	'Add to the selection combobox in the object properties.
	CallSubDelayed(Me, "InitShapesSelection")
End Sub

'Set the shape types to the object properties selection combobox.
'This combobox allows to change the shape type without removing and re-add the object.
Private Sub InitShapesSelection
	B4XComboBoxObjPFDObject.SetItems(PFDShapeNames)
End Sub

'Init the PFD Drawing Board Canvas
Private Sub InitCanvas
	'Canvas holding the PFD created from external pfd definition file
	PaneCanvas.Color = PFDBackgroundColor
	Canvas.Initialize(PaneCanvas, 0, 0, PaneCanvas.Width, PaneCanvas.Height)
	'AutoInvalidate do not set to true because invalidate handled by ReDraw methods
	Canvas.AutoInvalidate = False

	PaneCanvasScaleTop.Color = PFDBackgroundColor
	CanvasScaleTop.Initialize(PaneCanvasScaleTop, 0, 0, PaneCanvasScaleTop.Width, PaneCanvasScaleTop.Height)
	PFDCommon.DrawScale(CanvasScaleTop, "TOP")

	PaneCanvasScaleLeft.Color = PFDBackgroundColor
	CanvasScaleLeft.Initialize(PaneCanvasScaleLeft, 0, 0, PaneCanvasScaleLeft.Width, PaneCanvasScaleLeft.Height)
	PFDCommon.DrawScale(CanvasScaleLeft, "LEFT")

	'Init the PFDBase instance	
	PFD.Initialize(Canvas, Debug)

	'Draw the scale and the pfd grid
	If ShowGrid Then
		PFDCommon.DrawGrid(Canvas, False)
	End If
End Sub

'Hanfle B4XPage appearance.
Private Sub B4XPage_Appear
	'Create the object properties in the scrollpane
	CallSubDelayed(Me, "CreateObjectProperties")
	Sleep(1)
	'Load the settings from external settingsfile
	Wait for (LoadSettings) complete (result As Boolean)
	'Load the PFD if settings OK
	If result Then
		Wait for (PFDFileLoad) complete (result As Boolean)
	End If
End Sub

Private Sub B4XPage_Disappear
	DrawMode = DRAWMODE_OFF
	Wait for (SaveSettings) Complete(Result As Boolean)
End Sub

Private Sub B4XPage_CloseRequest As ResumableSub
	If PFDChanged Then
		Wait For (PFDFileSave) Complete(Result As Boolean)
	End If
	B4XPages.ClosePage(Me)
	Return True
End Sub
#End Region

#Region Settings
'Load the settings from settings file JSON format located in the dirapp folder
Private Sub LoadSettings As ResumableSub
	Dim result As Boolean
	
	B4XPages.SetTitle(Me, $"${APP_TITLE}"$)

	'Check if there is a settings file, else create new by saving the settings with defaults
	If Not(File.Exists(File.DirApp, PFDCommon.SETTINGS_FILE)) Then
		SaveSettings
	End If

	'Read the settings from the settingsfile	
	Try
		Dim settingscontent As String = File.ReadString(File.DirApp, PFDCommon.SETTINGS_FILE)
		Dim parser As JSONParser

		'Init the JSON parser for the settings content
		parser.Initialize(settingscontent)
		'Get the root json object
		Dim jRoot As Map = parser.NextObject
		
		'Get the keys from the root
		PFDFile = jRoot.Get("pfdfile")
		PFDDescription = IIf(jRoot.ContainsKey("pfddescription"), jRoot.Get("pfddescription"), "")
		PFDLastChange = IIf(jRoot.ContainsKey("pfdlastchange"), jRoot.Get("pfdlastchange"), "")
		
		'Option show grid - set selection menuitem
		ShowGrid = IIf(jRoot.ContainsKey("showgrid"), jRoot.Get("showgrid"), True)
		Dim cmi As CheckMenuItem = MenuItems.Get("ToolsShowGrid")
		cmi.Selected = ShowGrid

		'Option move step size - set menuitem which show inputdialog to set the move step size as int
		MoveStepSize = IIf(jRoot.ContainsKey("movestepsize"), jRoot.Get("movestepsize"), PFDCommon.GRID_SIZE)
		MoveStepSize = MoveStepSize

		'Option to debug = extensive logging
		Debug = IIf(jRoot.ContainsKey("debug"), jRoot.Get("debug"), False)
		Dim cmi As CheckMenuItem = MenuItems.Get("ToolsDebug")
		cmi.Selected = Debug		
		Log($"DEBUG=${Debug}"$)
		result = True
	Catch
		PFDCommon.ShowMessage(PFDCommon.MSG_TYPE_ERROR, _
							  "Load Settings", _
							  $"Can not read the settings from file ${PFDCommon.SETTINGS_FILE}.${CRLF}${LastException}"$)
		result = False
	End Try
	Return result
End Sub

'Save the settings as JSON object generated from a map.
Private Sub SaveSettings As ResumableSub
	Dim result As Boolean
	Dim jsongen As JSONGenerator

	Try
		'Check if the pfdfile exists prior writing to the settings
		'This to avoid error when loading
		If Not(File.Exists(File.DirApp, PFDFile)) Then
			PFDFile = ""
		End If
		
		'Create the settings map
		Dim m As Map = CreateMap( _
			"pfdfile":		PFDFile, _ 
			"showgrid":		ShowGrid, _ 
			"movestepsize":	MoveStepSize, _ 
			"debug":		Debug)
			
		'Init the json object with the map.
		jsongen.Initialize(m)

		'Write the JSON object to the settingsfile as pretty string
		File.WriteString(File.DirApp, PFDCommon.SETTINGS_FILE, jsongen.ToPrettyString(2))
		
		result = True
	Catch
		PFDCommon.ShowMessage(PFDCommon.MSG_TYPE_ERROR, _
		                 	  "Save Settings", _ 
							  $"Can not save the settings to file ${PFDCommon.SETTINGS_FILE}.${CRLF}${LastException}"$)
		result = False
	End Try
	Return result
End Sub
#End Region

#Region MainMenu
'Collect the menu items from the MainMenu Items list and add to a global map
'Example: CollectMenuItems(menuItems, mbMain.Menus)
Private Sub CollectMenuItems(Menus As Map, Items As List)
	For Each mi As MenuItem In Items
		If mi.Tag <> Null And mi.Tag <> "" Then Menus.Put(mi.Tag, mi)
		If mi Is Menu Then
			Dim mn As Menu = mi
			CollectMenuItems(Menus, mn.MenuItems)
		End If
	Next
End Sub

'Set menu items from the menu tag.
'The menu tag contains a 2 byte HEX string starting with 0x, like File New 0xF016.
'The HEX string is parsed and converted to a FontAwesome image assigned to a global label with format FontAwesome.
Private Sub SetMenuItemsIcon
	For Each Key As String In MenuItems.Keys
		Dim mi As MenuItem = MenuItems.Get(Key)
		Dim mitag As String = mi.tag
		If mitag.StartsWith("0x") Then
			Try
				mitag = mitag.Replace("0x", "")
				Dim mitagvalue As Int = Bit.ParseInt(mitag, 16)
				mi.Image = FontAwesomeToImageUsingLabel(Chr(mitagvalue), 16)
			Catch
				Helper.ToLog(Debug, $"[ERROR][SetMenuItemsIcon] Can not assign fontawesome icon to menu ${mi.Text} (tag=${mi.tag}), ${LastException}"$)
			End Try
		End If
	Next
End Sub

'Convert fontawesome character to an image using a label which is created with the visual designer.
'Example:
' Private Label1 As Label
' Dim img As Image = FontAwesomeToImage(Chr(0xF0AA), 16)
'This can be used to add f.e. a fontawesome icon dynamically to a menu item:
'Dim mi As MenuItem ... mi.Image = img
Private Sub FontAwesomeToImageUsingLabel(s As String, FontSize As Double) As Image
	Dim img As Image
	LabelMenuBar.Text = s
	LabelMenuBar.TextSize = FontSize
	LabelMenuBar.Visible = True
	'LabelMenuBar.Alignment = "CENTER_LEFT"
	img = LabelMenuBar.Snapshot
	LabelMenuBar.Visible = False
	Return img
End Sub

'Menu File Create a new PFD file
Private Sub FileNew_Action
	PFDFileNew
End Sub

'Menu File Open an existing PFD file
Private Sub FileOpen_Action
	PFDFileOpen
End Sub

'Menu File Save the selected PFD file
Private Sub FileSave_Action
	PFDFileSave
End Sub

'Menu File Delete the selected PFD file
Private Sub FileDelete_Action
	PFDFileDelete
End Sub

'Menu File Export the PFD to PNG
Private Sub FileExportPFDtoPNG_Action
	PFDExportPFDtoPNG
End Sub

'Menu File Export all shapes to a folder as png image
Private Sub FileExportShapestoPNG_Action
	PFDExportShapestoPNG
End Sub

'Menu File set the PFD file description.
Private Sub FilePFDDescription_Action
	PFDFileDescription
End Sub

'Menu File exit the application
Private Sub FileExit_Action
	If PFDChanged Then
		Wait For (PFDFileSave) Complete(Result As Boolean)
	End If
	B4XPages.ClosePage(Me)
End Sub

'Menu Edit copy select object
Private Sub EditCopy_Action
	CopyObject
End Sub

'Menu Edit paste copied object as new object at top right pos on the PFD Drawing Board
Private Sub EditPaste_Action
	PasteObject
	Sleep(1)
	SetDrawModeState(DRAWMODE_OBJECTS, True)
End Sub

'Menu Edit cut (remove) the selected object.
Private Sub EditCut_Action
	CutObject
End Sub

'Menu Object Select.
'Select an object.
'The dialog has a B4XListTemplate which is initially populated with a JSON string containing properties tag and descriptions.
'After the listtemplate is shown, the properties tag and description are set in the list view.
'The listview item is changed: the label text is set with tag text and an additional label is added showing the object description.
Private Sub ObjectSelect_Action
	Dim options As B4XListTemplate

	Dialog.Title = "Select Object"

	'Init the options list
	'Add the object tag & description as JSON string from the global pfdobjects
	options.Initialize
	For Each obj As TPFDObject In PFDObjects
		'Create the map with properties tag & description
		Dim m As Map = CreateMap("tag":obj.tag, "description":obj.description)
		'Add the map as JSOn string
		options.Options.Add(Helper.MapToJSON(m))
	Next
	'No multiselection
	options.AllowMultiSelection = False
	'Sort the list
	options.Options.Sort(True)
    
	'Show the listtemplate
	Dim RS As ResumableSub = Dialog.ShowTemplate(options, "OK", "", "CANCEL")

	'Loop over the listtemplate clv with text items.
	For i=0 To options.CustomListView1.Size - 1
		'Get the clv panel
		Dim v As B4XView = options.CustomListView1.GetPanel(i)
		'Check if there are views - lookig for the label
		If v.NumberOfViews > 0 Then
			'Get the first view which is a label but containing JSON string
			Dim json As String = v.GetView(0).As(Label).text
			
			'Get the label for the object tag
			Dim lbl As Label = v.GetView(0).As(Label)

'			'Change the properties
			lbl.Text = Helper.GetJSONKeyValue("tag", json)
			lbl.Alignment = "CENTER_LEFT"
			
			'Create a new label for the object description
			Dim lbldescr As Label
			lbldescr.Initialize("")
			lbldescr.Text = Helper.GetJSONKeyValue("description", json)
			lbldescr.Font = xui.CreateDefaultFont(10)
			lbldescr.Alignment = "BOTTOM_LEFT"
			lbldescr.TextColor = Helper.ColorIntToPaint(xui.Color_LightGray)

			'Add the label to the view
			v.AddView(lbldescr, lbl.left, 0, v.Width, v.height)

		End If
	Next

	'Wait for the dialog to complte
	Wait For (RS) Complete (Result As Int)
	
	'OK has been selected
	If Result = xui.DialogResponse_Positive Then
		'Get the tag from the selected item JSON string
		Dim tag As String = Helper.GetJSONKeyValue("tag", options.SelectedItem)
		
		'Find the object by its tag
		Dim obj As TPFDObject = FindObjectByTag(tag)
		
		'Set the object properties
		ObjectPropertyEventEnabled = False
		SetPFDObjectToProperties(obj)
		Sleep(5)
		ObjectPropertyEventEnabled = True
		
		'Redraw the pfd and show the position cross at the object
		PFDRedraw(obj)
	End If
End Sub

'Menu Object Add
'Select an object from the list of objects and add to the PFD drawing board.
Private Sub ObjectAdd_Action
	Dim options As B4XListTemplate

	Dialog.Title = "Add Object"

	'Init the options list and add the object shape from the global 
	options.Initialize
	options.options.AddAll(PFDShapeNames)
	'No multiselection
	options.AllowMultiSelection = False
	'Sort by name 
	'options.Options.Sort(True)
    
	'Show the dialog. 
	'If OK add the object to the pfd drawing board.
	Wait For (Dialog.ShowTemplate(options, "OK", "", "CANCEL")) Complete (Result As Int)

	'If shape selected, select the shape properties
	If Result = xui.DialogResponse_Positive Then
		SetStatusbar($"[ObjectAdd] Adding object ${options.SelectedItem}"$)
		'Loop over the pfdshapes to get the selected shape.
		For Each shape As Map In PFDShapes
			'Select shape found
			If shape.Get("pfdobject") == options.SelectedItem Then 
				'Convert the PFD shape defintion to an PFD object
				Dim obj As TPFDObject = SetPFDShapeDefinitionToObject(shape)
				
				'Add the object, set the object properties ui views and redraw.
				AddObject(obj)

				'Ensure to set drawmode to objects to move the object
				SetDrawModeState(DRAWMODE_OBJECTS, False)

				'Done
				Return
			End If
		Next
	End If
End Sub

'Menu Object Update.
'The object properties are assigned to a PFDObject.
'The index of the PFDObject is used to update the object in the global PFDObjects list.
'Then the PFD is redrawn.
Private Sub ObjectUpdate_Action
	UpdateObject(SetPFDPropertiesToObject)
End Sub

'Menu Object Remove.
'Remove single object.
Private Sub ObjectRemove_Action
	'Check if there is an object by tag entry
	If TextFieldObjTag.Text.Length == 0 Then
		SetStatusbar($"[WARNING][ObjectRemove] No object selected."$)
		Return
	End If
	
	Dim obj As TPFDObject = SetPFDPropertiesToObject
	Dim sf As Object = xui.Msgbox2Async($"Do you really want to remove object ${obj.tag} (${obj.pfdobject})?"$, "Remove Object", "Yes", "", "No", Null)
	Wait For (sf) Msgbox_Result (Result As Int)
	If Result = xui.DialogResponse_Positive Then
		RemoveObject(obj)
	End If
End Sub

'Remove selected objects (mode drawselect).
Private Sub ObjectRemoveSelected_Action
	'Check if there are objects selected
	If DrawSelectObjects.Size == 0 Then
		SetStatusbar($"[WARNING][ObjectRemoveSelected] No objects selected."$)
		Return
	End If
	
	Dim sf As Object = xui.Msgbox2Async($"Do you really want to remove the selected objects (#${DrawSelectObjects.Size})?"$, "Remove Objects Selected", "Yes", "", "No", Null)
	Wait For (sf) Msgbox_Result (Result As Int)
	If Result = xui.DialogResponse_Positive Then
		RemoveObjectsSelected
	End If
End Sub

'Menu Object Move Left, Up, Dow, Right
Private Sub ObjectMoveLeft_Action
	ToolbarObjectPropertiesMove_Click("left")
End Sub
Private Sub ObjectMoveUp_Action
	ToolbarObjectPropertiesMove_Click("up")
End Sub
Private Sub ObjectMoveDown_Action
	ToolbarObjectPropertiesMove_Click("down")
End Sub
Private Sub ObjectMoveRight_Action
	ToolbarObjectPropertiesMove_Click("right")
End Sub

'Menu Object List Operate.
'List the object which have Operate property set.
'The dialog has a B4XListTemplate which is initially populated with a JSON string containing properties tag and descriptions.
'After the listtemplate is shown, the properties tag and description are set in the list view.
'The listview item is changed: the label text is set with tag text and an additional label is added showing the object description.
Private Sub ObjectListOperate_Action
	Dim options As B4XListTemplate

	Dialog.Title = "List Operate Objects"

	'Init the options list
	'Add the object tag & description as JSON string from the global pfdobjects
	options.Initialize
	For Each obj As TPFDObject In PFDObjects
		If obj.operate Then
			'Create the map with properties tag & description
			Dim m As Map = CreateMap("tag":obj.tag, "description":obj.description)
			'Add the map as JSOn string
			options.Options.Add(Helper.MapToJSON(m))			
		End If
	Next
	'No multiselection
	options.AllowMultiSelection = False
	'Sort the list
	options.Options.Sort(True)
	
	'Check if there are operate objects
	If options.Options.Size == 0 Then
		PFDCommon.ShowMessage(PFDCommon.MSG_TYPE_INFORMATION, _
		                 	  $"List Operate Objects"$, _ 
							  $"No Objects found with Operate property set."$)		
		Return
	End If
    
	'Show the listtemplate
	Dim RS As ResumableSub = Dialog.ShowTemplate(options, "OK", "", "CANCEL")

	'Loop over the listtemplate clv with text items.
	For i=0 To options.CustomListView1.Size - 1
		'Get the clv panel
		Dim v As B4XView = options.CustomListView1.GetPanel(i)
		'Check if there are views - lookig for the label
		If v.NumberOfViews > 0 Then
			'Get the first view which is a label but containing JSON string
			Dim json As String = v.GetView(0).As(Label).text
			
			'Get the label for the object tag
			Dim lbl As Label = v.GetView(0).As(Label)

'			'Change the properties
			lbl.Text = Helper.GetJSONKeyValue("tag", json)
			lbl.Alignment = "CENTER_LEFT"
			
			'Create a new label for the object description
			Dim lbldescr As Label
			lbldescr.Initialize("")
			lbldescr.Text = Helper.GetJSONKeyValue("description", json)
			lbldescr.Font = xui.CreateDefaultFont(10)
			lbldescr.Alignment = "BOTTOM_LEFT"
			lbldescr.TextColor = Helper.ColorIntToPaint(xui.Color_LightGray)

			'Add the label to the view
			v.AddView(lbldescr, lbl.left, 0, v.Width, v.height)

		End If
	Next

	'Wait for the dialog to complte
	Wait For (RS) Complete (Result As Int)
	
	'OK has been selected
	If Result = xui.DialogResponse_Positive Then
		'Get the tag from the selected item JSON string
		Dim tag As String = Helper.GetJSONKeyValue("tag", options.SelectedItem)
		
		'Find the object by its tag
		Dim obj As TPFDObject = FindObjectByTag(tag)
		
		'Set the object properties
		ObjectPropertyEventEnabled = False
		SetPFDObjectToProperties(obj)
		Sleep(5)
		ObjectPropertyEventEnabled = True
		
		'Redraw the pfd and show the position cross at the object
		PFDRedraw(obj)
	End If
End Sub

'Menu Draw redraw the PFD from the PFD file
Private Sub DrawRefresh_Action
	SetDrawModeState(DRAWMODE_OFF, True)
End Sub

'Menu Draw erase the drawing board
Private Sub DrawErase_Action
	PFDErase
End Sub

'Menu Draw set draw mode off (only object select possible)
Private Sub DrawModeOff_Action
	SetDrawModeState(DRAWMODE_OFF, True)
End Sub

'Menu Draw set draw mode to objects (change and move objects).
Private Sub DrawModeObjects_Action
	SetDrawModeState(DRAWMODE_OBJECTS, True)
End Sub

'Menu Draw set draw mode to lines (free line drawing).
'Hor and vert lines are supported.
Private Sub DrawModeLines_Action
	SetDrawModeState(DRAWMODE_LINES, True)
End Sub

'Menu Draw set draw mode to select (select multiple shapes).
Private Sub DrawModeSelect_Action
	SetDrawModeState(DRAWMODE_SELECT, True)
End Sub

'Menu Tools show or hide the grid on the drawingboard.
Private Sub ToolsShowGrid_Action
	'Select the menuitem using the tag as defined in the menubar menu json structure
	'{Text:"_Show Grid", Tag:"ToolsShowGrid", EventName: "ToolsShowGrid", Selected: False}
	Dim cmi As CheckMenuItem = MenuItems.Get("ToolsShowGrid")
	ShowGrid = cmi.Selected

	'Redraw the PFD without object and with or without grid
	PFDRedraw(Null)
End Sub

'Menu Tools show or hide the obj tag on the drawingboard.
Private Sub ToolsShowIndex_Action
	'Select the menuitem using the tag as defined in the menubar menu json structure
	'{Text:"_Show Index", Tag:"ToolsShowIndex", EventName: "ToolsShowIndex", Selected: False}
	Dim cmi As CheckMenuItem = MenuItems.Get("ToolsShowIndex")
	ShowIndex = cmi.Selected

	If ShowIndex Then
		PFDCommon.DrawIndex(Canvas, PFDObjects)
		Canvas.Invalidate
	Else
		'Redraw the PFD without object and with or without grid
		PFDRedraw(Null)
	End If
End Sub

'Menu Tools move step size
'{Text:"_Move Step Size", Tag:"ToolsMoveStepSize", EventName: "ToolsMoveStepSize"}
Private Sub ToolsMoveStepSize_Action
	Dim title As String		= $"Set Move Step Size"$
	Dim subtitle As String	= $"Current: #${MoveStepSize}"$
	Dim hint As String		= $"Step range between 1 and 20."$

	'Create and set layout for the custom view panel
	Dim p As B4XView = xui.CreatePanel("")
	p.SetLayoutAnimated(0, 0, 0, 300dip, 180dip)
	p.LoadLayout("PlusMinusDialog")

	'Set Dialog properties
	'Titlebar text
	Dialog.Title = title
	'Do not put the dialog at the top of the screen
	Dialog.PutAtTop = False

	'SubTitle text
	DesignerUtils.GetViewByName(p, "LabelSubTitle").Text = subtitle
	'Hint text
	DesignerUtils.GetViewByName(p, "LabelHint").Text = hint
	'DesignerUtils.GetViewByName(p, "LabelHint").Textsize = 8

	'Set plusminus range
	B4XPlusMinusField.SetNumericRange(1, 20, 1)
	'Set prevalue
	B4XPlusMinusField.SelectedValue = MoveStepSize

	'Open the dialog and wait for the result pos or neg
	Wait For (Dialog.ShowCustom(p, "OK", "", "CANCEL")) Complete (Result As Int)
	'Handle dialog result
	If Result = xui.DialogResponse_Positive Then
		'No need to check with IsNumber
		MoveStepSize = B4XPlusMinusField.SelectedValue
		'Show statusbar
		SetStatusbar($"Move Step Size changed to ${MoveStepSize}."$)
	End If

End Sub

'Menu Tools PFDBackgroundColor dialog
Private Sub ToolsPFDBackgroundColor_Action
	Dim title As String		= $"Select PFD Background Color"$
	Dim subtitle As String	= $"Current: #${Helper.ColorIntToHexRGB(PFDBackgroundColor).ToLowerCase}"$
	Dim hint As String		= $"ISA-101 ARGB recommendation: Light Gray 224 #ffe0e0e0 (R224,G224,B224) or Silver 192 #ffc0c0c0 (R192,R192,R192)."$

	'Open the dialog and wait for completion buttons OK or Cancel
	Wait for (ColorPickerDialog(title, subtitle, hint, PFDBackgroundColor)) complete (selectedcolor As Int)

	'New color selected then assign to the global, redraw the pfd with new background color and change pfd change state to true
	If selectedcolor <> 0 Then
		PFDBackgroundColor = selectedcolor
		PFDRedraw(Null)
		SetPFDChangedState(True)
		'Show statusbar
		SetStatusbar($"PFD Background Color changed to #${Helper.ColorIntToHexARGB(PFDBackgroundColor)}."$)
	End If
End Sub

#Region COLORPICKERDIALOG
'Show a color picker custom dialog using the view colorpicker.
'title - Dialog titlebar text
'subtitle - Optional text below the titlebar
'hint - Optional hint at bottom of the dialog
'color - Preselected color as int
'Return selected color as int or 0 if no color selected (cancel)
Private Sub ColorPickerDialog(title As String, subtitle As String, hint As String, color As Int) As ResumableSub
	'Create & init the panel for the dialog
	Dim p As B4XView = xui.CreatePanel("")
	p.SetLayoutAnimated(0, 0, 0, 300dip, 180dip)
	p.LoadLayout("ColorPickerDialog")

	'Set Dialog properties
	'Titlebar text
	Dialog.Title = title
	'Do not put the dialog at the top of the screen
	Dialog.PutAtTop = False

	'SubTitle text
	DesignerUtils.GetViewByName(p, "LabelSubTitle").Text = subtitle
	'Hint text
	DesignerUtils.GetViewByName(p, "LabelHint").Text = hint
	'DesignerUtils.GetViewByName(p, "LabelHint").Textsize = 8

	'Set color as colorpicker selected
	ColorPickerDialogColor.SelectedColor = Helper.ColorIntToPaint(color)

	'Open the dialog and wait for the result pos or neg
	Wait For (Dialog.ShowCustom(p, "OK", "", "CANCEL")) Complete (Result As Int)

	'Handle dialog result
	If Result = xui.DialogResponse_Positive Then
		Return Helper.ColorPaintToInt(ColorPickerDialogColor.SelectedColor)
	Else
		Return 0
	End If

End Sub
#End Region

'Create B4XCode method (sub) from the select area containing one or more objects.
'The created code is shown in a custom dialog with a BBCodeView and can be copied to the clipboard.
Private Sub ToolsSelectToCode_Action
	Dim input As B4XInputTemplate
	Dim shapename As String = "MyShape"
	Dim b4xcode As String

	'Option to use selected object from select area
	'Check if there are objects selected
	If DrawSelectObjects.Size == 0 Then
		PFDCommon.ShowMessage(PFDCommon.MSG_TYPE_WARNING, _
		                 	  "Select to Code", _ 
							  $"No objects selected.${CRLF}${CRLF}Action: Select one or more objects to create B4X draw method code."$)
		Return
	End If
		
	'Dialog to get the shapename used for the draw method
	Dialog.Title = $"Select to Code Set Shape Name"$
	'Init the input field holding the shapename
	input.Initialize
	input.lblTitle.Text = "Enter name:"
	input.Text = shapename
	input.TextField1.EditTextHint = "Set unique shape name in CamelCase."
	input.RegexPattern = ".+" 'require at least one character
	
	'Show the PFD input dialog
	Wait For (Dialog.ShowTemplate(input, "OK", "", "CANCEL")) Complete (Result As Int)

	'Handle dialog response
	If Result = xui.DialogResponse_Cancel Then Return

	'Set shapename from textinput
	shapename = input.Text

	'Create the code from the objects selected
	b4xcode = PFD.SelectToCode(shapename, PFDShapes, DrawSelectObjects, DrawSelectObjectsRect)
	
	'Option to use all pfd objects
	'b4xcode = PFD.ExportPFDToB4XDrawMethod(shapename, PFDShapes, PFDObjects)

	'Create the dialog to view the code created
	Dim p As B4XView = xui.CreatePanel("")
	p.SetLayoutAnimated(0, 0, 0, 600dip, 500dip)
	p.LoadLayout("SelectToCodeDialog")
	p.Color = xui.Color_White
	
	'BBCode
	TextEngine.Initialize(p)
	BBCodeViewSelectToCode.TextEngine = TextEngine
	BBCodeViewSelectToCode.Text = b4xcode

	'Dialog properties
	Dialog.Title = "Select to Code"
	'Do not put the dialog at the top of the screen
	Dialog.PutAtTop = False

	'Show the help dialog
	Dim rs As ResumableSub = Dialog.ShowCustom(p, "OK", "", "COPY")
	'And wait for completion
	Wait For (rs) Complete (Result As Int)
	If Result = xui.DialogResponse_Cancel Then
		'No action = Not Required
		Helper.CopyStringToClipboard(BBCodeViewSelectToCode.Text)
	End If
End Sub

'Menu Tools flag to set debug (= extensive logging).
Private Sub ToolsDebug_Action
	'Select the menuitem using the tag as defined in the menubar menu json structure
	'{Text:"_Debug", Tag:"ToolsDebug", EventName: "ToolsDebug", Selected: False}
	Dim cmi As CheckMenuItem = MenuItems.Get("ToolsDebug")
	Debug = cmi.Selected
End Sub

'Menu Help show help dialog with bbcodeview and textengine
Private Sub HelpHelp_Action
	Dim p As B4XView = xui.CreatePanel("")

	p.SetLayoutAnimated(0, 0, 100dip, 900dip, 700dip)
	p.LoadLayout("InformationDialog")
	p.Color = xui.Color_White
	
	'Init the textengine with the new created panel
	TextEngine.Initialize(p)
	
	'Add additional fonts
	'italic - used like $"This is an [font=italic]italic[/font] font. Italic font with [font=italic size=30]size 30[/font]"$
	TextEngine.CustomFonts.Put("italic",xui.CreateFont(fx.CreateFont("System", 10, False, True), 10))
	
	'BBCodeView assign the textengine and set the text from the external helpfile located in the dirapp folder
	BBCodeViewInformation.TextEngine = TextEngine
	BBCodeViewInformation.Text = File.ReadString(File.DirApp, PFDCommon.HELP_FILE)

	'Dialog properties
	Dialog.Title = $"Help ${APP_TITLE}"$
	'Do not put the dialog at the top of the screen
	Dialog.PutAtTop = False

	'Show the dialog
	Dim rs As ResumableSub = Dialog.ShowCustom(p, "OK", "", "")
	'Wait till closed which returns always positive
	Wait For (rs) Complete (Result As Int)
	If Result = xui.DialogResponse_Positive Then
		'No action = Not Required
	End If
End Sub

'Menu Help show about info
Private Sub HelpAbout_Action
	Dim p As B4XView = xui.CreatePanel("")
	Dim sb As StringBuilder

	'Set the text using the stringbuilder
	sb.Initialize
	sb.Append($"[b]${APP_TITLE}[/b]${CRLF}"$)
	sb.Append($"${APP_COPYRIGHT}"$)
	sb.Append($"${APP_CREATED}"$)
	sb.Append($"${APP_CREDITS}"$)
	sb.Append($"${APP_LICENSE}"$)
	
	p.SetLayoutAnimated(0, 0, 0, 450dip, 400dip)
	p.LoadLayout("InformationDialog")
	p.Color = xui.Color_White
	
	'Textengine and BBCodeView with underlined urls (see sub BBCodeViewInformation_linkclicked)
	TextEngine.Initialize(p)
	BBCodeViewInformation.TextEngine = TextEngine
	BBCodeViewInformation.Text = sb.ToString
	BBCodeViewInformation.AutoUnderlineURLs = True
	Dim sp As ScrollPane = BBCodeViewInformation.sv
	sp.SetVScrollVisibility("ALWAYS")

	'Dialog properties
	Dialog.Title = "About"
	'Do not put the dialog at the top of the screen
	Dialog.PutAtTop = False

	'Show the dialog
	Dim rs As ResumableSub = Dialog.ShowCustom(p, "OK", "", "")
	'Wait till closed which returns always positive
	Wait For (rs) Complete (Result As Int)
	If Result = xui.DialogResponse_Positive Then
		'No action = Not Required
	End If
End Sub

'Open the link of the BBCodeViewInformation url.
Private Sub BBCodeViewInformation_LinkClicked(url As String)
	Try
		fx.ShowExternalDocument(url)		
	Catch
		PFDCommon.ShowMessage(PFDCommon.MSG_TYPE_ERROR, _
		                 	  "Help Open Link", _ 
							  $"Can not open the external link ${url}.${CRLF}${LastException}"$)
	End Try
End Sub
#End Region

#Region KeyManagement
'Key filter event handling key code F1
Private Sub Key_Filter (EventData As Event)
	Dim joEvent As JavaObject = EventData
	Dim keycode As String = joEvent.RunMethod("getCode", Null)
	
	'If now know what the keycode is, then log which shows a string
	'Log(keycode)
	If keycode == "CONTROL" Then
		KeyCtrl = True
	End If
	If keycode == "O" And KeyCtrl Then
		FileOpen_Action
		KeyCtrl = False
		EventData.Consume
	End If
	If keycode == "S" And KeyCtrl Then
		FileSave_Action
		KeyCtrl = False
		EventData.Consume
	End If

	If keycode == "C" And KeyCtrl Then
		EditCopy_Action
		KeyCtrl = False
		EventData.Consume
	End If
	If keycode == "P" And KeyCtrl Then
		EditPaste_Action
		KeyCtrl = False
		EventData.Consume
	End If
	If keycode == "X" And KeyCtrl Then
		EditCut_Action
		KeyCtrl = False
		EventData.Consume
	End If

	If keycode == "LEFT" Then
		ObjectMoveLeft_Action
		KeyCtrl = False
		EventData.Consume
	End If
	If keycode == "UP" Then
		ObjectMoveUp_Action
		KeyCtrl = False
		EventData.Consume
	End If
	If keycode == "DOWN" Then
		ObjectMoveDown_Action
		KeyCtrl = False
		EventData.Consume
	End If
	If keycode == "RIGHT" Then
		ObjectMoveRight_Action
		KeyCtrl = False
		EventData.Consume
	End If
	If keycode == "DELETE" Then
		ObjectRemove_Action
		KeyCtrl = False
		EventData.Consume
	End If

	If keycode == "F1" Then
		HelpHelp_Action
		KeyCtrl = False
		EventData.Consume
	End If
	If keycode == "F5" Then
		DrawModeOff_Action
		KeyCtrl = False
		EventData.Consume
	End If
	If keycode == "F6" Then
		DrawModeObjects_Action
		KeyCtrl = False
		EventData.Consume
	End If
	If keycode == "F7" Then
		DrawModeLines_Action
		KeyCtrl = False
		EventData.Consume
	End If
	If keycode == "F8" Then
		DrawModeSelect_Action
		KeyCtrl = False
		EventData.Consume
	End If
End Sub
#End Region

#Region Toolbars
'Handle click of a toolbar label
'Label tag is an array object with 3 entries: Layoutmodule (map), eventname (string), tag (string)
'The label tag is assigned to an array object from which the entry with index 2 is assigned to string.
Private Sub ToolbarTop_Click (tag As String)
	'Select the toolbar tag (from left to right)
	Select tag
		Case "exit"
			FileExit_Action
		Case "new"
			'Create new PFD file
			PFDFileNew
		Case "open"
			'Open existing PFD file
			PFDFileOpen
		Case "save"
			'Save the selected PFD file
			PFDFileQuickSave
			'PFDFileSave
		Case "delete"
			'Delete the selected PFD file
			PFDFileDelete
		Case "erase"
			'Erase the drawing board
			PFDErase
		Case "redraw"
			'Redraw the PFD from the PFD file
			SetDrawModeState(DRAWMODE_OFF, True)
			SetStatusbar($"PFD redrawed."$)
		Case "help"
			'Show the help dialog
			HelpHelp_Action
		End Select
End Sub

'Select the toolbar tag (from left to right) to add, update or remove the selected object.
Private Sub ToolbarObjectProperties_Click (tag As String)
	Select tag
		Case "add"
			ObjectAdd_Action
		Case "update"
			UpdateObject(SetPFDPropertiesToObject)
		Case "remove"
			ObjectRemove_Action
		Case "select"
			ObjectSelect_Action
	End Select
End Sub

'Move the objects or objects using arrow keys - see next sub ToolbarObjectPropertiesMove_Click
Private Sub ToolbarObjectPropertiesMove(direction As String)
	Helper.ToLog(Debug, $"[ToolbarObjectPropertiesMove] direction=${direction}"$)
	Select DrawMode
		Case DRAWMODE_OFF
			MoveObject(DraggingObj, direction)
		Case DRAWMODE_OBJECTS
			MoveObject(DraggingObj, direction)
		Case DRAWMODE_SELECT
			MoveObjects(direction)
	End Select
End Sub

'Move selected object(s) left-up-down-right from drawmodes off, objects, select.
Private Sub ToolbarObjectPropertiesMove_Click (tag As String)
	'If DrawMode == DRAWMODE_OFF Then Return
	'Check arrow key tag holding the direction
	If tag == Null Then Return
	Helper.ToLog(Debug, $"[ToolbarObjectPropertiesMove_Click] tag=${tag}, drawmode=${DrawMode}"$)

	'Select the toolbar tag (from left to right)
	Select tag
		Case "left"
			ToolbarObjectPropertiesMove(PFDCommon.DIRECTION_LEFT)
		Case "up"
			ToolbarObjectPropertiesMove(PFDCommon.DIRECTION_UP)
		Case "down"
			ToolbarObjectPropertiesMove(PFDCommon.DIRECTION_DOWN)
		Case "right"
			ToolbarObjectPropertiesMove(PFDCommon.DIRECTION_RIGHT)
	End Select
End Sub

'Select the drawmode from the toolbardrawmode
Private Sub ToolbarDrawMode_Click (tag As String)
	'Select the toolbar tag (from left to right)
	Select tag.ToLowerCase
		Case "off"
			SetDrawModeState(DRAWMODE_OFF, True)
		Case "objects"
			SetDrawModeState(DRAWMODE_OBJECTS, True)
		Case "lines"
			SetDrawModeState(DRAWMODE_LINES, True)
		Case "select"
			SetDrawModeState(DRAWMODE_SELECT, True)
	End Select
End Sub
#End Region

#Region Statusbar
Private Sub SetStatusbar(text As String)
	LabelStatusbar.Text = text
	If Debug Then Log(text)
End Sub

'Set the draw mode.
Private Sub SetDrawModeState(state As Int, redraw As Boolean)
	Dim prefix As String = $"Draw Mode"$
	Dim suffix As String = ""

	DrawMode = state
	Select DrawMode
		Case DRAWMODE_OFF
			suffix = "Off"
		Case DRAWMODE_OBJECTS
			suffix = "Objects"
		Case DRAWMODE_LINES
			suffix = "Lines"
		Case DRAWMODE_SELECT
			suffix = "Select"
	End Select
	
	'LabelPFDDrawMode.Text = $"${prefix}${CRLF}${suffix}"$
	LabelDrawMode.Text = $"${prefix} ${suffix}"$
	
	'Redraw if option set
	If redraw Then
		PFDRedraw(Null)
	End If
End Sub

Private Sub SetPFDChangedState(state As Boolean)
	PFDChanged = state
	LabelPFDChanged.Text = $"PFD Changed${CRLF}${Helper.StateToYesNo(state)}"$
End Sub

Private Sub SetPFDCanvasPosition(x As Float, y As Float)
	LabelCanvasTouchpositionShort.Text = $"X:${Helper.SetNumberFormatNoDecimal(X)}${CRLF}Y:${Helper.SetNumberFormatNoDecimal(Y)}"$
End Sub

'Update the object size labels shown on the mainpage bottom right.
Private Sub SetPFDObjectSize(obj As TPFDObject)
	LabelObjectPropertiesSizeTop.Text =		$"Top${CRLF}${Helper.SetNumberFormatNoDecimal(obj.centery - (obj.height/2))}"$
	LabelObjectPropertiesSizeLeft.Text =	$"Left${CRLF}${Helper.SetNumberFormatNoDecimal(obj.centerx - (obj.width/2))}"$
	LabelObjectPropertiesSizeBottom.Text =	$"Bottom${CRLF}${Helper.SetNumberFormatNoDecimal(obj.centery + (obj.height/2))}"$
	LabelObjectPropertiesSizeRight.Text =	$"Right${CRLF}${Helper.SetNumberFormatNoDecimal(obj.centerx + (obj.width/2))}"$
End Sub
#End Region

#Region PFDFile
'Create a new PFDFile.
'There are two dialogs:
'1 = select the PFD Type, like pip or flowchart.
'2 = set the PFD definition file name.
Private Sub PFDFileNew As ResumableSub
	Dim input As B4XInputTemplate
	Dim filename As String

	'Go for sure and save the current PFD
	If PFDChanged Then
		Wait For (PFDFileSave) Complete(ResultFileSave As Boolean)
	End If

	'Set PFD Definition File Name
	Dialog.Title = $"Set PFD Filename"$
	'Init the input field holding the PFD filename
	input.Initialize
	input.lblTitle.Text = "Enter Filename (with extension .pfd):"
	input.Text = $"new.pfd"$
	input.TextField1.EditTextHint = "Enter unique PFD file name (lowercase)."
	input.RegexPattern = ".+" 'require at least one character
	
	'Show the PFD filename input dialog
	Wait For (Dialog.ShowTemplate(input, "OK", "", "CANCEL")) Complete (Result As Int)
	'Handle dialog response
	If Result = xui.DialogResponse_Positive Then
		'Set filename to lowercase
		filename = input.Text.ToLowerCase
		
		'Check file extension
		If Not(filename.Contains(".pfd")) Then filename = $"${filename}.pfd"$
		
		'Check if the PFD file already exists
		If File.Exists(File.DirApp, filename) Then
			PFDCommon.ShowMessage(PFDCommon.MSG_TYPE_WARNING, _
		                 	      "PFD File New", _ 
							      $"This PFD file ${filename} already exists. Reenter with unique PFD name."$)
			Return False
		Else
			PFDFile = filename
			PFDDescription = ""
			PFDObjects.Clear
			CustomListViewObjects_Clear
			SetDrawModeState(DRAWMODE_OFF, True)
			SetPFDChangedState(True)
			B4XPages.SetTitle(Me, $"${APP_TITLE} - ${PFDFile}"$)
			SetStatusbar($"New PFD file ${filename} created."$)
			Return True
		End If
	Else
		Return False
	End If
End Sub

'Open PFD file dialog.
Private Sub PFDFileOpen As ResumableSub
	Dim options As B4XListTemplate

	'Go for sure and save the current PFD
	If PFDChanged Then
		Wait For (PFDFileSave) Complete(ResultFileSave As Boolean)
	End If

	Dialog.Title = "Open PFD File"
	options.Initialize
	
	Wait For (File.ListFilesAsync(File.DirApp)) Complete (Success As Boolean, files As List)
	If Success Then
		For Each f As String In files
			If f.Contains(".pfd") Then
				options.Options.Add(f)
			End If
		Next
		'No multiselection
		options.AllowMultiSelection = False
		'Sort by filename
		options.Options.Sort(True)
    
		'Show the dialog. If OK set the object selected properties
		Wait For (Dialog.ShowTemplate(options, "OK", "", "CANCEL")) Complete (Result As Int)

		'Check the dialog result is ok
		If Result = xui.DialogResponse_Positive Then
			PFDFile = options.SelectedItem
			PFDFileLoad
			B4XPages.SetTitle(Me, $"${APP_TITLE} - ${PFDFile}"$)
		End If
		Return True
	Else
		Return False
	End If
End Sub

'Draw the objects from PFD definition file on the PFD Drawing Board (=canvas).
'The PFD definition file has json format.
Private Sub PFDFileLoad As ResumableSub
	Dim result As Boolean
	'Hold the jsoncontent
	Dim pfdfilecontent As String
	Dim parser As JSONParser

	'Check if there is a PFDFile (setting key pfdfile)
	If PFDFile.Length == 0 Then
		SetStatusbar("Can not load PFD file, because no PFD filename defined.")
		'PFDCommon.ShowMessage(PFDCommon.MSG_TYPE_WARNING, "PFD File Load", "No PFD file defined.")
		Return False
	End If

	'Open the PFD definition file using try..catch in case file not found or no content			
	Try
		'Read the content of the PFD definition file
		pfdfilecontent = File.ReadString(File.DirApp, PFDFile)
		
		'Init the JSON parser with the content
		parser.Initialize(pfdfilecontent)

		'Get the next object to get the globals and the objects
		Dim jRoot As Map = parser.NextObject

		PFDDescription = IIf(jRoot.ContainsKey("pfddescription"), jRoot.Get("pfddescription"), "")
		PFDLastChange = IIf(jRoot.ContainsKey("pfdlastchange"), jRoot.Get("pfdlastchange"), "")
		PFDBackgroundColor = IIf(jRoot.ContainsKey("pfdbackgroundcolor"), _ 
						         Helper.ColorHexToInt(jRoot.Get("pfdbackgroundcolor")), _
								 Helper.ColorHexToInt(PFDCommon.COLOR_ISA101_WHITE))

		'Get the PFD objects from the JSON array and assign to the global list
		PFDObjects = PFD.GetObjectsFromPFDDefinition(jRoot.Get("objects"))
	
		'Reindex the objects
		ReindexObjects
			
		'Load the PFD objects list in the customlistview
		Wait for (CustomListViewObjects_Load) complete (resultobjects As Boolean)

		'Draw the PFD in drawmode off
		SetDrawModeState(DRAWMODE_OFF, True)

		'Set PFD changed state to false
		SetPFDChangedState(False)
		result = True
	Catch
		PFDCommon.ShowMessage(PFDCommon.MSG_TYPE_ERROR, _
		                 	  "PFD File Load", _ 
							  $"Can not load the PFD definition file "${PFDFile}"${CRLF}${LastException}"$)
		result = False
	End Try

	Return result
End Sub

'Save PFD file dialog
Private Sub PFDFileSave As ResumableSub
	Dim input As B4XInputTemplate
	Dim filename As String = PFDFile
	Dim dialogtitle As String = "Save PFD File"

	'Set dialog title
	Dialog.Title = dialogtitle

	'Init the input field holding the PFD filename
	input.Initialize
	input.lblTitle.Text = "Enter Filename (with extension .pfd):"
	input.Text = filename
	input.TextField1.EditTextHint = "Enter unique PFD file name (lowercase)."
	input.RegexPattern = ".+" 'require at least one character
	
	'Show the pfd filename input dialog
	Wait For (Dialog.ShowTemplate(input, "Yes", "No", "")) Complete (Result As Int)
	'Handle dialog response
	If Result = xui.DialogResponse_Positive Then
		'Set filename to lowercase
		filename = input.Text.ToLowerCase
		
		'Check file extension
		If Not(filename.Contains(".pfd")) Then filename = $"${filename}.pfd"$

'		'Check if the PFD file already exists
'		If File.Exists(File.DirApp, filename) Then
'			xui.Msgbox2Async($"[ERROR] This PFD file ${filename} already exists. Reenter with unique PFD name."$, dialogtitle, "OK", "", "", Null)
'		End If

		SetPFDChangedState(False)
		PFDFile = filename
		PFDLastChange = Helper.GetDateTime
		PFD.SaveToFile(PFDFile, PFDObjects, PFDDescription, PFDLastChange, PFDBackgroundColor)
		B4XPages.SetTitle(Me, $"${APP_TITLE} - ${PFDFile}"$)
		SetStatusbar($"PFD file ${PFDFile} saved."$)
		Return True
	Else
		Return False
	End If
End Sub

'NOT USED
'Dialog without filename input field.
Private Sub PFDFileSave2	'ignore
	'Check if the PFD file has changed
	If PFDChanged Then
		Dim sf As Object = xui.Msgbox2Async($"Save the PFD to ${PFDFile}?"$, "Save PFD File", "Yes", "", "No", Null)
		Wait For (sf) Msgbox_Result (Result As Int)
		If Result = xui.DialogResponse_Positive Then
			PFDLastChange = Helper.GetDateTime
			PFD.SaveToFile(PFDFile, PFDObjects, PFDDescription, PFDLastChange, PFDBackgroundColor)
			SetPFDChangedState(False)
			SetStatusbar($"PFD file ${PFDFile} saved."$)
		End If
	End If
End Sub

'Save the current file without dialog.
Private Sub PFDFileQuickSave
	'Check if the PFD file has changed
	If PFDChanged Then
		PFDLastChange = Helper.GetDateTime
		PFD.SaveToFile(PFDFile, PFDObjects, PFDDescription, PFDLastChange, PFDBackgroundColor)
		SetPFDChangedState(False)
		SetStatusbar($"PFD file ${PFDFile} saved."$)
	End If
End Sub

'Delete the selected PFD file, set change state false & redraw the PFD
Private Sub PFDFileDelete
	Dim sf As Object = xui.Msgbox2Async($"Do you really want to delete the PFD ${PFDFile}?"$, "PFD File Delete", "Yes", "", "No", Null)
	Wait For (sf) Msgbox_Result (Result As Int)
	If Result = xui.DialogResponse_Positive Then
		'Delete the file
		Try
			File.Delete(File.dirapp, PFDFile)
			'Clear and reset the properties
			ResetPFDObjectProperties
			'Clear the PFD globals
			PFDFile = ""
			PFDDescription = ""
			'Remove all objects from the objectslist
			PFDObjects.Clear
			'Draw an empty PFD Drawing Board
			PFDRedraw(Null)
			'PFD reset changed flag
			SetPFDChangedState(False)
			'PFD reset drawmode to off
			SetDrawModeState(DRAWMODE_OFF, True)
			'Update title and statusbar
			B4XPages.SetTitle(Me, $"${APP_TITLE} - No PFD File"$)
			SetStatusbar($"PFD file ${PFDFile} deleted."$)
		Catch
			PFDCommon.ShowMessage(PFDCommon.MSG_TYPE_ERROR, _
		                 	  "PFD File Delete", _ 
							  $"Can not delete the PFD file "${PFDFile}"${CRLF}${LastException}"$)
			SetStatusbar($"[ERROR][PFDFileDelete] PFD file ${PFDFile} not deleted."$)
			Return
		End Try
	End If
End Sub

Private Sub PFDExportPFDtoPNG
	PFD.ExportPFDToPNG(PFDFile)
End Sub

Private Sub PFDExportShapestoPNG
	PFD.ExportShapesToPNG(PFDShapes, PFDCommon.IMAGES_FOLDER)
End Sub

'Set a description for the selected PFD file
Private Sub PFDFileDescription
	Dim input As B4XInputTemplate

	'Set PFD file description
	Dialog.Title = $"Set PFD Description"$
	'Init the input field holding the PFD description
	input.Initialize
	input.lblTitle.Text = "Enter:"
	input.Text = $"${PFDDescription}"$
	input.TextField1.EditTextHint = "Enter short PFD description."
	
	'Show the PFD input dialog
	Wait For (Dialog.ShowTemplate(input, "OK", "", "CANCEL")) Complete (Result As Int)
	'Handle dialog response
	If Result = xui.DialogResponse_Positive Then
		PFDDescription = input.Text
		SetPFDChangedState(True)
	End If
End Sub
#End Region

#Region PFDDrawingBoard
'Redraw the pfd.
Private Sub PFDRedraw(obj As TPFDObject)
	
	PFD.ReDraw(PFDObjects, ShowGrid, PFDBackgroundColor)

	If DrawMode = DRAWMODE_OFF Then
		'If there is an object, show the object selected (blue rectangle).
		If Not(obj == Null) Then
			PFDCommon.DrawObjectSelected(Canvas, obj)
		End If
	End If

	If DrawMode = DRAWMODE_OBJECTS Then
		'If there is an object, show the gridcross at obj pos if option set
		'Else show object selected only (blue rectangle).
		If Not(obj == Null) Then
			PFDCommon.DrawObjectSelected(Canvas, obj)
			If ShowGrid Then
				PFDCommon.DrawGridCross(Canvas, obj.centerx, obj.centery, Canvas.TargetView.Width, Canvas.TargetView.Height)
			End If			
		End If
	End If
	
	'Show the object indices if flag is set.
	If ShowIndex Then
		PFDCommon.DrawIndex(Canvas, PFDObjects)
	End If

	SetStatusbar($"PFD redrawn."$)
End Sub

'Erase the pfd.
Private Sub PFDErase
	Dim sf As Object = xui.Msgbox2Async($"Do you really want to erase the PFD?"$, "Erase PFD", "Yes", "", "No", Null)
	Wait For (sf) Msgbox_Result (Result As Int)
	If Result = xui.DialogResponse_Positive Then
		'Clear the objects list
		PFDObjects.Clear
		'Clear the clv
		CustomListViewObjects.Clear
		'Reset the objects label
		LabelObjects.Text = $"Objects #${PFDObjects.size}"$
		'Redraw the PFD
		PFD.ReDraw(PFDObjects, ShowGrid, PFDBackgroundColor)
		'Change the state
		SetPFDChangedState(True)
		SetStatusbar($"PFD erased."$)
	End If
End Sub
#End Region

#Region PFDObjects
'Reindex the list of objects starting with 0 till objects.size - 1.
Private Sub ReindexObjects
	Dim index As Int
	For index = 0 To PFDObjects.Size - 1
		Dim obj As TPFDObject = PFDObjects.Get(index)
		obj.index = index
		PFDObjects.Set(index, obj)
	Next
	Helper.ToLog(debug, $"[ReindexObjects] size=${PFDObjects.size}"$)
End Sub

'Add a new object from the object properties.
'Example: AddObject(SetPFDPropertiesToObject)
Private Sub AddObject(obj As TPFDObject)
	'Check if there is an object
	If obj == Null Then
		SetStatusbar($"[ERROR][AddObject] No object selected."$)
		Return
	End If
	If Not(obj.IsInitialized) Then
		SetStatusbar($"[ERROR][AddObject] Object is not initialized."$)
		Return
	End If

	'Set x1,y1,x2,y2
	obj.x1 = obj.centerx - (obj.width/2)
	obj.y1 = obj.centery - (obj.height/2)
	obj.x2 = obj.centerx + (obj.width/2)
	obj.y2 = obj.centery + (obj.height/2)

	'Add the new object to the list
	PFDObjects.Add(obj)

	'Reindex the list of objects
	ReindexObjects
	
	'Update the object properties ui views
	ObjectPropertyEventEnabled = False
	SetPFDObjectToProperties(obj)
	Sleep(5)
	ObjectPropertyEventEnabled = True

	'Rebuild the the objects listview
	CustomListViewObjects_Load

	'Sleep(1)

	'Redraw the PFD drawing board
	PFDRedraw(obj)

	'Indicate pfd has changed
	SetPFDChangedState(True)

	SetStatusbar($"[AddObject] type=${obj.pfdobject}, tag=${obj.tag}, index=${obj.index}, x/y=${obj.centerx}/${obj.centery}"$)
End Sub

'Add a new solid line object.
'The line is created from the positions start x1,y1 and end x2,y2.
'Supported are horizontal (x1<>x2, y1=y2) and vertical lines (x1=x2, y1<>y2).
'TODO: Add support for diagonal lines.
Private Sub AddObjectLine(x1 As Int, y1 As Int, x2 As Int, y2 As Int)
	Dim obj As TPFDObject

	SetStatusbar($"[AddObjectLine]${x1},${y1},${x2},${y2}"$)

	'Init the object type and set the members
	obj.Initialize
	obj.pfdobject	= PFDShapesBasic.BASIC_SHAPE_LINE_SOLID
	obj.tag 		= "LS-NNNN"
	obj.description	= "Line Solid"
	obj.value 		= ""
	obj.unit 		= ""
	obj.image 		= ""
	obj.index 		= 0
	obj.strokewidth	= PFDCommon.LINE_SOLID_STROKE_WIDTH
	obj.fillcolor 	= PFDCommon.LINE_SOLID_COLOR

	'Ensure object centerx,y snap to grid
	obj.centerx 	= Round(obj.centerx / PFDCommon.GRID_SIZE) * PFDCommon.GRID_SIZE
	obj.centery 	= Round(obj.centery / PFDCommon.GRID_SIZE) * PFDCommon.GRID_SIZE

	'Check direction first!
	obj.arrow = PFDCommon.DIRECTION_NONE
	'If obj.w < obj.h Then obj.direction = PFD.DIRECTION_VERTICAL
	obj.direction = PFDCommon.DIRECTION_NONE

	Dim direction As String
	'Vertical = Check if x2 in range (x1 - PFDCommon.GRID_SIZE) and (x1 + PFDCommon.GRID_SIZE)
	If Helper.InRange(x2, x1 - PFDCommon.GRID_SIZE, x1 + PFDCommon.GRID_SIZE) Then
		direction = PFDCommon.DIRECTION_VERTICAL
		x2 = x1
	End If
	
	'Horizontal = Check if xy in range (y1 - PFDCommon.GRID_SIZE) and (y1 + PFDCommon.GRID_SIZE)
	If Helper.InRange(y2, y1 - PFDCommon.GRID_SIZE, y1 + PFDCommon.GRID_SIZE) Then
		direction = PFDCommon.DIRECTION_HORIZONTAL
		y2 = y1
	End If
	Helper.ToLog(Debug, $"[AddObjectLine]direction=${direction}"$)

'	If y1 == y2 Then
	If direction == PFDCommon.DIRECTION_HORIZONTAL Then
		obj.direction = PFDCommon.DIRECTION_HORIZONTAL
		obj.width = Abs(x2 - x1)
		obj.width = Round(obj.width / PFDCommon.GRID_SIZE) * PFDCommon.GRID_SIZE
		obj.height = obj.strokewidth
		If x1 > x2 Then
			obj.centerx = x2 + (obj.width / 2)
		Else
			obj.centerx = x1 + (obj.width / 2)
		End If
		obj.centery = y1 + (obj.height / 2)
		'Add the new line to the objects
		AddObject(obj)
	End If

'	If x1 == x2  Then
	If direction == PFDCommon.DIRECTION_VERTICAL Then
		obj.direction = PFDCommon.DIRECTION_VERTICAL
		obj.width = obj.strokewidth
		obj.centerx = x1 + (obj.width / 2)
		obj.height = Abs(y2 - y1)
		obj.height = Round(obj.height / PFDCommon.GRID_SIZE) * PFDCommon.GRID_SIZE
		If y1 > y2 Then
			obj.centery = y2 + (obj.height / 2)
		Else
			obj.centery = y2 - (obj.height / 2)
		End If
		'Add the new line to the objects
		AddObject(obj)
	End If
End Sub

'Update an object in the objects list by selecting the object unique index.
'If the object index is found in the list, the object is replaced.
Public Sub UpdateObject(obj As TPFDObject)
	'Check if there is an object
	If obj == Null Then Return
	If Not(obj.IsInitialized) Then Return
	
	'Loop over the objects list	
	For i = 0 To PFDObjects.Size - 1
		'Get an object from the objectslist
		Dim objx As TPFDObject = PFDObjects.Get(i).As(TPFDObject)
		'Check if the object is found using the object index
		If objx.index == obj.index Then
			'Replace the object in the list with the object argument
			PFDObjects.Set(i, obj)
			'Reload the CLV with the objects
			CustomListViewObjects_Load
			'Redraw the PFD with the updated object
			PFDRedraw(obj)
			'Set the PFD change state to true
			SetPFDChangedState(True)
			'Show the updated object site on the mainpage layout bottom right
			SetPFDObjectSize(obj)
			SetStatusbar($"[UpdateObject] type=${obj.pfdobject}, tag=${obj.tag}, index=${obj.index}, x/y=${obj.centerx}/${obj.centerx}."$)
			'If there is a dragging object, assign the update object
			If DraggingObj <> Null Then
				DraggingObj = obj
			End If
			Return
		End If
	Next
End Sub

'Remove an object in the objects list by the object unique index.
Private Sub RemoveObject(obj As TPFDObject)
	For i = 0 To PFDObjects.Size - 1
		If PFDObjects.Get(i).As(TPFDObject).index == obj.index Then
			PFDObjects.RemoveAt(i)
			ReindexObjects
			CustomListViewObjects_Load
			PFDRedraw(Null)
			SetPFDChangedState(True)
			SetStatusbar($"[RemoveObject] type)${obj.pfdobject}, tag=${obj.tag}, index=${obj.index}."$)
			Return
		End If
	Next
End Sub

'Find an object in the objects list by the object mandatory tag.
Private Sub FindObjectByTag(tag As String) As TPFDObject
	Dim result As TPFDObject
	For Each obj As TPFDObject In PFDObjects
		If obj.tag = tag Then
			result = obj
		End If
	Next
	Return result
End Sub

'Find an object in the objects list by the object mandatory index.
Private Sub FindObjectByIndex(index As Int) As TPFDObject
	Dim result As TPFDObject
	For Each obj As TPFDObject In PFDObjects
		If obj.index = index Then
			result = obj
		End If
	Next
	Return result
End Sub

'DRAWMODE_OFF or DRAWMODE_OBJECT: Move selected object left-up-down-right.
'The drawmode_off supports moving the object but not dragging.
Private Sub MoveObject(obj As TPFDObject, direction As String)
	'Check if the object is initialzed
	If Not(PFD.IsObjectInitialized(obj)) Then Return

	Helper.ToLog(Debug, $"[MoveObject] object=${obj.tag},direction=${direction}"$)
	Select direction
		Case PFDCommon.DIRECTION_LEFT
			obj.centerx = obj.centerx - MoveStepSize
		Case PFDCommon.DIRECTION_UP
			obj.centery = obj.centery - MoveStepSize
		Case PFDCommon.DIRECTION_DOWN
			obj.centery = obj.centery + MoveStepSize
		Case PFDCommon.DIRECTION_RIGHT
			obj.centerx = obj.centerx + MoveStepSize
	End Select

	SetPFDObjectToProperties(obj)
	UpdateObject(obj)
End Sub

'DRAWMODE_SELECT: Move selected objects left-up-down-right.
Private Sub MoveObjects(direction As String)
	'Checks
	If DrawSelectObjects.Size = 0 Then Return
	Helper.ToLog(Debug, $"[MoveObjects] objects=${DrawSelectObjects.Size},direction=${direction}"$)
	
	'Loop over the selected objects and set the new centerx, centery pos for the object
	For Each obj As TPFDObject In DrawSelectObjects	
		Select direction
			Case PFDCommon.DIRECTION_LEFT
				obj.centerx = obj.centerx - MoveStepSize
			Case PFDCommon.DIRECTION_UP
				obj.centery = obj.centery - MoveStepSize
			Case PFDCommon.DIRECTION_DOWN
				obj.centery = obj.centery + MoveStepSize
			Case PFDCommon.DIRECTION_RIGHT
				obj.centerx = obj.centerx + MoveStepSize
		End Select
		'Set the new object rect's position (x1,y1,x2,y2)
		obj = PFD.SetPFDObjectRectangles(obj)
		'Ensure to update the object in the PFDObjects list
		UpdateObject(obj)
	Next
	
	'Set the new position of the rectangle with the selected objects (selectrect)
	Select direction
		Case PFDCommon.DIRECTION_LEFT
			DrawSelectObjectsRect.left = DrawSelectObjectsRect.Left - MoveStepSize
			DrawSelectObjectsRect.right = DrawSelectObjectsRect.Right - MoveStepSize
		Case PFDCommon.DIRECTION_UP
			DrawSelectObjectsRect.top = DrawSelectObjectsRect.Top - MoveStepSize
			DrawSelectObjectsRect.bottom = DrawSelectObjectsRect.bottom - MoveStepSize
		Case PFDCommon.DIRECTION_DOWN
			DrawSelectObjectsRect.top = DrawSelectObjectsRect.Top + MoveStepSize
			DrawSelectObjectsRect.bottom = DrawSelectObjectsRect.Bottom + MoveStepSize
		Case PFDCommon.DIRECTION_RIGHT
			DrawSelectObjectsRect.left = DrawSelectObjectsRect.Left + MoveStepSize
			DrawSelectObjectsRect.right = DrawSelectObjectsRect.Right + MoveStepSize
	End Select

	'And redraw the PFD drawing board
	PFDRedraw(Null)
	PFD.mCvs.DrawRect(DrawSelectObjectsRect, PFDCommon.SELECTION_LINE_COLOR, False, PFDCommon.SELECTION_LINE_SIZE)
	PFD.mCvs.Invalidate
	Helper.ToLog(Debug, $"[MoveObjects] objects=${DrawSelectObjects.Size},l,t,r,b=${DrawSelectObjectsRect.left},${DrawSelectObjectsRect.top},${DrawSelectObjectsRect.right},${DrawSelectObjectsRect.bottom}"$)
End Sub

'DRAWMODE_SELECT: Delete selected objects.
Private Sub RemoveObjectsSelected
	'Checks
	If DrawSelectObjects.Size = 0 Then Return
	Helper.ToLog(Debug, $"[RemoveObjectsSelected] objects=${DrawSelectObjects.Size}"$)
	
	'Loop over the selected objects and set the new centerx, centery pos for the object
	For Each obj As TPFDObject In DrawSelectObjects	
		RemoveObject(obj)
	Next

	'Clear the selected objects list
	DrawSelectObjects.Clear

	'And redraw the PFD drawing board
	PFDRedraw(Null)
	
	SetStatusbar($"[RemoveObjectsSelected] Objects removed."$)

	Helper.ToLog(Debug, $"[RemoveObjectsSelected] objects=${DrawSelectObjects.Size}"$)
End Sub

'Copy selected object.
'Only possible for single object.
Private Sub CopyObject
	'Check the drawmode for single or multiple objects
	If DrawMode == DRAWMODE_OFF Or DrawMode == DRAWMODE_OBJECTS Then
		'Check if an object is selected = there must be initialized object
		If Not(PFD.IsObjectInitialized(DraggingObj)) Then Return
		'Copy the dragging object to the editobject
		EditObj = PFD.CopyObject(DraggingObj)
		SetStatusbar($"[CopyObject] Object ${EditObj.tag} copied."$)
	End If

	'TODO: Add copyobject for multiple objects.
	If DrawMode == DRAWMODE_SELECT Then
		PFDCommon.ShowMessage(PFDCommon.MSG_TYPE_WARNING, _
		                 	  "Copy Object", _ 
							  $"This feature is not supported for draw mode select."$)
	End If
End Sub

'Paste selected object as new object on the PFD Drawing Board at top left position.
'Only possible for single object.
Private Sub PasteObject
	'Check the drawmode for single or multiple objects
	If DrawMode == DRAWMODE_OFF Or DrawMode == DRAWMODE_OBJECTS Then
		'Check if an object is selected = there must be initialized object
		If Not(PFD.IsObjectInitialized(EditObj)) Then Return
		'Add the editobject to the PFD Drawing Board at top left pos
		AddObject(EditObj)
		SetStatusbar($"[PasteObject] Object ${EditObj.tag} pasted."$)
	End If

	'TODO: Add pasteobject for multiple objects.
	If DrawMode == DRAWMODE_SELECT Then
		PFDCommon.ShowMessage(PFDCommon.MSG_TYPE_WARNING, _
		                 	  "Paste Object", _ 
							  $"This feature is not supported for draw mode select."$)
	End If
End Sub

'Cut (Remove) selected object from the PFD Drawing Board.
'Only possible for single object.
Private Sub CutObject
	'Check the drawmode for single or multiple objects
	If DrawMode == DRAWMODE_OFF Or DrawMode == DRAWMODE_OBJECTS Then
		'Check if an object is selected = there must be initialized object
		If Not(PFD.IsObjectInitialized(DraggingObj)) Then Return
		'Copy the dragging object to the editobject
		EditObj = PFD.CopyObject(DraggingObj)
		'Remove the dragging object
		RemoveObject(DraggingObj)
		SetStatusbar($"[CutObject] Object ${EditObj.tag} cut."$)
	End If

	'TODO: Add cutobject for multiple objects.
	If DrawMode == DRAWMODE_SELECT Then
		PFDCommon.ShowMessage(PFDCommon.MSG_TYPE_WARNING, _
		                 	  "Cut Object", _ 
							  $"This feature is not supported for draw mode select."$)
	End If
End Sub
#End Region

#Region ObjectContextMenuDialog
'Open object context menu dialog to select an action.
'Used by the method PaneCanvas_MouseClicked (see next).
Private Sub ObjectContextMenuDialog(obj As TPFDObject) As ResumableSub
	'Define the optionslist
	Dim options As B4XListTemplate

	'Set the dialog title
	Dialog.Title = $"Select Action for ${obj.tag}"$
	
	'Init the optionslist
	options.Initialize
	'Add the context menu items defined in PFDCommon
	options.Options.AddAll(PFDCommon.OBJECT_CONTEXT_MENU)
	'Add the obj selected properties
	options.Options.Add($"Info: object=${obj.pfdobject}, tag=${obj.tag}, index=${obj.index}, description=${obj.description}, value=${obj.value}"$)
	'No multiselection
	options.AllowMultiSelection = False
	'Optional resize listdialog
	'options.Resize(300, 100)

	'Create the list dialog
	Dim rs As ResumableSub = Dialog.ShowTemplate(options, "OK", "", "CANCEL")
	'Set the hint as list item with special properties
	For i = 0 To options.CustomListView1.size - 1
		'Check if clv item index is contextmenu items + 1
		'Note the loop starts with 0 so the hint item is length contextmenu
		If i == PFDCommon.OBJECT_CONTEXT_MENU.Length Then
			Dim p As Pane = options.CustomListView1.GetPanel(i).As(Pane)
			'Get the label from the pane first (and only) node
			Dim lbl As Label = p.GetNode(0)
			'Set the properties
			lbl.Alignment = "CENTER_LEFT"
			'CSSUtils.SetBackgroundColor(lbl, fx.colors.LightGray)
			CSSUtils.SetStyleProperty(lbl, "-fx-font-size", 12)
			CSSUtils.SetStyleProperty(lbl, "-fx-text-fill", "darkgray")
			CSSUtils.SetStyleProperty(lbl, "-fx-font-weight", "normal")
		End If
	Next
	
	'Show the dialog. If OK call the select menu action.
	Wait For (rs) Complete (Result As Int)

	'Check the dialog result is ok
	If Result = xui.DialogResponse_Positive Then
		'Call the action selected
		Select options.SelectedItem
			Case PFDCommon.CONTEXT_MENU_COPY
				CopyObject
			Case PFDCommon.CONTEXT_MENU_PASTE
				PasteObject
			Case PFDCommon.CONTEXT_MENU_CUT
				CutObject
		End Select
	End If
	Return True
End Sub
#End Region

#Region PaneCanvasTouchMouseClick
'Handle mouseclick event.
'Get the object touched and assign to the global DraggingObj.
Private Sub PaneCanvas_MouseClicked (EventData As MouseEvent)
	EventData.Consume

	'Check secondary button clicked = right mouse click
	If EventData.SecondaryButtonPressed Then
		'Get the object touched at mouse x,y pos
		Dim obj As TPFDObject = PFD.GetObjectTouched(PFDObjects, EventData.X, EventData.Y)
		
		'Check if there is an object, then open the contextmenu dialog
		If obj <> Null Then
			ObjectContextMenuDialog(obj)
		End If
		Return
	End If

	If DrawMode == DRAWMODE_OFF Then
		Helper.ToLog(Debug, $"[PaneCanvas_MouseClicked] x=${EventData.x},y=${EventData.y},drawmode=${DrawMode}"$)
		
		'Get the object touched at mouse x,y pos
		Dim obj As TPFDObject = PFD.GetObjectTouched(PFDObjects, EventData.X, EventData.Y)
		
		'Check if there is an object
		If obj <> Null Then
			'Set the touched object as dragging object to enable using arrows
			DraggingObj = obj
			ObjectPropertyEventEnabled = True
			SetPFDObjectToProperties(obj)
			PFDRedraw(obj)
		End If
	End If
End Sub

'Show the pane pfd touch position in the status area bottom right.
'Private Sub PaneCanvas_Touch (Action As Int, X As Float, Y As Float)
'	LabelTouchPos.Text = $"x=${x},y=${y}"$
'End Sub

'Handle PaneCanvas touch depending the drawmode.
Private Sub PaneCanvas_Touch(Action As Int, X As Float, Y As Float)
	'Show the x,y touch position on the statusbar
	SetPFDCanvasPosition(X,Y)

	'Select the draw mode and draw accordingly
	Select DrawMode
		Case DRAWMODE_OBJECTS
			PaneCanvas_DrawObjects(Action, X, Y)
		Case DRAWMODE_LINES
			PaneCanvas_DrawLines(Action, X, Y)
		Case DRAWMODE_SELECT
			PaneCanvas_DrawSelect(Action, X, Y)
	End Select
End Sub

'Handle PaneCanvas touch for drawing an object.
Private Sub PaneCanvas_DrawObjects(Action As Int, X As Float, Y As Float)
	'Check if the drawmode is on objects
	If DrawMode <> DRAWMODE_OBJECTS Then Return
	LabelStatusbar.Text = $"[PaneCanvas_DrawObjects] drawmode=${DrawMode} (1=objects), action=${Action}, dragging=${Dragging}, x=${x}, y=${y}"$

	'Clear selected objects
	DrawSelectObjects.Clear

	'Start dragging object
	If Not(Dragging) And Action = PaneCanvas.TOUCH_ACTION_DOWN Then

		'Mouse is pressed > get the object touched
		Dim obj As TPFDObject = PFD.GetObjectTouched(PFDObjects, X, Y)
		Helper.ToLog(Debug, $"[PaneCanvas_DrawObjects] object touched=${obj}"$)
		
		'There is an object touched, lets move it
		If obj <> Null Then

			DraggingObj = obj
			Dragging = True
			DraggingMoved = False
			DraggingRectID = PFD.GetObjectRectTouched(DraggingObj, X, Y)

			'Redraw the pfd canvas followed by the gridcross at object center position
			PFDRedraw(DraggingObj)

			'Update the object properties shown at the right of the page
			ObjectPropertyEventEnabled = False
			SetPFDObjectToProperties(DraggingObj)
			Sleep(5)
			ObjectPropertyEventEnabled = True

			Helper.ToLog(Debug, $"[PaneCanvas_DrawObjects DOWN] x=${X},y=${Y},dragging=${Dragging},object=${DraggingObj.tag}"$)
		End If
	
	'Move dragging object (Mouse is pressed and moved)
	Else If Dragging And Action = PaneCanvas.TOUCH_ACTION_MOVE Then
		'Check if there is a draggingobj
		If Not(DraggingObj == Null) Then
			
			'Set move flag
			DraggingMoved = True

			'Set the new object center pos from the mouse click pos
			If DraggingRectID == PFDCommon.PFDOBJECT_RECT_CENTER Then
				DraggingObj.centerx = Round(X / PFDCommon.GRID_SIZE) * PFDCommon.GRID_SIZE
				DraggingObj.centery = Round(Y / PFDCommon.GRID_SIZE) * PFDCommon.GRID_SIZE
			Else
				DraggingObj = PFD.ResizeObjectTouched(DraggingObj, DraggingRectID, X, Y)
			End If

			'Update the object - not used here as covered by TOUCH_ACTION_UP when dragging completed
			'UpdateObject(DraggingObj)

			'Redraw the pfd canvas followed by the gridcross at dragging object center position
			PFDRedraw(DraggingObj)

			'Update the object properties shown at the right of the page
			SetPFDObjectToProperties(DraggingObj)

			SetStatusbar($"[PaneCanvas_DrawObjects MOVE] x=${X},y=${Y},dragging=${Dragging},object=${DraggingObj.tag}, ${DraggingObj.index}"$)
		End If

	'Stop dragging object
	Else If Dragging And Action = PaneCanvas.TOUCH_ACTION_UP Then
		'Mouse is released > object dropped at new position
		Dragging = False

		'Ensure there is a dragging obj
		If Not(DraggingObj == Null) And (DraggingMoved) Then
			'Set the new obj center pos from the mouse click pos.
			'The obj is not resized because touched at rect center.
			If DraggingRectID == PFDCommon.PFDOBJECT_RECT_CENTER Then
				'Adjust the center x,y to snaptogrid, i.e. x=47 > x=50 or y = 81 > y = 80
				DraggingObj.centerx = X
				DraggingObj.centery = Y
				DraggingObj.centerx = Round(DraggingObj.centerx / PFDCommon.GRID_SIZE) * PFDCommon.GRID_SIZE
				DraggingObj.centery = Round(DraggingObj.centery / PFDCommon.GRID_SIZE) * PFDCommon.GRID_SIZE
			Else
				'The obj is resized and the draggingobj updated with new center x,y and width&height.
				DraggingObj = PFD.ResizeObjectTouched(DraggingObj, DraggingRectID, X, Y)
			End If

			'Update the object in the list with center x,y coordinates and width&height
			UpdateObject(DraggingObj)

			'Update object properties
			ObjectPropertyEventEnabled = False
			SetPFDObjectToProperties(DraggingObj)
			Sleep(5)
			ObjectPropertyEventEnabled = True

			Helper.ToLog(Debug, $"[PaneCanvas_DrawObjects UP] x=${X},y=${Y},dragging=${Dragging},object=${DraggingObj.tag}"$)

			'Reset the dragging object
			DraggingObj = Null
			DraggingMoved = False
			DraggingRectID = -1

			'Redraw the pfd canvas without object selected.
			'This enables to use copy&paste as the object needs to be selected first.
			PFDRedraw(Null)
		End If

	End If
End Sub

'Handle PaneCanvas touch for drawing lines.
Private Sub PaneCanvas_DrawLines(Action As Int, X As Float, Y As Float)
	If DrawMode <> DRAWMODE_LINES Then Return
	LabelStatusbar.Text = $"[PaneCanvas_DrawLines] action=${Action},dragging=${Dragging},x=${x},y=${y}"$

	'Clear selected objects
	DrawSelectObjects.Clear

	Select Action
		Case PaneCanvas.TOUCH_ACTION_DOWN
			'Start drawing the line - indicate with blue dot; set line begin position
			DrawLineX1 = Round(X / PFDCommon.GRID_SIZE) * PFDCommon.GRID_SIZE
			DrawLineY1 = Round(Y / PFDCommon.GRID_SIZE) * PFDCommon.GRID_SIZE
			DrawLineX2 = -1
			DrawLineY2 = -1
			PFD.mCvs.DrawCircle(DrawLineX1, DrawLineY1, 3, xui.Color_Blue, True, 1)
			PFD.mCvs.Invalidate
			
		Case PaneCanvas.TOUCH_ACTION_MOVE
			'Move the mouse - keep the line end position
			'PaneCanvas.DrawCircle(x0, y0, 3, xui.Color_Red, True, 1)
			DrawLineX2 = X
			DrawLineY2 = Y
			
		Case PaneCanvas.TOUCH_ACTION_UP
			'Stop movig followed by drawing the line and add to the objects
			If DrawLineX2 > -1 Then
				DrawLineX2 = Round(X / PFDCommon.GRID_SIZE) * PFDCommon.GRID_SIZE
				DrawLineY2 = Round(Y / PFDCommon.GRID_SIZE) * PFDCommon.GRID_SIZE
				PFD.mCvs.DrawCircle(DrawLineX2, DrawLineY2, 3, xui.Color_Blue, True, 1)
				'Draw the line
				PFDShapesBasic.DrawLineSolid2(PFD.mCvs, DrawLineX1, DrawLineY1, DrawLineX2, DrawLineY2, _
										 	  PFDCommon.LINE_SOLID_COLOR, PFDCommon.LINE_SOLID_STROKE_WIDTH)
				'Add the line to the objects
				AddObjectLine(DrawLineX1, DrawLineY1, DrawLineX2, DrawLineY2)

				'Redraw the pfd canvas without object selected.
				'This enables to use copy&paste as the object needs to be selected first.
				PFDRedraw(Null)

			End If
	End Select
End Sub

'Handle PaneCanvas touch for selecting an area with objects.
Private Sub PaneCanvas_DrawSelect(Action As Int, X As Float, Y As Float)
	If DrawMode <> DRAWMODE_SELECT Then Return
	LabelStatusbar.Text = $"[PaneCanvas_DrawSelect]action=${Action},dragging=${Dragging},x=${x},y=${y}"$

	Select Action
		Case PaneCanvas.TOUCH_ACTION_DOWN
			'Set the select rectangle start point 
			'Clear the selected objects list
			DrawSelectObjects.Clear
			
			'Start drawing the rect - indicated with a blue dot; set rectangle begin position
			DrawSelectX1 = Round(X / PFDCommon.GRID_SIZE) * PFDCommon.GRID_SIZE
			DrawSelectY1 = Round(Y / PFDCommon.GRID_SIZE) * PFDCommon.GRID_SIZE
			DrawSelectX2 = DrawSelectX1
			DrawSelectY2 = DrawSelectX2
			PFD.mCvs.DrawCircle(DrawSelectX1, DrawSelectY1, 3, PFDCommon.SELECTION_LINE_COLOR, True, 1)
			PFD.mCvs.Invalidate

		Case PaneCanvas.TOUCH_ACTION_MOVE
			'Move the mouse - keep the rect bottom left or top right pos
			DrawSelectX2 = X
			DrawSelectY2 = Y
			PFDRedraw(Null)
			PFD.mCvs.DrawCircle(DrawSelectX2, DrawSelectY2, 3, xui.Color_Blue, True, 1)
			DrawSelectObjectsRect.Initialize(DrawSelectX1, DrawSelectY1, DrawSelectX2, DrawSelectY2)
			PFD.mCvs.DrawRect(DrawSelectObjectsRect, PFDCommon.SELECTION_LINE_COLOR, False, PFDCommon.SELECTION_LINE_SIZE)
			PFD.mCvs.Invalidate

		Case PaneCanvas.TOUCH_ACTION_UP
			'Redraw the pfd without any object selected
			PFDRedraw(Null)
			
			'Stop drawing the rect, init the select rectangle
			DrawSelectX2 = Round(X / PFDCommon.GRID_SIZE) * PFDCommon.GRID_SIZE
			DrawSelectY2 = Round(Y / PFDCommon.GRID_SIZE) * PFDCommon.GRID_SIZE
			DrawSelectObjectsRect.Initialize(DrawSelectX1, DrawSelectY1, DrawSelectX2, DrawSelectY2)

			'Draw & commit the select rectangle
			PFD.mCvs.DrawRect(DrawSelectObjectsRect, PFDCommon.SELECTION_LINE_COLOR, False, PFDCommon.SELECTION_LINE_SIZE)
			PFD.mCvs.Invalidate
			
			'Get the objects selected from the selected area
			DrawSelectObjects = PFD.GetObjectsFromSelectArea(PFDObjects, DrawSelectObjectsRect)
	End Select
End Sub
#End Region

#Region ObjectProperties
'Create the object properties in a scrollpane.
'Set combobox selection items.
Private Sub CreateObjectProperties
	'Load the layout holding the object properties with Label+TextField
	ScrollPanePFDObjectProperties.LoadLayout("ObjectProperties", -1, -1)
	
	'Comboxes set items and set the first item as selected
	B4XComboBoxObjDirection.SetItems(PFDCommon.PFDDirections)
	B4XComboBoxObjDirection.SelectedIndex = 0

	B4XComboBoxObjArrow.SetItems(PFDCommon.PFDArrowDirections)
	B4XComboBoxObjArrow.SelectedIndex = 0

	B4XComboBoxObjFont.SetItems(PFDCommon.PFDFonts)	'Helper.GetDefaultFontNames
	B4XComboBoxObjFont.SelectedIndex = 0

	B4XComboBoxObjTextAlignment.SetItems(PFDCommon.PFDTextAlignments)
	B4XComboBoxObjTextAlignment.SelectedIndex = 1
End Sub

'Set the UI views holding the object properties with the properties from the object tpe TPFDObject.
'Note that this triggers also the object events, like textchanged.
'obj - Object used to set the UI views
'update - Flag to indicate if the UI views methods like textchanged are invoked and update the object
Private Sub SetPFDObjectToProperties(obj As TPFDObject) As Boolean
	Helper.ToLog(Debug, $"[SetPFDObjectToProperties] obj=${obj.tag},ObjectPropertyEventEnabled=${ObjectPropertyEventEnabled}"$)

	'Check if the object is initialzed
	If Not(PFD.IsObjectInitialized(obj)) Then
		Return False
	End If
	
	LabelObjIndexValue.Text						= obj.index
	TextFieldObjTag.Text						= obj.tag
	TextFieldObjDescription.Text				= obj.description
	TextFieldObjValue.Text						= obj.value
	TextFieldObjUnit.Text						= obj.unit

	TextFieldObjImage.Text 						= obj.image
'	'If the object type is an image then enable image textfield
'	'"pfdobject":"IMAGE"
'	If obj.pfdobject.Contains("IMAGE") Then
'		TextFieldObjImage.Enabled = True
'		TextFieldObjImage.Text = obj.image
'	Else
'		TextFieldObjImage.Enabled = False
'		TextFieldObjImage.Text = ""
'	End If
	
	SpinnerObjCenterX.Value						= obj.centerx
	SpinnerObjCenterY.Value						= obj.centery
	SpinnerObjWidth.Value						= obj.width
	SpinnerObjHeight.Value						= obj.height
	B4XComboBoxObjPFDObject.cmbBox.Value		= obj.pfdobject
	B4XComboBoxObjDirection.cmbBox.Value		= obj.direction
	B4XComboBoxObjArrow.cmbBox.Value			= obj.arrow

	B4XComboBoxObjFont.cmbbox.value				= obj.font.ToUpperCase
	B4XComboBoxObjTextAlignment.cmbBox.Value	= obj.textalignment
	CheckBoxObjSeparator.Checked				= obj.separator
	CheckBoxObjOperate.Checked					= obj.operate
	ColorPickerObjBorderColor.SelectedColor		= fx.Colors.From32Bit(obj.bordercolor)
	ColorPickerObjFillColor.SelectedColor		= fx.Colors.From32Bit(obj.fillcolor)
	ColorPickerObjTextColor.SelectedColor		= fx.Colors.From32Bit(obj.textcolor)
	SpinnerObjFontSize.Value					= obj.fontsize
	SpinnerObjStrokeWidth.Value					= obj.strokewidth
	SpinnerObjCornerRadius.Value				= obj.cornerradius
	LabelObjHint.Text 							= PFD.GetShapeHint(PFDShapes, obj.pfdobject)	'from the shapes definition file pfdcreator.shp

	SetPFDObjectSize(obj)

	'Set property enabled/disabled based on on shape definition
	TextFieldObjTag.Enabled 					= PFD.HasShapeProperty(PFDShapes, obj.pfdobject, "tag")
	TextFieldObjDescription.Enabled				= PFD.HasShapeProperty(PFDShapes, obj.pfdobject, "description")
	TextFieldObjValue.Enabled 					= PFD.HasShapeProperty(PFDShapes, obj.pfdobject, "value")
	TextFieldObjUnit.Enabled 					= PFD.HasShapeProperty(PFDShapes, obj.pfdobject, "unit")
	TextFieldObjImage.Enabled 					= PFD.HasShapeProperty(PFDShapes, obj.pfdobject, "image")
	SpinnerObjCenterX.Enabled 					= PFD.HasShapeProperty(PFDShapes, obj.pfdobject, "centerx")
	SpinnerObjCenterY.Enabled 					= PFD.HasShapeProperty(PFDShapes, obj.pfdobject, "centery")
	SpinnerObjWidth.Enabled				 		= PFD.HasShapeProperty(PFDShapes, obj.pfdobject, "width")
	SpinnerObjHeight.Enabled 					= PFD.HasShapeProperty(PFDShapes, obj.pfdobject, "height")
	B4XComboBoxObjPFDObject.cmbBox.Enabled		= PFD.HasShapeProperty(PFDShapes, obj.pfdobject, "pfdobject")
	B4XComboBoxObjDirection.cmbBox.Enabled		= PFD.HasShapeProperty(PFDShapes, obj.pfdobject, "direction")
	B4XComboBoxObjArrow.cmbBox.Enabled 			= PFD.HasShapeProperty(PFDShapes, obj.pfdobject, "arrow")
	B4XComboBoxObjFont.cmbbox.Enabled 			= PFD.HasShapeProperty(PFDShapes, obj.pfdobject, "font")
	B4XComboBoxObjTextAlignment.cmbBox.Enabled	= PFD.HasShapeProperty(PFDShapes, obj.pfdobject, "textalignment")
	CheckBoxObjSeparator.Enabled 				= PFD.HasShapeProperty(PFDShapes, obj.pfdobject, "separator")
	CheckBoxObjOperate.Enabled 					= PFD.HasShapeProperty(PFDShapes, obj.pfdobject, "operate")
	ColorPickerObjBorderColor.Enabled 			= PFD.HasShapeProperty(PFDShapes, obj.pfdobject, "bordercolor")
	ColorPickerObjFillColor.Enabled 			= PFD.HasShapeProperty(PFDShapes, obj.pfdobject, "fillcolor")
	ColorPickerObjTextColor.Enabled 			= PFD.HasShapeProperty(PFDShapes, obj.pfdobject, "textcolor")
	SpinnerObjFontSize.Enabled 					= PFD.HasShapeProperty(PFDShapes, obj.pfdobject, "fontsize")
	SpinnerObjStrokeWidth.Enabled 				= PFD.HasShapeProperty(PFDShapes, obj.pfdobject, "strokewidth")
	SpinnerObjCornerRadius.Enabled 				= PFD.HasShapeProperty(PFDShapes, obj.pfdobject, "cornerradius")
	
	Return True
End Sub

'Reset the obj properties to defaults.
Private Sub ResetPFDObjectProperties
	Dim obj As TPFDObject

	Helper.ToLog(Debug, $"[ResetPFDObjectProperties] Reset all object properties."$)
	obj.Initialize
	obj.arrow 			= PFDCommon.DIRECTION_NONE
	obj.bordercolor 	= PFDCommon.OBJECT_BORDERCOLOR
	obj.centerx 		= 0
	obj.centery 		= 0
	obj.description 	= ""
	obj.direction 		= PFDCommon.DIRECTION_NONE
	obj.fillcolor 		= PFDCommon.OBJECT_FILLCOLOR
	obj.font 			= PFDCommon.FONT_DEFAULT
	obj.fontsize 		= PFDCommon.FONT_DEFAULT_SIZE
	obj.height 			= 0
	obj.image 			= ""
	obj.index 			= -1
	obj.pfdobject 		= ""
	obj.separator 		= PFDCommon.OBJECT_SEPARATOR
	obj.operate 		= PFDCommon.OBJECT_OPERATE
	obj.strokewidth		= PFDCommon.OBJECT_STROKEWIDTH
	obj.cornerradius 	= PFDCommon.OBJECT_CORNERRADIUS
	obj.shapeselector	= ""
	obj.tag 			= ""
	obj.textalignment	= PFDCommon.TEXT_ALIGNMENT_CENTER
	obj.textcolor 		= PFDCommon.OBJECT_TEXTCOLOR
	obj.unit 			= ""
	obj.value 			= ""
	obj.width 			= 0
	obj.x1 				= 0
	obj.y1 				= 0
	obj.x2 				= 0
	obj.y2 				= 0
	obj 				= PFD.SetPFDObjectRectangles(obj)

	SetPFDObjectToProperties(obj)
End Sub

'Set the UI object properties to an object.
'TODO: Add checks.
Private Sub SetPFDPropertiesToObject As TPFDObject
	Dim obj As TPFDObject

	obj.Initialize
	obj.arrow 			= B4XComboBoxObjArrow.cmbBox.Value
	obj.bordercolor 	= fx.Colors.To32Bit(ColorPickerObjBorderColor.SelectedColor)
	obj.centerx 		= SpinnerObjCenterX.Value
	obj.centery 		= SpinnerObjCenterY.Value
	obj.description 	= TextFieldObjDescription.Text
	obj.direction 		= B4XComboBoxObjDirection.cmbBox.Value
	obj.fillcolor 		= fx.Colors.To32Bit(ColorPickerObjFillColor.SelectedColor)
	obj.font 			= B4XComboBoxObjFont.SelectedItem.ToUpperCase
	obj.fontsize 		= SpinnerObjFontSize.Value
	obj.height 			= SpinnerObjHeight.Value
	obj.image 			= TextFieldObjImage.Text
	obj.index 			= LabelObjIndexValue.Text
	obj.pfdobject 		= B4XComboBoxObjPFDObject.cmbBox.Value
	obj.separator 		= CheckBoxObjSeparator.Checked
	obj.operate 		= CheckBoxObjOperate.Checked
	obj.strokewidth 	= SpinnerObjStrokeWidth.Value
	obj.cornerradius 	= SpinnerObjCornerRadius.Value
	obj.tag 			= TextFieldObjTag.Text
	obj.textalignment	= B4XComboBoxObjTextAlignment.cmbBox.Value
	obj.textcolor 		= fx.Colors.To32Bit(ColorPickerObjTextColor.SelectedColor)
	obj.unit 			= TextFieldObjUnit.Text
	obj.value 			= TextFieldObjValue.Text
	obj.width 			= SpinnerObjWidth.Value
	obj.x1 				= obj.centerx - (obj.width / 2)
	obj.y1 				= obj.centery - (obj.height / 2)
	obj.x2 				= obj.centerx + (obj.width / 2)
	obj.y2 				= obj.centery - (obj.height / 2)
	obj 				= PFD.SetPFDObjectRectangles(obj)
	
	Return obj
End Sub

'Set the shape definition map to object properties.
'The shape definition is set in file pfdcreator.shp.
Private Sub SetPFDShapeDefinitionToObject(definition As Map) As TPFDObject
	Dim obj As TPFDObject
	
	obj.Initialize
	obj.index 			= -1
	obj.pfdobject 		= IIf(definition.ContainsKey("pfdobject"), definition.Get("pfdobject"), PFDCommon.OBJECT_UNKNOWN)
	obj.tag 			= IIf(definition.ContainsKey("tag"), definition.Get("tag"), "TAG")
	obj.description		= IIf(definition.ContainsKey("description"), definition.Get("description"), "")

	'The value is a string.
	obj.value 			= IIf(definition.ContainsKey("value"), definition.Get("value"), "")
	obj.unit 			= IIf(definition.ContainsKey("unit"), definition.Get("unit"), "")

	obj.direction 		= IIf(definition.ContainsKey("direction"), definition.Get("direction"), PFDCommon.DIRECTION_NONE)

	obj.arrow 			= IIf(definition.ContainsKey("arrow"), definition.Get("arrow"), PFDCommon.DIRECTION_NONE)

	'TODO: Consider using shapes with predefined images.
	obj.image 			= IIf(definition.ContainsKey("image"), definition.Get("image"), "")

	'Check if the coordinates and the size are numbers. if not then set to 0 and logged.
	obj.centerx 		= IIf(definition.ContainsKey("centerx"), Helper.CheckNumberField(definition.Get("centerx")), 0)
	obj.centery 		= IIf(definition.ContainsKey("centery"), Helper.CheckNumberField(definition.Get("centery")), 0)
	obj.width 			= IIf(definition.ContainsKey("width"), Helper.CheckNumberField(definition.Get("width")), 0)
	obj.height 			= IIf(definition.ContainsKey("height"), Helper.CheckNumberField(definition.Get("height")), 0)

	obj.x1 				= IIf(definition.ContainsKey("x1"), definition.Get("x1").As(Float), 0)
	obj.y1 				= IIf(definition.ContainsKey("y1"), definition.Get("y1").As(Float), 0)
	obj.x2 				= IIf(definition.ContainsKey("x2"), definition.Get("x2").As(Float), 0)
	obj.y2 				= IIf(definition.ContainsKey("y2"), definition.Get("y2").As(Float), 0)
	
	obj 				= PFD.SetPFDObjectRectangles(obj)

	obj.font			= IIf(definition.ContainsKey("font"), definition.Get("font").As(String).ToUpperCase, PFDCommon.FONT_DEFAULT)
	obj.fontsize		= IIf(definition.ContainsKey("fontsize"), definition.Get("fontsize"), PFDCommon.FONT_DEFAULT_SIZE)
	obj.fillcolor		= IIf(definition.ContainsKey("fillcolor"), Helper.ColorHexToInt(definition.Get("fillcolor")), PFDCommon.OBJECT_FILLCOLOR)
	obj.bordercolor		= IIf(definition.ContainsKey("bordercolor"), Helper.ColorHexToInt(definition.Get("bordercolor")), PFDCommon.OBJECT_BORDERCOLOR)
	obj.textcolor		= IIf(definition.ContainsKey("textcolor"), Helper.ColorHexToInt(definition.Get("textcolor")), PFDCommon.OBJECT_TEXTCOLOR)
	obj.textalignment	= IIf(definition.ContainsKey("textalignment"), definition.Get("textalignment"), PFDCommon.TEXT_ALIGNMENT_CENTER)
	obj.strokewidth		= IIf(definition.ContainsKey("strokewidth"), definition.Get("strokewidth"), PFDCommon.OBJECT_STROKEWIDTH)
	obj.cornerradius	= IIf(definition.ContainsKey("cornerradius"), definition.Get("cornerradius"), PFDCommon.OBJECT_CORNERRADIUS)
	obj.separator		= IIf(definition.ContainsKey("separator"), definition.Get("separator"), PFDCommon.OBJECT_SEPARATOR)
	obj.operate			= IIf(definition.ContainsKey("operate"), definition.Get("operate"), PFDCommon.OBJECT_OPERATE)

	Return obj	
End Sub

'Handle updating the object from the ui property views (PFD right pane with views).
'For every property event, this sub must be assigned.
Private Sub HandleObjectPropertyEvent
	If Not(ObjectPropertyEventEnabled) Then Return
	UpdateObject(SetPFDPropertiesToObject)
End Sub

'Object property events calling HandleObjectPropertyEvent.
Private Sub B4XComboBoxObjpfdobject_SelectedIndexChanged (Index As Int)
	HandleObjectPropertyEvent
End Sub
Private Sub TextFieldObjTag_TextChanged (Old As String, New As String)
	HandleObjectPropertyEvent
End Sub
Private Sub TextFieldObjDescription_TextChanged (Old As String, New As String)
	HandleObjectPropertyEvent
End Sub
Private Sub TextFieldObjValue_TextChanged (Old As String, New As String)
	HandleObjectPropertyEvent
End Sub
Private Sub TextFieldObjUnit_TextChanged (Old As String, New As String)
	HandleObjectPropertyEvent
End Sub
Private Sub B4XComboBoxObjDirection_SelectedIndexChanged (Index As Int)
	HandleObjectPropertyEvent
End Sub
Private Sub B4XComboBoxObjArrow_SelectedIndexChanged (Index As Int)
	HandleObjectPropertyEvent
End Sub
Private Sub SpinnerObjCenterX_ValueChanged (Value As Object)
	HandleObjectPropertyEvent
End Sub
Private Sub SpinnerObjCenterY_ValueChanged (Value As Object)
	HandleObjectPropertyEvent
End Sub
Private Sub SpinnerObjWidth_ValueChanged (Value As Object)
	HandleObjectPropertyEvent
End Sub
Private Sub SpinnerObjHeight_ValueChanged (Value As Object)
	HandleObjectPropertyEvent
End Sub
Private Sub TextFieldObjImage_TextChanged (Old As String, New As String)
	HandleObjectPropertyEvent
End Sub
'Handle double click on the Image Label = show the Image size width and height
Private Sub LabelObjImage_MouseClicked (EventData As MouseEvent)
	If EventData.ClickCount == 2 Then
		Dim m As Map = Helper.GetImageSize(File.dirapp, TextFieldObjImage.Text)
		If m.IsInitialized Then
			xui.MsgboxAsync($"Image Size ${File.dirapp}\${TextFieldObjImage.Text}:${CRLF}width=${m.Get("w")}${CRLF}height=${m.Get("h")}"$, "Image Size")
		Else
			xui.MsgboxAsync($""[ERROR] Can not read image ${File.dirapp}\${TextFieldObjImage.Text}"$, "Image Size")
		End If
	End If
End Sub
Private Sub TextFieldObjImage_MouseClicked (EventData As MouseEvent)
	'TODO: show dialog to select a PNG imagefile from the dirapp folder.
End Sub
Private Sub TextFieldObjFont_TextChanged (Old As String, New As String)
	HandleObjectPropertyEvent	
End Sub
Private Sub SpinnerObjStrokeWidth_ValueChanged (Value As Object)
	HandleObjectPropertyEvent
End Sub
Private Sub SpinnerObjCornerRadius_ValueChanged (Value As Object)
	HandleObjectPropertyEvent
End Sub
Private Sub SpinnerObjFontSize_ValueChanged (Value As Object)
	HandleObjectPropertyEvent
End Sub
Private Sub ColorPickerObjTextColor_ValueChanged (Value As Paint)
	HandleObjectPropertyEvent
End Sub
Private Sub ColorPickerObjFillColor_ValueChanged (Value As Paint)
	HandleObjectPropertyEvent
End Sub
Private Sub ColorPickerObjBorderColor_ValueChanged (Value As Paint)
	HandleObjectPropertyEvent
End Sub
Private Sub CheckBoxObjSeperator_CheckedChange(Checked As Boolean)
	HandleObjectPropertyEvent	
End Sub
Private Sub B4XComboBoxObjFont_SelectedIndexChanged (Index As Int)
	HandleObjectPropertyEvent
End Sub
Private Sub B4XComboBoxObjTextAlignment_SelectedIndexChanged (Index As Int)
	HandleObjectPropertyEvent
End Sub
Private Sub CheckBoxObjSeparator_CheckedChange(Checked As Boolean)
	HandleObjectPropertyEvent
End Sub
Private Sub CheckBoxObjOperate_CheckedChange(Checked As Boolean)
	HandleObjectPropertyEvent
End Sub
Private Sub LabelObjHint_MouseClicked (EventData As MouseEvent)
	If DraggingObj == Null Then Return
	If Not(DraggingObj.IsInitialized) Then Return
	If EventData.ClickCount == 1 Then
		PFDCommon.ShowMessage(PFDCommon.MSG_TYPE_INFORMATION, _
		                 	  $"Hint ${DraggingObj.Tag} (${DraggingObj.pfdobject})"$, _ 
							  $"${LabelObjHint.text}"$)
	End If
End Sub
#End Region

#Region CustomListViewObjects
'Build the list of objects and show in the customlistview objects.
Private Sub CustomListViewObjects_Load As ResumableSub
	Dim result As Boolean = True

	'Clear the CLV first - required for refresh after updating an object
	CustomListViewObjects.Clear
	
	'Sort the objects asc by otag
	PFDObjects.SortType("tag", True)

	'Add to the CLV list an item with object otag, otype, oindex
	For Each obj As TPFDObject In PFDObjects
		CustomListViewObjects.Add(CustomListViewObjects_CreateListItem(obj, CustomListViewObjects.AsView.Width, 60dip), obj)
		'CustomListViewObjects.AddTextItem($"${obj.tag}${CRLF}${obj.pfdobject}"$, obj)
	Next
	LabelObjects.Text = $"Objects #${PFDObjects.size}"$

	Return result
End Sub

'Create a list item which is a panel with object Tag, Type and Index.
'Obj - PFD object
'Width - Width of the panel
'Height - Height of the panel
Private Sub CustomListViewObjects_CreateListItem(obj As TPFDObject, Width As Int, Height As Int) As B4XView
	'Create a panel as B4XView
	Dim p As B4XView = xui.CreatePanel("")

	'Set the layout
	p.SetLayoutAnimated(0, 0, 0, Width, Height)
	p.LoadLayout("CustomListViewObjects_CellItem")
	p.Color = xui.color_white

	DesignerUtils.GetViewByName(p, "LabelObjTag").Text = obj.tag
	DesignerUtils.GetViewByName(p, "LabelObjTag").TextSize = 15

	DesignerUtils.GetViewByName(p, "LabelObjPFDObject").Text = obj.pfdobject
	DesignerUtils.GetViewByName(p, "LabelObjPFDObject").TextColor = xui.color_darkgray
	DesignerUtils.GetViewByName(p, "LabelObjPFDObject").TextSize = 12

	DesignerUtils.GetViewByName(p, "LabelObjIndex").Text = obj.index
	DesignerUtils.GetViewByName(p, "LabelObjIndex").TextColor = xui.color_darkgray
	DesignerUtils.GetViewByName(p, "LabelObjIndex").TextSize = 12

	'Return the new panel which is added to the CLV
	Return p
End Sub

'Select the object on the PFD
Private Sub CustomListViewObjects_ItemClick (Index As Int, Value As Object)
	Dim objvalue As TPFDObject = Value
	Dim obj As TPFDObject = FindObjectByIndex(objvalue.index)

	'Set the object properties
	ObjectPropertyEventEnabled = False
	SetPFDObjectToProperties(obj)
	Sleep(5)
	ObjectPropertyEventEnabled = True
	'SetPFDObjectToProperties(obj)

	'Set drawmode to objects in case drawmode is lines or select.
	'Do not redraw because done next step
	If DrawMode == DRAWMODE_LINES Or DrawMode == DRAWMODE_SELECT Then
		SetDrawModeState(DRAWMODE_OBJECTS, False)
	End If

	'Redraw the pfd, select the object and show the position cross at the object center x,y
	PFDRedraw(obj)
End Sub

'NOT USED - just example how to clear the list
'Clear the clv with the object.
Private Sub CustomListViewObjects_Clear
	CustomListViewObjects.Clear
End Sub
#End Region

#Region CustomListViewShapes
'ShapeSelector is a customlistview (CLV) listing the shape types which are defined as JSON in the external shape definition file PFDCreator.shp (dirapp folder).
'The CLV shows the object shape image.
'When clicking on an object, the shape is created on the PFD Drawing Board at object centerx,centery position with sizes width and height as defined in the shape definition file.

'Load the shapes from the external shapes defintion file and create the images.
Private Sub CustomListViewShapes_Load As ResumableSub
	Dim result As Boolean
	Dim parser As JSONParser
	Dim shapetype As String

	'Clear the shapes list
	PFDShapeNames.Clear

	'Customlistview clear & color
	CustomListViewShapes.Clear
	
	Try
		'Load the shapes with its definition from external json file
		parser.Initialize(File.ReadString(File.DirApp, PFDCommon.SHAPES_FILE))
		
		'Get the array containing the shape types with the shapes
		'The size of the array is the number of shape types, i.e. 3 for Basic, Flowchart, PID
		Dim jRoot As List = parser.NextArray
		
		'Loop over the array with the shapes, get the type and its shapes.
		For Each coljRoot As Map In jRoot
			shapetype = coljRoot.Get("shapetype")
			Dim shapes As List = coljRoot.Get("shapes")

			'Set the max expanded height for the shapes pane and assign to the item value
			Dim PaneShapesExpandedHeight As Int = ((shapes.Size / CustomListViewShapes_ShapesPerRow) * CustomListViewShapes_ShapeHeightWidth) + (CustomListViewShapes_ShapeHeightWidth * 1.5)
			CustomListViewShapes.Add(CustomListViewShapesCreateItem(xui.Color_White, shapetype, shapes), PaneShapesExpandedHeight)
		Next
		result = True
	Catch
		PFDCommon.ShowMessage(PFDCommon.MSG_TYPE_ERROR, _
		                 	  "Load Shapes", _ 
							  $"Can not load the shapes from file ${PFDCommon.SHAPES_FILE}.${CRLF}${LastException}"$)
		result = False
	End Try
	Return result
End Sub

'Create a clv expandable item with 2 panes.
'Top pane contains the title, which is the shape type, and a down arrow to expand/collapse the bottom pane.
'Bottom pane contains the shape images for the selected shape type.
'The shape images are created from the external shape definition file pfdcreator.shp.
'A shape image is drawn on an imageview based on the shape definition dimension width and height (ensure to set).
'The shape definition dimension width and height are adjusted to fit into the imageview.
'The imageview is added to an image pane which is added to the bottom pane containing the images for the shapetype.
'There are 3 images per row in the bottom pane.
'Summary:
'The shape pane has default dimension w=60, h=60.
'Within the shape pane there is the imageview pane with dimension w=50, h=50.
'The imageview pane contains the shape image.
'The imageview pane has an event PaneImage_MouseEntered(EventData As MouseEvent) which can be used to show the pfdobject, like ARROW, OVAL.
Private Sub CustomListViewShapesCreateItem(clr As Int, Title As String, shapes As List) As B4XView
	Dim x,y As Int

	'Shape Pane width,height and offset for the imageview pane
	Dim pw As Int = CustomListViewShapes_ShapeHeightWidth
	Dim ph As Int = CustomListViewShapes_ShapeHeightWidth
	Dim poffset As Int = 5

	'Image width,height to fit into the shape pane
	Dim iw,ih As Int

	'Obj width,height and factor to resize the image from defaults (set in pfdcreator.shp)
	Dim ow As Int
	Dim oh As Int
	Dim f As Float

	'Handling shapes in the bottom pane
	Dim xcnt As Int = 0
	Dim ycnt As Int = 0

	'Default panel shape width, height
	iw = pw - (poffset * 2)
	ih = ph - (poffset * 2)
	x = 0
	y = ph

	'Create the panel for the expanded items (images)
	Dim p As B4XView = xui.CreatePanel("")

	'Initial layout with max expanded height
	p.SetLayoutAnimated(0, 0, 0, CustomListViewShapes.AsView.Width, CustomListViewShapes_ExpandedHeight)
	'Load the layout
	p.LoadLayout("CustomListViewShapes_ExpandableItem")
	'And collapse the panel
	p.SetLayoutAnimated(0, 0, 0, p.Width, CustomListViewShapes_CollapsedHeight)

	'Top pane
	lblTitle.Text = Title
	pnlTitle.Color = clr
	'pnlExpanded.Color = clr	'Helper.ShadeColor(xui.color_white)
	pnlExpanded.SetColorAndBorder(clr,0,clr,0)

	'Bottom pane which is view(1) of the layout item
	Dim pnlShapeImages As Pane = p.GetView(1)
	
	'Add the shapes for the shape type
	Dim i As Int = 0
	'Loop over the shapes and add the shape as map (JSON key:value pair) to the global PFDShapes list.
	For Each colshape As Map In shapes
		'Define new PFD object
		Dim obj As TPFDObject

		'Init a new object		
		obj.Initialize
		
		'Get the mandatory pfdobject and add to the global pfdshapenames list
		obj.pfdobject 		= IIf(colshape.ContainsKey("pfdobject"), colshape.Get("pfdobject"), PFDCommon.OBJECT_UNKNOWN)
		PFDShapeNames.Add(obj.pfdobject)

		'Add the shape to the global shapes list
		PFDShapes.Add(colshape)

		'Set the object properties from the shape definition
		obj.tag				= IIf(colshape.ContainsKey("tag"), colshape.Get("tag"), PFDCommon.OBJECT_UNKNOWN)
		obj.direction 		= IIf(colshape.ContainsKey("direction"), colshape.Get("direction"), PFDCommon.DIRECTION_NONE)
		obj.strokewidth		= IIf(colshape.ContainsKey("strokewidth"), colshape.Get("strokewidth"), PFDCommon.OBJECT_STROKEWIDTH)
		obj.cornerradius	= IIf(colshape.ContainsKey("cornerradius"), colshape.Get("cornerradius"), PFDCommon.OBJECT_CORNERRADIUS)
		obj.bordercolor		= IIf(colshape.ContainsKey("bordercolor"), Helper.ColorHexToInt(colshape.Get("bordercolor")), xui.color_black)
		obj.fillcolor		= IIf(colshape.ContainsKey("fillcolor"), Helper.ColorHexToInt(colshape.Get("fillcolor")), xui.color_white)
		obj.textcolor		= IIf(colshape.ContainsKey("textcolor"), Helper.ColorHexToInt(colshape.Get("textcolor")), xui.color_black)
		obj.font			= IIf(colshape.ContainsKey("font"), colshape.Get("font"), PFDCommon.FONT_DEFAULT)
		obj.fontsize		= IIf(colshape.ContainsKey("fontsize"), colshape.Get("fontsize"), PFDCommon.FONT_DEFAULT_SIZE)
		obj.textalignment	= IIf(colshape.ContainsKey("textalignment"), colshape.Get("textalignment"), PFDCommon.TEXT_ALIGNMENT_CENTER)
		obj.description		= IIf(colshape.ContainsKey("description"), colshape.Get("description"), "")
		
		'Use the shape description to set value and image for the small shape in the shape selector
		obj.shapeselector	= IIf(colshape.ContainsKey("shapeselector"), colshape.Get("shapeselector"), "")
		obj.value			= IIf(colshape.ContainsKey("shapeselector"), colshape.Get("shapeselector"), "")
		obj.image 			= IIf(colshape.ContainsKey("shapeselector"), colshape.Get("shapeselector"), "")
				
		'Set the obj width/height based on the image default.
		'Fit the obj w/h in the shape pane keeping the obj ratio to fit
		ow = IIf(colshape.ContainsKey("width"), colshape.Get("width"), PFDCommon.SHAPE_SELECTOR_WIDTH)
		oh = IIf(colshape.ContainsKey("height"), colshape.Get("height"), PFDCommon.SHAPE_SELECTOR_HEIGHT)
		If oh > ih Then
			Dim f As Float = ih/oh
			oh = oh * f
			ow = ow * f
		End If
		If ow >= iw Then
			Dim f As Float = iw/ow
			oh = oh * f
			ow = ow * f
		End If
		
		'Set min width & height of the shape
		If ow <= PFDCommon.SHAPE_SELECTOR_MIN_WIDTH Then ow = PFDCommon.SHAPE_SELECTOR_MIN_WIDTH
		If oh <= PFDCommon.SHAPE_SELECTOR_MIN_HEIGHT Then oh = PFDCommon.SHAPE_SELECTOR_MIN_HEIGHT
		
		'Update the object pos&dimension
		obj.width			= ow
		obj.height 			= oh
		obj.centerx			= x
		obj.centery			= y
		
		'New row
		If i Mod CustomListViewShapes_ShapesPerRow == 0 Then
			y = (ycnt * ph) '+ (h/2)
			xcnt = 0
			ycnt = ycnt + 1
		End If
		x = (xcnt * pw) '+ (w/2)

		'Create the imageview to hold the object as image
		Dim iv As ImageView
		iv.Initialize("ImageEvent")
		iv.Tag = obj.pfdobject

		'Draw the object to an image using the dimensions set previous
		Dim bmp As B4XBitmap = PFDCommon.DrawObjectToImage(obj)

		'Set the objectimage to the imageview
		iv.SetImage(bmp)

		'Create the pane to hold the imageview.
		'The paneimage mouseclick event is used to add the image to the pfd drawing board
		Dim pnliv As Pane
		pnliv.Initialize("PaneImage")
		pnliv.Tag = iv.Tag
		pnliv.PrefWidth = pw
		pnliv.PrefHeight = ph
		pnliv.Style="-fx-background-color:#FFFFFF; -fx-border-color:#A9A9A9; -fx-border-radius:0.00;-fx-background-radius:0.00;-fx-border-width:0.5;"

		'Add the shape imageview to the imageview pane
		Dim ivl, ivt As Int
		ivl = (pw - ow)/2
		ivt = (ph - oh)/2
		pnliv.AddNode(iv, ivl, ivt, obj.width, obj.height)
		
		'Add the imageview pane to the pane holding the shape images
		pnlShapeImages.AddNode(pnliv, x, y, pw, ph)
		
		xcnt = xcnt + 1
		i = i + 1
	Next
	
	'Panel is collapsed
	p.Tag = False
	Return p
End Sub

'ShapeSelector handle image mouse click to add an image to the canvas at default pos as defined in pfdcreator.shp.
'Keep the bottom panel expanded using the flag isImageClicked.
Private Sub PaneImage_MouseClicked(EventData As MouseEvent)
	Dim p As Pane = Sender
	Dim iv As ImageView = p.GetNode(0)	'Sender
	Dim parser As JSONParser

	'Setthe global flag indicating the image pane is clicked	
	CustomListViewShapes_ImageClicked = True
	
	'Get the shapes from the external PFD type shapes.
	'Select the shape from the clv value
	Try
		'Load the shapes with its definition from external json file
		parser.Initialize(File.ReadString(File.DirApp, PFDCommon.SHAPES_FILE))
		'Get the array
		Dim jRoot As List = parser.NextArray
		'Loop over the shapes and get the type
		For Each coljRoot As Map In jRoot
			Dim shapes As List = coljRoot.Get("shapes")
			For Each colshape As Map In shapes
				If colshape.Get("pfdobject") == iv.Tag Then
				
					'Convert the PFD shape defintion to an PFD object
					Dim obj As TPFDObject = SetPFDShapeDefinitionToObject(colshape)
				
					'Add the object, set the object properties ui views and redraw.
					AddObject(obj)

					'Ensure to set drawmode to objects to move the object
					SetDrawModeState(DRAWMODE_OBJECTS, False)
				
					Return
				End If
			Next
		Next
	Catch
		PFDCommon.ShowMessage(PFDCommon.MSG_TYPE_ERROR, _
		                 	  "Add Shape", _ 
							  $"Can not read the external shapes file ${PFDCommon.SHAPES_FILE}.${CRLF}${LastException}"$)
	End Try
End Sub

Private Sub PaneImage_MouseEntered(EventData As MouseEvent)
	Dim p As Pane = Sender
	SetStatusbar($"Shape selector: ${p.tag}."$)
End Sub

'Handle clv item clicked.
Private Sub CustomListViewShapes_ItemClick (Index As Int, Value As Object)
	Dim p As B4XView = CustomListViewShapes.GetPanel(Index)
	
	If CustomListViewShapes_ImageClicked Then
		CustomListViewShapes_ImageClicked = False
		Return
	End If
	
	If p.Tag == True Then
		CustomListViewShapes_CollapseItem(Index)
	Else if p.Tag == False Then
		CustomListViewShapes_ExpandItem(Index)
	Else
		'Do nothing
	End If
End Sub

'Expand the item with shapes pane height set in the item value
Private Sub CustomListViewShapes_ExpandItem(index As Int)
	Dim value As Int = CustomListViewShapes.GetValue(index)
	CustomListViewShapes.ResizeItem(index, value)
	CustomListViewShapes.GetPanel(index).Tag = True
	CustomListViewShapes_AnimatedArrow(index, 0, 180)
End Sub

Private Sub CustomListViewShapes_AnimatedArrow(index As Int, From As Int, ToDegree As Int)
	pnlTitle = CustomListViewShapes.GetPanel(index).GetView(0) 'pnlTitle is the first item
	Dim iv As B4XView = pnlTitle.GetView(1) 'ImageView1 is the second item
	iv.SetRotationAnimated(0, From)
	iv.SetRotationAnimated(CustomListViewShapes.AnimationDuration, ToDegree)
End Sub

Private Sub CustomListViewShapes_CollapseItem(index As Int)
	CustomListViewShapes.ResizeItem(index, CustomListViewShapes_CollapsedHeight)
	CustomListViewShapes.GetPanel(index).Tag = False
	CustomListViewShapes_AnimatedArrow(index, 180, 0)
End Sub

Private Sub CustomListViewShapes_FindExpanded As Int 'ignore
	For i = 0 To CustomListViewShapes.GetSize - 1
		If CustomListViewShapes.GetPanel(i).Tag = True Then Return i
	Next
	Return -1
End Sub

'Clear all shapes from the clv.
Private Sub CustomListViewShapes_Clear
	CustomListViewShapes.Clear
End Sub
#End Region
