﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=10
@EndOfDesignText@
#Region Code Module Information
'Static Code Module: PFDCommon
'File: PFDCommon.bas
'Static code module for PFD Common constanst and objects which are drawn on the AsyncCanvas.
'
'PFDCreator Copyright see B4XMainPage.
#End Region

Sub Process_Globals
	'Core
	Private xui As XUI
	Private fx As JFX

	'Files located in the dirapp folder
	'Settings
	Public SETTINGS_FILE As String 				= "PFDCreator.set"
	'Shapes - define the shape types with the associated shapes
	Public SHAPES_FILE As String 				= "PFDCreator.shp"
	'Images folder for export all shapes as PNG image
	Public IMAGES_FOLDER As String				= "images"
	'Help BB Format
	Public HELP_FILE As String 					= "PFDCreator.hlp"

	'Fonts
	Public FONT_DEFAULT As String				= "DEFAULT"
	Public FONT_DEFAULT_BOLD As String			= "DEFAULTBOLD"
	Public FONT_DEFAULT_ITALIC As String		= "DEFAULTITALIC"
	Public FONT_DIGITAL As String				= "DIGITAL"
	'Add the fonts to the array because used by the object properties combobox to set the object font
	Public PFDFonts() As String = Array As String(FONT_DEFAULT, FONT_DEFAULT_BOLD, FONT_DEFAULT_ITALIC, FONT_DIGITAL)

	'Font Sizes
	Public FONT_LARGE_SIZE As Int				= 18
	Public FONT_DEFAULT_SIZE As Int				= 14
	Public FONT_SMALL_SIZE As Int				= 12
	Public FONT_VERY_SMALL_SIZE As Int			= 8

	'ISA-101 Colors (Recommendations)
	'PFD Background Color (Canvas) as HEX ARGB.
	Public COLOR_ISA101_BLACK As String			= "FF000000"	'R0,G0,B0
	Public COLOR_ISA101_WHITE As String			= "FFFFFFFF"	'R255,G255,B255
	Public COLOR_ISA101_LIGHTGREY224 As String	= "FFE0E0E0"	'R224,G224,B224
	Public COLOR_ISA101_SILVER192 As String		= "FFC0C0C0"	'R192,G192,B192
	
	'Object Defaults like Colors
	Public OBJECT_UNKNOWN As String 			= "UNKNOWN"
	Public OBJECT_FILLCOLOR As Int 				= xui.color_white
	Public OBJECT_BORDERCOLOR As Int 			= xui.color_black
	Public OBJECT_TEXTCOLOR As Int 				= xui.color_black
	Public OBJECT_STROKEWIDTH As Int 			= 2
	Public OBJECT_CORNERRADIUS As Int 			= 0
	Public OBJECT_SEPARATOR As Boolean 			= False
	Public OBJECT_OPERATE As Boolean 			= False

	'Object Context Menu (right mouse click object selected, show b4xlistdialog)
	Public CONTEXT_MENU_COPY As String			= "Copy"
	Public CONTEXT_MENU_PASTE As String			= "Paste"
	Public CONTEXT_MENU_CUT As String			= "Cut"
	Public OBJECT_CONTEXT_MENU() As String		= Array As String(CONTEXT_MENU_COPY,CONTEXT_MENU_PASTE,CONTEXT_MENU_CUT)

	'Object Tag or Index Indicator at canvas obj position
	Public OBJECT_INDICATOR_COLOR As Int		= xui.Color_Red
	Public OBJECT_INDICATOR_TEXTCOLOR As Int	= xui.Color_White	'use xui.color_red if circle not filled
	
	'Selection Line Color and Size
	Public SELECTION_LINE_COLOR As Int			= xui.Color_Blue	'Lightblue Color_RGB(173,216,230)
	Public SELECTION_LINE_SIZE As Int 			= 1

	'State Colors
	Public COLOR_STATE_DEFAULT As Int 			= xui.color_lightgray
	Public COLOR_ON As Int 						= xui.Color_Green
	Public COLOR_OFF As Int 					= xui.Color_Red
	Public COLOR_ERROR As Int 					= -23296					'Yellow = xui.Color_RGB(255,165,0)
	Public COLOR_UNKNOWN As Int 				= xui.Color_White			'xui.Color_Magenta
	Public COLOR_OPEN As Int 					= xui.Color_Green
	Public COLOR_CLOSED As Int 					= xui.Color_Red
	Public COLOR_RUNNING As Int 				= xui.Color_Green
	Public COLOR_STOPPED As Int 				= xui.Color_Red

	'Positions & Directions Text strings
	Public DIRECTION_NONE As String				= "NONE"
	Public DIRECTION_TOP As String				= "TOP"
	Public DIRECTION_BOTTOM As String			= "BOTTOM"
	Public DIRECTION_LEFT As String				= "LEFT"
	Public DIRECTION_RIGHT As String			= "RIGHT"
	Public DIRECTION_UP As String				= "UP"
	Public DIRECTION_DOWN As String				= "DOWN"
	Public DIRECTION_HORIZONTAL As String		= "HORIZONTAL"
	Public DIRECTION_HORIZONTAL_UP As String	= "HORIZONTALUP"
	Public DIRECTION_HORIZONTAL_DOWN As String	= "HORIZONTALDOWN"
	Public DIRECTION_VERTICAL As String			= "VERTICAL"
	Public DIRECTION_VERTICAL_LEFT As String	= "VERTICALLEFT"
	Public DIRECTION_VERTICAL_RIGHT As String	= "VERTICALRIGHT"
	'Add the directions to the array because used by the object properties combobox to set the object direction property
	Public PFDDirections() As String 			= Array As String(DIRECTION_NONE,DIRECTION_LEFT,DIRECTION_RIGHT,DIRECTION_TOP,DIRECTION_BOTTOM,DIRECTION_UP,DIRECTION_DOWN, _
													   			  DIRECTION_HORIZONTAL, DIRECTION_HORIZONTAL_UP, DIRECTION_HORIZONTAL_DOWN, _ 
													   			  DIRECTION_VERTICAL, DIRECTION_VERTICAL_LEFT, DIRECTION_VERTICAL_RIGHT)
	
	'Textalignment direction
	Public TEXT_ALIGNMENT_NONE As String		= ""
	Public TEXT_ALIGNMENT_LEFT As String		= "LEFT"
	Public TEXT_ALIGNMENT_CENTER As String		= "CENTER"
	Public TEXT_ALIGNMENT_RIGHT As String		= "RIGHT"
	Public PFDTextAlignments() As String 		= Array As String(TEXT_ALIGNMENT_LEFT,TEXT_ALIGNMENT_CENTER,TEXT_ALIGNMENT_RIGHT)

	'Grid
	Public GRID_SIZE As Int 					= 10
	Private GRID_LINE_COLOR As Int 				= xui.Color_LightGray
	Private GRID_LINE_COLOR_BOLD As Int 		= xui.Color_DarkGray	'ignore
	Private GRID_TEXT_COLOR As Int 				= xui.Color_DarkGray
	Private GRID_CROSS_COLOR As Int 			= xui.color_red
	Private GRID_CROSS_STROKE_WIDTH As Float 	= 0.5

	'Arrows
	Public ARROW_COLOR As Int 					= xui.color_black
	Public ARROW_WIDTH As Int 					= 10
	Public ARROW_HEIGHT As Int 					= 10
	Public ARROW_STROKE_WIDTH_FACTOR As Int 	= 6
	Public ARROW_STROKE_HEIGHT_FACTOR As Int 	= 6
	Public PFDArrowDirections() As String 		= Array As String(DIRECTION_NONE,DIRECTION_LEFT,DIRECTION_RIGHT,DIRECTION_UP,DIRECTION_DOWN)

	'Image
	'Special case to draw an image from fontawesome icon (see PFDShapesBasic DrawImage)
	Public IMAGE_FONTAWESOME_PREFIX As String 	= "fontawesome:"

	'Line
	Public LINE_SOLID_STROKE_WIDTH As Int 		= 2			'Can be changed by object properties w or h
	Public LINE_SOLID_COLOR As Int 				= xui.Color_Black
	Public LINE_DASHED_STROKE_WIDTH As Int 		= 2
	Public LINE_DASHED_COLOR As Int 			= xui.Color_White
	Public LINE_DASHED_DASH_LENGTH_MIN As Int 	= 2
	
	'Label
	Public LABEL_TEXT_COLOR As Int 				= xui.Color_Black
	
	'Textbox
	Public TEXTBOX_STROKE_WIDTH As Int 			= 2
	Public TEXTBOX_BORDER_COLOR As Int 			= xui.Color_Black
	Public TEXTBOX_TEXT_COLOR As Int 			= xui.Color_Black
	Public TEXTBOX_CONNECTOR_LENGTH As Int 		= 10

	'PFDObject Rectangles LeftTop,LeftBot,RightTop,RightBot
	'These are used for resizing the object via drag & drop
	Public PFDOBJECT_CORNERRECTSIZE As Int 		= 5
	Public PFDOBJECT_RECT_CENTER As Int 		= 0
	Public PFDOBJECT_RECT_TOPLEFT As Int 		= 1
	Public PFDOBJECT_RECT_BOTLEFT As Int 		= 2
	Public PFDOBJECT_RECT_TOPRIGHT As Int		= 3
	Public PFDOBJECT_RECT_BOTRIGHT As Int 		= 4
	
	'Shape Selector (PFDObjects) rect w&h of a shape (must fit within B4XMainPage CustomListViewShapes_ShapeHeightWidth with default 60)
	Public SHAPE_SELECTOR_SHAPES_PER_ROW As Int	= 4
	Public SHAPE_SELECTOR_WIDTH As Int 			= 40
	Public SHAPE_SELECTOR_HEIGHT As Int 		= SHAPE_SELECTOR_WIDTH
	Public SHAPE_SELECTOR_RECT_FACTOR As Float 	= 0.8
	Public SHAPE_SELECTOR_MIN_WIDTH As Int 		= 20					'Min width of a shape within the rectangle of the clv shapeselector
	Public SHAPE_SELECTOR_MIN_HEIGHT As Int 	= 20					'Min height ...

	'Messages
	Public MSG_TYPE_INFORMATION As Int = 1
	Public MSG_TYPE_WARNING As Int = 2
	Public MSG_TYPE_ERROR As Int = 3
	
	'Hints
	Public HINT_DRAWMODE As String = "Draw Mode: Off (change properties, drag&drop selected object disabled), Objects (change properties & drag&drop selected object enabled), Lines (draw horizontal&vertical lines with start&end point), Select (multiple objects)"
End Sub

#Region ShowMessage
Public Sub ShowMessage(msgtype As Int, title As String, msg As String)
	Select msgtype
		Case MSG_TYPE_INFORMATION:
			xui.Msgbox2Async(msg, title, "OK","","", Helper.FontAwesomeInformation(32))
		Case MSG_TYPE_WARNING:
			xui.Msgbox2Async(msg, $"[WARNING] ${title}"$, "OK","","", Helper.FontAwesomeWarning(32))
		Case MSG_TYPE_ERROR:
			xui.Msgbox2Async(msg, $"[ERROR] ${title}"$, "OK","","", Helper.FontAwesomeError(32))
		Case Else
			Log($"[ShowMessage] Unknown message type."$)
	End Select
End Sub
#End Region

#Region Font
'Set the font from the object font and fontsize.
Public Sub SetFont(obj As TPFDObject) As B4XFont
	Dim fnt As B4XFont
	
	'Check fontsize and set to default
	If obj.fontsize == 0 Then
		obj.fontsize = FONT_DEFAULT_SIZE
	End If
	
	'Select the font and create
	Select obj.font.ToUpperCase 
		Case FONT_DEFAULT
			fnt = xui.CreateDefaultFont(obj.fontsize)
		Case FONT_DEFAULT_BOLD
			fnt = xui.CreateDefaultBoldFont(obj.fontsize)
		Case FONT_DEFAULT_ITALIC
			fnt = Helper.CreateDefaultItalicFont(obj.fontsize)
		Case FONT_DIGITAL
			fnt = fx.LoadFont(File.DirAssets, "Digital.ttf", obj.fontsize)
		Case Else
			fnt = xui.CreateDefaultFont(FONT_DEFAULT_SIZE)
	End Select
	Return fnt
End Sub

'Set the font using font and fontsize.
'font - String as defined in the FONT_NAME constants
'fontsize - Int as defined in the FONT_SIZE constants
Public Sub SetFont2(font As String, fontsize As Int) As B4XFont
	Dim fnt As B4XFont
	
	'Check fontsize and set to default
	If fontsize == 0 Then
		fontsize = FONT_DEFAULT_SIZE
	End If
	
	'Select the font and create
	Select font.ToUpperCase 
		Case FONT_DEFAULT
			fnt = xui.CreateDefaultFont(fontsize)
		Case FONT_DEFAULT_BOLD
			fnt = xui.CreateDefaultBoldFont(fontsize)
		Case FONT_DEFAULT_ITALIC
			fnt = Helper.CreateDefaultItalicFont(fontsize)
		Case FONT_DIGITAL
			fnt = fx.LoadFont(File.DirAssets, "Digital.ttf", fontsize)
		Case Else
			fnt = xui.CreateDefaultFont(FONT_DEFAULT_SIZE)
	End Select
	Return fnt
End Sub

'Set the font with fontsize small from the object font and fontsize.
Public Sub SetFontSmall(obj As TPFDObject) As B4XFont
	Dim fnt As B4XFont
	
	Select obj.font.ToUpperCase 
		Case FONT_DEFAULT
			fnt = xui.CreateDefaultFont(FONT_SMALL_SIZE)
		Case FONT_DEFAULT_BOLD
			fnt = xui.CreateDefaultBoldFont(FONT_SMALL_SIZE)
		Case FONT_DEFAULT_ITALIC
			fnt = Helper.CreateDefaultItalicFont(FONT_SMALL_SIZE)
		Case FONT_DIGITAL
			fnt = fx.LoadFont(File.DirAssets, "Digital.ttf", FONT_SMALL_SIZE)
		Case Else
			fnt = xui.CreateDefaultFont(FONT_SMALL_SIZE)
	End Select
	Return fnt
End Sub

'Set the font with very small fontsize from the object font and fontsize.
Public Sub SetFontVerySmall(obj As TPFDObject) As B4XFont
	Dim fnt As B4XFont
	
	Select obj.font.ToUpperCase 
		Case FONT_DEFAULT
			fnt = xui.CreateDefaultFont(FONT_VERY_SMALL_SIZE)
		Case FONT_DEFAULT_BOLD
			fnt = xui.CreateDefaultBoldFont(FONT_VERY_SMALL_SIZE)
		Case FONT_DEFAULT_ITALIC
			fnt = Helper.CreateDefaultItalicFont(FONT_VERY_SMALL_SIZE)
		Case FONT_DIGITAL
			fnt = fx.LoadFont(File.DirAssets, "Digital.ttf", FONT_VERY_SMALL_SIZE)
		Case Else
			fnt = xui.CreateDefaultFont(FONT_VERY_SMALL_SIZE)
	End Select
	Return fnt
End Sub

'Set the fx font from the object font and fontsize.
Public Sub SetFontFX(obj As TPFDObject) As Font
	Dim fnt As Font
	Dim defaultfont As Font = fx.DefaultFont(12)
	
	'Check fontsize and set to default
	If obj.fontsize == 0 Then
		obj.fontsize = FONT_DEFAULT_SIZE
	End If
	
	'Select the font and create
	Select obj.font.ToUpperCase 
		Case FONT_DEFAULT
			fnt = fx.DefaultFont(obj.fontsize)
		Case FONT_DEFAULT_BOLD
			fnt = fx.CreateFont(defaultfont.FamilyName, obj.fontsize, True, False)
		Case FONT_DEFAULT_ITALIC
			fnt = fx.CreateFont(defaultfont.FamilyName, obj.fontsize, False, True)
		Case FONT_DIGITAL
			Dim fntdigital As B4XFont = fx.LoadFont(File.DirAssets, "Digital.ttf", obj.fontsize)
			fnt = fx.CreateFont(fntdigital.ToNativeFont.FamilyName, obj.fontsize, False, False)
		Case Else
			fnt = fx.DefaultFont(FONT_DEFAULT_SIZE)
	End Select
	Return fnt
End Sub

#End Region

#Region Drawing Board Grid
'Draw the grid on the PFD Drawing Board.
'The gridsize is defined as constant with size 10 (=rectangle 10x10 pixel).
'The scale uses small default font with size 12.
'Sleep is used to let the drawing complete.
Public Sub DrawGrid(cvs As AsyncCanvas, scale As Boolean)	
	Dim width As Int = cvs.TargetRect.Width
	Dim height As Int = cvs.TargetRect.Height
	Dim horlines As Int = Round(height / GRID_SIZE)
	Dim vertlines As Int = Round(width / GRID_SIZE)

	'Set the font
	Dim fnt As B4XFont
	fnt = xui.CreateDefaultFont(FONT_SMALL_SIZE)

	'Draw horizontal lines with scale text
	For i = 0 To horlines
		cvs.DrawLine(0, i * GRID_SIZE, width, i * GRID_SIZE, GRID_LINE_COLOR, 1)
		If scale Then
			If i Mod 5 == 0 And i > 0 Then
				'cvs.DrawLine(0, i * GRID_SIZE, GRID_SIZE/2, i * GRID_SIZE, GRID_LINE_COLOR_BOLD, 2)
				cvs.DrawText(i * GRID_SIZE, 5, i * GRID_SIZE + 4, fnt, GRID_TEXT_COLOR, "LEFT")
			End If
		End If
	Next

	'Draw vertical lines with scale text
	For j = 0 To vertlines
		cvs.DrawLine(j * GRID_SIZE, 0, j * GRID_SIZE, height, GRID_LINE_COLOR, 1)
		If scale Then
			If j Mod 5 == 0 And j > 0 Then
				'cvs.DrawLine(j * GRID_SIZE, 0, j * GRID_SIZE, GRID_SIZE/2, GRID_LINE_COLOR_BOLD, 2)
				cvs.DrawTextRotated(j * GRID_SIZE, j * GRID_SIZE - 4, 5, fnt, GRID_TEXT_COLOR, "LEFT", 90)
			End If
		End If
	Next

	'Commit the drawing
	cvs.Invalidate
End Sub

'Draw scale only without a full grid.
'Sleep is used to let the drawing complete.
Public Sub DrawScale(cvs As AsyncCanvas, position As String)
	Dim width As Int = cvs.TargetRect.Width
	Dim height As Int = cvs.TargetRect.Height
	Dim strokewidth As Int = 1
	Dim horlines As Int = Round(height / GRID_SIZE)
	Dim vertlines As Int = Round(width / GRID_SIZE)

	'Set the font
	Dim fnt As B4XFont
	fnt = xui.CreateDefaultFont(FONT_SMALL_SIZE)

	'Set scale width which is half grid size
	Dim scalewidth As Int = GRID_SIZE '/ 2
	Dim scaleheight As Int = GRID_SIZE '/ 2

	'Draw the horizontal scale at the top
	If position == "TOP" Then
		For j = 0 To vertlines
			If j Mod (scaleheight/2) == 0 And j > 0 Then
				cvs.DrawLine(j * GRID_SIZE, height, j * GRID_SIZE, height - scaleheight, GRID_LINE_COLOR_BOLD, strokewidth * 2)
				cvs.DrawTextRotated(j * GRID_SIZE, j * GRID_SIZE - 4, scaleheight, fnt, GRID_TEXT_COLOR, "LEFT", 90)
			Else
				cvs.DrawLine(j * GRID_SIZE, height, j * GRID_SIZE, height - scaleheight, GRID_LINE_COLOR, strokewidth)
			End If
		Next
	End If

	'Draw the vertical scale at the left
	If position == "LEFT" Then
		For i = 0 To horlines
			If i Mod (scalewidth/2) == 0 And i > 0 Then
				cvs.DrawLine(width, i * GRID_SIZE, width - scalewidth, i * GRID_SIZE, GRID_LINE_COLOR_BOLD, strokewidth * 2)
				cvs.DrawText(i * GRID_SIZE, scalewidth, i * GRID_SIZE + 4, fnt, GRID_TEXT_COLOR, "LEFT")
			Else
				cvs.DrawLine(width, i * GRID_SIZE, width - scalewidth, i * GRID_SIZE, GRID_LINE_COLOR, strokewidth)
			End If
		Next		
	End If
	
	'Commit the drawing
	cvs.Invalidate
End Sub

'Draw the object position indicator across the grid at the object center x,y position.
Public Sub DrawGridCross(cvs As AsyncCanvas, x As Int, y As Int, w As Int, h As Int)
	cvs.DrawLine(0, y, w, y, GRID_CROSS_COLOR, GRID_CROSS_STROKE_WIDTH)
	cvs.DrawLine(x, 0, x, h, GRID_CROSS_COLOR, GRID_CROSS_STROKE_WIDTH)
	cvs.DrawCircle(x,y,2,GRID_CROSS_COLOR,True,0)
	'Commit the drawing
	cvs.Invalidate
End Sub

'Draw a thin rectangle with 4 rectangle corners around an object.
'The corners are used to resize the object using the mouse.
'See PFDBase ResizeObjectTouched.
Public Sub DrawObjectSelected(cvs As AsyncCanvas, obj As TPFDObject)
	Dim rect As B4XRect
	'Offset of the rect from the object
	Dim offset As Int = 0

	'Draw the rect around the object
	rect.Initialize(obj.centerx - (obj.width/2) - offset, obj.centery - (obj.height/2) - offset, _
					obj.centerx + (obj.width/2) + offset, obj.centery + (obj.height/2) + offset)
	cvs.DrawRect(rect, SELECTION_LINE_COLOR, False, SELECTION_LINE_SIZE)

	'Draw the corner rect
	Dim x1,y1,x2,y2 As Int

	Dim recttopleft As B4XRect
	x1 = obj.centerx - (obj.width/2) - PFDOBJECT_CORNERRECTSIZE
	y1 = obj.centery - (obj.height/2) - PFDOBJECT_CORNERRECTSIZE
	x2 = x1 + (PFDOBJECT_CORNERRECTSIZE*2)
	y2 = y1 + (PFDOBJECT_CORNERRECTSIZE*2)
	recttopleft.Initialize(x1,y1,x2,y2)
	cvs.DrawRect(recttopleft, SELECTION_LINE_COLOR, False, SELECTION_LINE_SIZE)

	Dim rectbotleft As B4XRect
	x1 = obj.centerx - (obj.width/2) - PFDOBJECT_CORNERRECTSIZE
	y1 = obj.centery + (obj.height/2) - PFDOBJECT_CORNERRECTSIZE
	x2 = x1 + (PFDOBJECT_CORNERRECTSIZE*2)
	y2 = y1 + (PFDOBJECT_CORNERRECTSIZE*2)
	rectbotleft.Initialize(x1,y1,x2,y2)
	cvs.DrawRect(rectbotleft, SELECTION_LINE_COLOR, False, SELECTION_LINE_SIZE)

	Dim recttopright As B4XRect
	x1 = obj.centerx + (obj.width/2) - PFDOBJECT_CORNERRECTSIZE
	y1 = obj.centery - (obj.height/2) - PFDOBJECT_CORNERRECTSIZE
	x2 = x1 + (PFDOBJECT_CORNERRECTSIZE*2)
	y2 = y1 + (PFDOBJECT_CORNERRECTSIZE*2)
	recttopright.Initialize(x1,y1,x2,y2)
	cvs.DrawRect(recttopright, SELECTION_LINE_COLOR, False, SELECTION_LINE_SIZE)

	Dim rectbotright As B4XRect
	x1 = obj.centerx + (obj.width/2) - PFDOBJECT_CORNERRECTSIZE
	y1 = obj.centery + (obj.height/2) - PFDOBJECT_CORNERRECTSIZE
	x2 = x1 + (PFDOBJECT_CORNERRECTSIZE*2)
	y2 = y1 + (PFDOBJECT_CORNERRECTSIZE*2)
	rectbotright.Initialize(x1,y1,x2,y2)
	cvs.DrawRect(rectbotright, SELECTION_LINE_COLOR, False, SELECTION_LINE_SIZE)

	'Commit the drawing
	cvs.Invalidate
End Sub

'Draw a thin rectangle around an object selected.
Public Sub DrawObjectSelected2(cvs As AsyncCanvas, obj As TPFDObject)
	Dim rect As B4XRect
	Dim offset As Int = 4
	rect.Initialize(obj.centerx - (obj.width/2) - offset, obj.centery - (obj.height/2) - offset, _
					obj.centerx + (obj.width/2) + offset, obj.centery + (obj.height/2) + offset)
	cvs.DrawRect(rect, SELECTION_LINE_COLOR, False, SELECTION_LINE_SIZE)
	'Commit the drawing
	cvs.Invalidate
End Sub

'Draw a thin rectangle around an object selected with additional properties linecolor and strokewidth.
Public Sub DrawObjectSelectedOperate(cvs As AsyncCanvas, obj As TPFDObject, linecolor As Int, strokewidth As Float)
	Dim rect As B4XRect
	Dim offset As Int = 4
	rect.Initialize(obj.centerx - (obj.width/2) - offset, obj.centery - (obj.height/2) - offset, _
					obj.centerx + (obj.width/2) + offset, obj.centery + (obj.height/2) + offset)
	cvs.DrawRect(rect, linecolor, False, strokewidth)
	'Commit the drawing
	cvs.Invalidate
End Sub
'
''Draw a thin rectangle around an object selected with additional properties x1,y1,x2,y2,linecolor and strokewidth.
'Public Sub DrawObjectSelected3(cvs As AsyncCanvas, x1 As Int, y1 As Int, x2 As Int, y2 As Int, linecolor As Int, strokewidth As Float)
'	Dim rect As B4XRect
'	rect.Initialize(x1,y1,x2,y2)
'	cvs.DrawRect(rect, linecolor, False, strokewidth)
'	'Commit the drawing
'	cvs.Invalidate
'End Sub
#End Region

#Region OBJECTTAG
'Draw the object value below the object.
Public Sub DrawValue(cvs As AsyncCanvas, obj As TPFDObject)
	Dim fnt As B4XFont = SetFont(obj)
	Dim fntrect As B4XRect = cvs.MeasureText(obj.value, fnt)
	'Check text alignment
	If obj.textalignment == TEXT_ALIGNMENT_NONE Then obj.textalignment = TEXT_ALIGNMENT_CENTER
	'Draw the text
	cvs.DrawText(obj.value, obj.centerx, obj.centery + (obj.height/2) + (fntrect.height * 2), fnt, obj.textcolor, obj.textalignment)
End Sub

'Draw the object tag below the object.
Public Sub DrawTag(cvs As AsyncCanvas, obj As TPFDObject)
	'Set the font
	Dim fnt As B4XFont = SetFont(obj)
	Dim fntrect As B4XRect = cvs.MeasureText(obj.tag, fnt)
	'Check text alignment
	If obj.textalignment == TEXT_ALIGNMENT_NONE Then obj.textalignment = TEXT_ALIGNMENT_CENTER
	'Draw the text
	cvs.DrawText(obj.tag, obj.centerx, obj.centery + (obj.height/2) + (fntrect.height * 2), fnt, obj.textcolor, obj.textalignment)
End Sub

'Draw the object tag in the object middle.
Public Sub DrawTag2(cvs As AsyncCanvas, obj As TPFDObject)
	'Set the font
	Dim fnt As B4XFont = SetFont(obj)
	'Check text alignment
	If obj.textalignment == TEXT_ALIGNMENT_NONE Then obj.textalignment = TEXT_ALIGNMENT_CENTER

	'Only show the tag if there is a tag
	If obj.tag.Length > 0 Then
		Dim recttag As B4XRect = cvs.MeasureText(obj.tag, fnt)
		Dim oxtag As Int = obj.centerx
		Dim oytag As Int = obj.centery + (recttag.height/2)
		Dim strtag As String = obj.tag
		If recttag.Width > obj.width Then
			strtag = strtag.Replace(" ", CRLF)
			oxtag = obj.centerx
			oytag = obj.centery - (recttag.height/2)
		End If
		cvs.DrawText(strtag, oxtag, oytag, fnt, obj.bordercolor, obj.textalignment)
	End If
End Sub

'Draw the object tag + value below the object.
Public Sub DrawTagValue(cvs As AsyncCanvas, obj As TPFDObject)
	Dim x,y As Int
	Dim offset As Int = 4

	'Set the font
	Dim fnt As B4XFont = SetFont(obj)
	Dim fntrect As B4XRect = cvs.MeasureText(obj.tag, fnt)

	'Check text alignment
	If obj.textalignment == TEXT_ALIGNMENT_NONE Then obj.textalignment = TEXT_ALIGNMENT_CENTER
	
	x = obj.centerx
	y = obj.centery + (obj.height/2) + fntrect.height + offset
	cvs.DrawText(obj.tag, x, y, fnt, obj.textcolor, obj.textalignment)
	
	If obj.value.Length > 0 Then
		x = x
		y = y + fntrect.height + offset
		cvs.DrawText($"${obj.value}${obj.unit}"$, x, y, fnt, obj.textcolor, obj.textalignment)
	End If
End Sub

'Draw the object value+unit below the object.
Public Sub DrawValueUnit(cvs As AsyncCanvas, obj As TPFDObject)
	'Set the font
	Dim fnt As B4XFont = SetFont(obj)
	Dim fntrect As B4XRect = cvs.MeasureText(obj.value, fnt)
	cvs.DrawText($"${obj.value}${obj.unit}"$, obj.centerx, obj.centery + (obj.height/2) + fntrect.height, fnt, obj.textcolor, obj.textalignment)
End Sub

'Draw the object value+unit below the object in 2 lines.
Public Sub DrawValueUnit2(cvs As AsyncCanvas, obj As TPFDObject)
	Dim x, y As Int
	Dim offset As Int = 4

	'Set the font
	Dim fnt As B4XFont = SetFont(obj)
	Dim fntrect As B4XRect = cvs.MeasureText(obj.value, fnt)

	'Check text alignment
	If obj.textalignment == TEXT_ALIGNMENT_NONE Then obj.textalignment = TEXT_ALIGNMENT_CENTER
	'Draw the text

	x = obj.centerx
	y = obj.centery + (obj.height/2) + fntrect.height
	cvs.DrawText($"${obj.value}"$, x, y, fnt, obj.textcolor, obj.textalignment)
	x = x
	y = y + fntrect.height + offset
	cvs.DrawText($"${obj.value}"$, x, y, fnt, obj.textcolor, obj.textalignment)
End Sub

'Draw the value in the object centered.
Public Sub DrawValueInObject(cvs As AsyncCanvas, obj As TPFDObject)
	Dim cx, cy As Int
	Dim degrees As Int
	
	'Set the font
	Dim fnt As B4XFont = SetFont(obj)
	Dim fntrect As B4XRect = cvs.MeasureText("A", fnt)
	
	'Check text alignment and adjust cx and set cy
	cx = obj.centerx
	cy = obj.centery
	Select obj.textalignment
		Case TEXT_ALIGNMENT_NONE
			obj.textalignment = TEXT_ALIGNMENT_CENTER
		Case TEXT_ALIGNMENT_LEFT
			cx = cx - (obj.width/2) + 2dip
		Case TEXT_ALIGNMENT_RIGHT
			cx = cx + (obj.width/2) - 2dip
	End Select

	'Set the text rotation angle
	If obj.direction == DIRECTION_NONE Or _
	   obj.direction == DIRECTION_HORIZONTAL Then
		degrees = 0
	Else if obj.direction == DIRECTION_VERTICAL Then
		degrees = 90
	Else if obj.direction == DIRECTION_UP Then
		degrees = 90
	Else if obj.direction == DIRECTION_DOWN Then
		degrees = -90
	Else
		degrees = 0
	End If

	'Wrap the obj value into text and linecnt
	If obj.value.Length > 0 Then
		'Log($"objtag=${obj.tag},objvalue=${obj.value}objchars=${obj.value.As(String).length},objwidth=${obj.width},fntrectwidth=${fntrect.Width},charsperline=${Round(obj.width/fntrect.Width)}"$)

		Dim m As Map = Helper.StringWrap2(obj.value, Round(obj.width/fntrect.Width) )

		Dim linecnt As Int = m.Get("cnt")
	
		'Adjust centery depending linecnt
		If linecnt > 1 Then
			'cy = obj.centery - ( (linecnt * fntrect.height) / 2)
			cy = obj.centery - ( (linecnt * Round(fntrect.height)) / 2 ) + (Round(fntrect.height) / 2)
		Else
			cy = obj.centery + ( (linecnt * fntrect.height) / 2)
		End If
	
		'Draw the wrapped text rotated
		cvs.DrawTextRotated(m.Get("text"), cx, cy, fnt, obj.textcolor, obj.textalignment, degrees)
	End If
End Sub

'Draw the value in the object centered with cx,cy,degrees instead obj.centerx,y, direction.
Public Sub DrawValueInObject2(cvs As AsyncCanvas, obj As TPFDObject, cx As Int, cy As Int, degrees As Float)
	
	'Set the font
	Dim fnt As B4XFont = SetFont(obj)
	Dim fntrect As B4XRect = cvs.MeasureText("A", fnt)
	
	'Check text alignment and adjust cx and set cy
	Select obj.textalignment
		Case TEXT_ALIGNMENT_NONE
			obj.textalignment = TEXT_ALIGNMENT_CENTER
		Case TEXT_ALIGNMENT_LEFT
			cx = cx - (obj.width/2)
		Case TEXT_ALIGNMENT_RIGHT
			cx = cx + (obj.width/2)
	End Select

	'Wrap the obj value into text and linecnt
	Dim m As Map = Helper.StringWrap2(obj.value, Round(obj.width/fntrect.Width) )
	Dim linecnt As Int = m.Get("cnt")
	
	'Adjust centery depending linecnt
	If linecnt > 1 Then
		cy = cy - ( (linecnt * Round(fntrect.height)) / 2 ) + (Round(fntrect.height) / 2)
	Else
		cy = cy + ( (linecnt * fntrect.height) / 2)
	End If
	
	'Draw the wrapped text rotated
	cvs.DrawTextRotated(m.Get("text"), cx, cy, fnt, obj.textcolor, obj.textalignment, degrees)
End Sub

'Draw the value below the object centered.
Public Sub DrawValueBelowObject(cvs As AsyncCanvas, obj As TPFDObject)
	Dim cx, cy As Int
	Dim degrees As Int
	
	'Set the font
	Dim fnt As B4XFont = SetFont(obj)
	Dim fntrect As B4XRect = cvs.MeasureText("A", fnt)
	
	'Check text alignment and adjust cx and set cy
	cx = obj.centerx
	cy = obj.centery
	Select obj.textalignment
		Case TEXT_ALIGNMENT_NONE
			obj.textalignment = TEXT_ALIGNMENT_CENTER
		Case TEXT_ALIGNMENT_LEFT
			cx = cx - (obj.width/2)
		Case TEXT_ALIGNMENT_RIGHT
			cx = cx + (obj.width/2)
	End Select

	'Set the text rotation angle
	If obj.direction == DIRECTION_NONE Or _
	   obj.direction == DIRECTION_HORIZONTAL Then
		degrees = 0
	Else if obj.direction == DIRECTION_VERTICAL Then
		degrees = 90
	Else if obj.direction == DIRECTION_UP Then
		degrees = 90
	Else if obj.direction == DIRECTION_DOWN Then
		degrees = -90
	Else
		degrees = 0
	End If

	'Wrap the obj value into text and linecnt
	Dim m As Map = Helper.StringWrap2(obj.value, Round(obj.width/fntrect.Width) )
	Dim linecnt As Int = m.Get("cnt")
	
	'Adjust centery depending linecnt
	If linecnt > 1 Then
		'cy = obj.centery - ( (linecnt * fntrect.height) / 2)
		cy = obj.centery - ( (linecnt * Round(fntrect.height)) / 2 ) + (Round(fntrect.height) / 2)
	Else
		cy = obj.centery + ( (linecnt * fntrect.height) / 2)
	End If
	cy = cy + (obj.height/2) + fnt.size
	
	'Draw the wrapped text rotated
	cvs.DrawTextRotated(m.Get("text"), cx, cy, fnt, obj.textcolor, obj.textalignment, degrees)
End Sub
#End Region

#Region DrawObjectInPanel
'Draw an object inside a panel by creating a canvas inside the panel.
'Ensure to set the size properly.
'The panel coordinates:
'left = obj.centerx - (obj.width/2) and top = obj.centery - (obj.height/2)
'obj.pfdtype = "OVAL"	
'obj.centerx = 40, obj.centery = 30, obj.width = 80, obj.height = 40
'DrawObjectInPanel(pnlImages, obj)
Public Sub DrawObjectInPanel(pnl As B4XView, obj As TPFDObject)
	Dim cvs As AsyncCanvas
	Dim l, t, h, w As Int

	'Get the canvas dimension
	l = obj.centerx - (obj.width/2)
	t = obj.centery - (obj.height/2)
	w = obj.width
	h = obj.height
	
	'Create the canvas to hold the shape
	cvs.Initialize(pnl, l, t, w, h)

	'Adjust the obj centerx & y to fit in cvs
	obj.centerx = w/2
	obj.centery = h/2

	'Draw the shape
	'Need to go over all shapes because need to find the drawing method based on the pfdobject, i.e. OVAL
	PFDShapesBasic.DrawShape(cvs, obj)
	PFDShapesFlowchart.DrawShape(cvs, obj)
	PFDShapesPID.DrawShape(cvs, obj)
	PFDShapesElectrical.DrawShape(cvs, obj)
	
	'Optional draw check
	'DrawCheckRect(cvs, obj)

	'Commit the drawing - this must be done here because of the canvas created
	cvs.Invalidate
End Sub
#End Region

#Region DrawObjectToImage
'Draw an object to a rendered image using snapshot.
'Steps:
'Create a pane with object size.
'Create a canvas with pane as parent.
'Draw the object.
'Return the image snapshot.
Public Sub DrawObjectToImage(obj As TPFDObject) As Image
	'Declare a pane object to hold the canvas to create the obj image
	Dim pnl As Pane
	'Declare canvas object to hold the obj as image
	Dim cvs As AsyncCanvas
	Dim l, t, h, w As Int

	'Get the canvas dimension
	l = obj.centerx - (obj.width/2)
	t = obj.centery - (obj.height/2)
	w = obj.width
	h = obj.height

	'Init the pane to hold the canvas	
	pnl.Initialize("")
	
	'Create the canvas to hold the shape in the pane
	cvs.Initialize(pnl, l, t, w, h)

	'Adjust the obj centerx & y to fit in cvs
	obj.centerx = w/2
	obj.centery = h/2

	'Draw the shape
	'Go over all shapes because need to find the drawing method based on the pfdobject, i.e. OVAL
	PFDShapesBasic.DrawShape(cvs, obj)
	PFDShapesFlowchart.DrawShape(cvs, obj)
	PFDShapesPID.DrawShape(cvs, obj)
	PFDShapesElectrical.DrawShape(cvs, obj)

	'Draw the additional check rect (red 0.5 border)
	'DrawCheck(cvs, obj)

	'Commit the drawing - this must be done here because of the canvas created
	cvs.Invalidate
	
	Return cvs.GetNativeCanvas.Snapshot
End Sub
#End Region

#Region RotatePoint
'Rotate a point x,y around center x,y.
'x,y - Start coordinates of the point. This could be for example a line.
'centerX, centerY - Center coordinates of the point used for the rotation.
'angleDegrees - Angle to rotate the point.
'Return - Map with the new point coordinates x,y.
Public Sub RotatePoint(x As Float, y As Float, centerX As Float, centerY As Float, angleDegrees As Float) As Map
	Dim angleRadians As Float = angleDegrees * cPI / 180 ' Convert to radians
	Dim cosTheta As Float = Cos(angleRadians)
	Dim sinTheta As Float = Sin(angleRadians)
    
	Dim newX As Float = cosTheta * (x - centerX) - sinTheta * (y - centerY) + centerX
	Dim newY As Float = sinTheta * (x - centerX) + cosTheta * (y - centerY) + centerY
    
	Dim result As Map
	result.Initialize
	result.Put("x", newX)
	result.Put("y", newY)
	Return result
End Sub
#End Region

#Region Draw PFDTypes
Public Sub DrawPFDLine(cvs As AsyncCanvas, line As TPFDLine)
	cvs.DrawLine(line.x1, line.y1, line.x2, line.y2, line.fillcolor, line.strokewidth)
End Sub

Public Sub DrawPFDArrow(cvs As AsyncCanvas, arrow As TPFDArrow)
	'Create a base arrow with direction left.
	'  2
	' /|
	'1 |
	' \|
	'  3
	Dim path As B4XPath
	Dim degrees As Int = 0
	
	'1
	path.Initialize(arrow.cx - (arrow.w/2), arrow.cy)
	'2
	path.LineTo(arrow.cx + (arrow.w/2), arrow.cy - (arrow.h/2))
	'3
	path.LineTo(arrow.cx + (arrow.w/2), arrow.cy + (arrow.h/2))
	'4=1
	path.LineTo(arrow.cx - (arrow.w/2), arrow.cy)
	Select arrow.direction
		Case DIRECTION_LEFT
			degrees = 0
		Case DIRECTION_RIGHT
			degrees = 180
		Case DIRECTION_DOWN
			degrees = -90
		Case DIRECTION_UP
			degrees = 90
		Case Else
			degrees = 0
	End Select
	cvs.DrawPathRotated(path, arrow.fillcolor, True, 0, degrees, arrow.cx, arrow.cy)
End Sub
#End Region

#Region TextAsImage
'Draw text as image using object properties
Private Sub DrawTextAsImage(cvs As AsyncCanvas, obj As TPFDObject, text As String)
	'Declare a pane object to hold the canvas to create the obj image
	Dim pnl As Pane
	'Declare canvas object to hold the obj as image
	Dim cvsImage As AsyncCanvas
	Dim l, t, h, w As Int
	Dim degrees As Int = 0
	
	'Set the font
	Dim fnt As B4XFont		= SetFont(obj)
	Dim fntrect As B4XRect	= cvs.MeasureText(text, fnt)

	l = 0
	t = 0
	w = fntrect.Width + 2dip
	h = fntrect.Height

	'Init the pane to hold the canvas
	pnl.Initialize("")
	
	'Create the canvas to hold the shape in the pane
	cvsImage.Initialize(pnl, l, t, w, h)

	'Draw the text
	cvsImage.DrawTextRotated(text, w/2, h, fnt, obj.textcolor, obj.textalignment, degrees)

	'Commit the drawing - this must be done here because of the canvas created
	cvsImage.Invalidate
	
	Dim img As Image = cvsImage.GetNativeCanvas.Snapshot
	
	'Set the canvas dimension using the font rect
	Dim rect As B4XRect
	rect.Initialize(obj.centerx - (w/2), obj.centery - (h/2), _
	                obj.centerx + (w/2), obj.centery + (h/2))
	cvs.DrawBitmap(img, rect)
End Sub

'Draw the object value as image.
Public Sub DrawValueAsImage(cvs As AsyncCanvas, obj As TPFDObject)
	DrawTextAsImage(cvs, obj, obj.value)
End Sub

'Draw the object unit as image.
Public Sub DrawUnitAsImage(cvs As AsyncCanvas, obj As TPFDObject)
	DrawTextAsImage(cvs, obj, obj.unit)
End Sub
#End Region

#Region Checks
'Draw a red rectangle with strokewidth 0.5 around the shape to see if fits withing object width and height.
'Example<code>
'PFDCommon.DrawCheckRect(cvs, obj)
'</code>
Public Sub DrawCheckRect(cvs As AsyncCanvas, obj As TPFDObject)
	Dim rect As B4XRect
	Dim x1 As Float = obj.centerx - (obj.width/2)
	Dim y1 As Float = obj.centery - (obj.height/2)
	Dim x2 As Float = obj.centerx + (obj.width/2)
	Dim y2 As Float = obj.centery + (obj.height/2)
	Dim cx As Float = obj.centerx
	Dim cy As Float = obj.centery
	
	rect.Initialize(x1,y1,x2,y2)
	cvs.DrawRect(rect, xui.Color_Red, False, 0.5)

	Log($"DrawCheckRect: ${obj.tag}, cx=${cx}, cy=${cy}, x1=${x1}, y1=${y1}, x2=${x2}, y2=${y2}, w=${obj.width}, h=${obj.height}"$)
End Sub

'Draw a red rotated rectangle with strokewidth 0.5 around the shape to see if fits withing object width and height.
'The rotation degrees is set by the obj.value 0-360.
'Example<code>
'PFDCommon.DrawCheckRect(cvs, obj)
'</code>
Public Sub DrawCheckRectRotated(cvs As AsyncCanvas, obj As TPFDObject)
	Dim rect As B4XRect
	Dim x1 As Float = obj.centerx - (obj.width/2)
	Dim y1 As Float = obj.centery - (obj.height/2)
	Dim x2 As Float = obj.centerx + (obj.width/2)
	Dim y2 As Float = obj.centery + (obj.height/2)
	Dim cx As Float = obj.centerx
	Dim cy As Float = obj.centery
	Dim degrees As Int = 0
	'Set rotation degrees
	If Helper.ValueIsNumber(obj.value) Then
		degrees = obj.value
	End If
	
	rect.Initialize(x1,y1,x2,y2)
	cvs.DrawRectRotated(rect, xui.Color_Red, False, 0.5,degrees)
	'cvs.DrawRect(rect, xui.Color_Red, False, 0.5)

	Log($"DrawCheckRectRotated: ${obj.tag}, cx=${cx}, cy=${cy}, x1=${x1}, y1=${y1}, x2=${x2}, y2=${y2}, w=${obj.width}, h=${obj.height}, degrees=${obj.value}"$)
End Sub

'Draw a red pixel with radius 4 at obj centerx,y.
'Example<code>
'PFDCommon.DrawCheckPixel(cvs, obj)
'</code>
Public Sub DrawCheckPixel(cvs As AsyncCanvas, obj As TPFDObject)
	cvs.DrawPixel2(obj.centerx,obj.centery,xui.Color_Red,4)
End Sub

'Draw red text size 14 with the obj value @ obj centerx,y.
'Example<code>
'PFDCommon.DrawCheckValue(cvs, obj)
'</code>
Public Sub DrawCheckValue(cvs As AsyncCanvas, obj As TPFDObject)
	cvs.DrawText(obj.value,obj.centerx, obj.centery + 20,xui.CreateDefaultFont(14),xui.color_red, "CENTER")
End Sub

'Draw the obj index as text @ top right of the object.
Public Sub DrawIndexAtObject(cvs As AsyncCanvas, obj As TPFDObject)
	Dim x,y,r As Float
	Dim offset As Int = 10
	
	'Dim fnt As B4XFont = xui.CreateDefaultFont(FONT_VERY_SMALL_SIZE)
	Dim fnt As B4XFont = xui.CreateDefaultBoldFont(FONT_SMALL_SIZE)
	Dim fntrect As B4XRect = cvs.MeasureText(obj.index, fnt)

	'Set the index indicator circle radius
	r = (fntrect.Width/2) + (offset/2)

	'Set the index indicator at center x,y position
	x = obj.centerx
	y = obj.centery

'	'Set the index indicator center position at top left of the object rectangle
'	'To set centered below the object use x = obj.centerx; y = obj.centery + (obj.height/2) + offset
'	'Adjust x,y if out of grid range
'	x = obj.centerx + (obj.width/2)
'	If x <= 0 Then x = r * 2
'	If x >= cvs.Width Then x = cvs.Width - (r * 2)
'
'	y = obj.centery - (obj.height/2) - offset
'	If y <= 0 Then y = r * 2
'	If y >= cvs.Height Then x = cvs.Height - (r * 2)
	
	'Draw the circle and index text
	cvs.DrawCircle(x, y, r, OBJECT_INDICATOR_COLOR, True, 1)
	cvs.DrawText(obj.index, x, y + (fntrect.Height/2), fnt, OBJECT_INDICATOR_TEXTCOLOR, TEXT_ALIGNMENT_CENTER)

	'Option to draw the circle not filled
	'cvs.DrawCircle(x, y, r, OBJECT_INDICATOR_COLOR, False, 1)
	'cvs.DrawText(obj.index, x, y + (fntrect.Height/2), fnt, OBJECT_INDICATOR_TEXTCOLOR, TEXT_ALIGNMENT_CENTER)
End Sub

'Draw for all objects the object index (as circle with index) at object position.
'The drawings are committed on the canvas.
Public Sub DrawIndex(cvs As AsyncCanvas, objects As List)
	For Each obj As TPFDObject In objects
		DrawIndexAtObject(cvs, obj)
	Next
	cvs.Invalidate
End Sub

'Draw the obj tag as text below the object.
Public Sub DrawTagAtObject(cvs As AsyncCanvas, obj As TPFDObject)
	'Dim fnt As B4XFont = xui.CreateDefaultFont(FONT_VERY_SMALL_SIZE)
	Dim fnt As B4XFont = xui.CreateDefaultFont(FONT_SMALL_SIZE)
	cvs.DrawText(obj.tag,obj.centerx, obj.centery + (obj.height/2) + 10, fnt, OBJECT_INDICATOR_COLOR, TEXT_ALIGNMENT_CENTER)
End Sub
#End Region
