﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=10
@EndOfDesignText@
#Region DrawCode Module Information
'Static Code Module: PFDShapesPID
'File: PFDShapesPID.bas
'Static code module for the PFD basic shapes.
'Steps for adding an shape:
'Add the PFD basic shape to the Process Globals.
'Example: Public BASIC_SHAPE_ARROW As String = "ARROW"
'Add the module Draw<SHAPE> with mandatory arguments cvs and obj to draw the shape on the PFD Drawing Board.
'Example: Public Sub DrawArrow(cvs As AsyncCanvas, obj As TPFDObject)	
'Add the object to the method Draw.
'Example:
'Case PID_OBJECT_BOILER:
'	DrawBoiler(cvs, pfdobject)
'Add the object to the shapes definition file pid.shp.
'
'PFDCreator Copyright see B4XMainPage.
#End Region

Sub Process_Globals
	'Core
	Private xui As XUI

	'PFD Basic Shapes (in uppercase)
	Public BASIC_SHAPE_MYSHAPE As String				= "MYSHAPE"

	Public BASIC_SHAPE_ARROW As String					= "ARROW"
	Public BASIC_SHAPE_CIRCLE As String					= "CIRCLE"
	Public BASIC_SHAPE_CONNECTORLLINE As String			= "CONNECTORLLINE"
	Public BASIC_SHAPE_CONNECTORULINE As String			= "CONNECTORULINE"
	Public BASIC_SHAPE_CONNECTORZLINE As String			= "CONNECTORZLINE"
	Public BASIC_SHAPE_IMAGE As String					= "IMAGE"
	Public BASIC_SHAPE_LABEL As String					= "LABEL"
	Public BASIC_SHAPE_LINE_DASHED As String			= "LINEDASHED"
	Public BASIC_SHAPE_LINE_ROTATED As String			= "LINEROTATED"
	Public BASIC_SHAPE_LINE_ROTATED_ARROW As String		= "LINEROTATEDARROW"
	Public BASIC_SHAPE_LINE_SOLID As String				= "LINESOLID"
	Public BASIC_SHAPE_OVAL As String					= "OVAL"
	Public BASIC_SHAPE_PANE As String					= "PANE"
	Public BASIC_SHAPE_PATH As String					= "PATH"
	Public BASIC_SHAPE_PIXEL As String					= "PIXEL"
	Public BASIC_SHAPE_RECTANGLE As String				= "RECTANGLE"
	Public BASIC_SHAPE_TEXTARROW As String				= "TEXTARROW"
	Public BASIC_SHAPE_TEXTBOX As String				= "TEXTBOX"
	Public BASIC_SHAPE_VALUEUNIT As String				= "VALUEUNIT"
End Sub

#Region DrawShape
'Draw shape(s) selected from pfdobjects list.
'The shapes are defined as process_globals.
Public Sub DrawShapesFromList(cvs As AsyncCanvas, pfdobjects As List)
	'Loop over the pfd objects and draw the object shape 
	For Each pfdobject As TPFDObject In pfdobjects
		DrawShape(cvs, pfdobject)
	Next
End Sub

'Draw a shape by shape type as defined in process_globals.
Public Sub DrawShape(cvs As AsyncCanvas, obj As TPFDObject)
	'Select Type
	Select obj.pfdobject
		Case BASIC_SHAPE_MYSHAPE:
			DrawMyShape(cvs, obj)
		Case BASIC_SHAPE_ARROW:
			DrawArrow(cvs, obj)
		Case BASIC_SHAPE_CIRCLE:
			DrawCircle(cvs, obj)
		Case BASIC_SHAPE_CONNECTORLLINE:
			DrawConnectorLLine(cvs, obj)
		Case BASIC_SHAPE_CONNECTORULINE:
			DrawConnectorULine(cvs, obj)
		Case BASIC_SHAPE_CONNECTORZLINE:
			DrawConnectorZLine(cvs, obj)
		Case BASIC_SHAPE_IMAGE:
			DrawImage(cvs, obj)
		Case BASIC_SHAPE_LABEL:
			DrawLabel(cvs, obj)
		Case BASIC_SHAPE_LINE_DASHED:
			DrawLineDashed(cvs, obj)
		Case BASIC_SHAPE_LINE_ROTATED:
			DrawLineRotated(cvs, obj)
		Case BASIC_SHAPE_LINE_ROTATED_ARROW:
			DrawLineRotatedArrow(cvs, obj)
		Case BASIC_SHAPE_LINE_SOLID:
			DrawLineSolid(cvs, obj)
		Case BASIC_SHAPE_OVAL:
			DrawOval(cvs, obj)
		Case BASIC_SHAPE_PANE:
			DrawPane(cvs, obj)
		Case BASIC_SHAPE_PATH:
			DrawPath(cvs, obj)
		Case BASIC_SHAPE_PIXEL:
			DrawPixel(cvs, obj)
		Case BASIC_SHAPE_RECTANGLE:
			DrawRectangle(cvs, obj)
		Case BASIC_SHAPE_TEXTARROW:
			DrawTextArrow(cvs, obj)
		Case BASIC_SHAPE_TEXTBOX:
			DrawTextbox(cvs, obj)
		Case BASIC_SHAPE_VALUEUNIT:
			DrawValueUnit(cvs, obj)
	End Select
End Sub
#End Region

#Region MyShape
'MyShape
'Base Rectangle: width=70.0,height=40.0
'Note: resizing the shape might not work properly - this will require manual code change.
Public Sub DrawMyShape(cvs As AsyncCanvas, obj As TPFDObject)
	Dim obj3 As TPFDObject
	obj3.initialize
	obj3.arrow = "NONE"
	obj3.bordercolor = -16777216 'FF000000
	obj3.centerx = obj.centerx - (20.0)
	obj3.centery = obj.centery - (0.0)
	obj3.cornerradius = 0
	obj3.description = "Solid line"
	obj3.direction = "HORIZONTAL"
	obj3.fillcolor = -16776961 'FF0000FF
	obj3.font = "DEFAULT"
	obj3.fontsize = 12
	obj3.height = obj.height * 0.05 '2.0
	obj3.image = ""
	obj3.operate = False
	obj3.pfdobject = "LINESOLID"
	obj3.separator = False
	obj3.strokewidth = 2
	obj3.tag = "LSD-1"
	obj3.textalignment = "CENTER"
	obj3.textcolor = -16777216 'FF000000
	obj3.unit = ""
	obj3.value = ""
	obj3.width = obj.width * 0.42857143 '30.0
	obj3.x1 = obj3.centerx - (obj3.width / 2)
	obj3.y1 = obj3.centery - (obj3.height / 2)
	obj3.x2 = obj3.centerx + (obj3.width / 2)
	obj3.y2 = obj3.centery + (obj3.height / 2)
	DrawLineSolid(cvs, obj3)

	Dim obj4 As TPFDObject
	obj4.initialize
	obj4.arrow = "NONE"
	obj4.bordercolor = -16777216 'FF000000
	obj4.centerx = obj.centerx - (5.0)
	obj4.centery = obj.centery - (0.0)
	obj4.cornerradius = 0
	obj4.description = "Solid line"
	obj4.direction = "VERTICAL"
	obj4.fillcolor = -16776961 'FF0000FF
	obj4.font = "DEFAULT"
	obj4.fontsize = 12
	obj4.height = obj.height * 0.75 '30.0
	obj4.image = ""
	obj4.operate = False
	obj4.pfdobject = "LINESOLID"
	obj4.separator = False
	obj4.strokewidth = 2
	obj4.tag = "LSD-2"
	obj4.textalignment = "CENTER"
	obj4.textcolor = -16777216 'FF000000
	obj4.unit = ""
	obj4.value = ""
	obj4.width = obj.width * 0.028571429 '2.0
	obj4.x1 = obj4.centerx - (obj4.width / 2)
	obj4.y1 = obj4.centery - (obj4.height / 2)
	obj4.x2 = obj4.centerx + (obj4.width / 2)
	obj4.y2 = obj4.centery + (obj4.height / 2)
	DrawLineSolid(cvs, obj4)

	Dim obj5 As TPFDObject
	obj5.initialize
	obj5.arrow = "NONE"
	obj5.bordercolor = -16777216 'FF000000
	obj5.centerx = obj.centerx - (-5.0)
	obj5.centery = obj.centery - (0.0)
	obj5.cornerradius = 0
	obj5.description = "Solid line"
	obj5.direction = "VERTICAL"
	obj5.fillcolor = -16777216 'FF000000
	obj5.font = "DEFAULT"
	obj5.fontsize = 12
	obj5.height = obj.height * 0.375 '15.0
	obj5.image = ""
	obj5.operate = False
	obj5.pfdobject = "LINESOLID"
	obj5.separator = False
	obj5.strokewidth = 2
	obj5.tag = "LSD-3"
	obj5.textalignment = "CENTER"
	obj5.textcolor = -16777216 'FF000000
	obj5.unit = ""
	obj5.value = ""
	obj5.width = obj.width * 0.028571429 '2.0
	obj5.x1 = obj5.centerx - (obj5.width / 2)
	obj5.y1 = obj5.centery - (obj5.height / 2)
	obj5.x2 = obj5.centerx + (obj5.width / 2)
	obj5.y2 = obj5.centery + (obj5.height / 2)
	DrawLineSolid(cvs, obj5)

	Dim obj6 As TPFDObject
	obj6.initialize
	obj6.arrow = "NONE"
	obj6.bordercolor = -16777216 'FF000000
	obj6.centerx = obj.centerx - (-20.0)
	obj6.centery = obj.centery - (0.0)
	obj6.cornerradius = 0
	obj6.description = "Solid line"
	obj6.direction = "HORIZONTAL"
	obj6.fillcolor = -16777216 'FF000000
	obj6.font = "DEFAULT"
	obj6.fontsize = 12
	obj6.height = obj.height * 0.05 '2.0
	obj6.image = ""
	obj6.operate = False
	obj6.pfdobject = "LINESOLID"
	obj6.separator = False
	obj6.strokewidth = 2
	obj6.tag = "LSD-4"
	obj6.textalignment = "CENTER"
	obj6.textcolor = -16777216 'FF000000
	obj6.unit = ""
	obj6.value = ""
	obj6.width = obj.width * 0.42857143 '30.0
	obj6.x1 = obj6.centerx - (obj6.width / 2)
	obj6.y1 = obj6.centery - (obj6.height / 2)
	obj6.x2 = obj6.centerx + (obj6.width / 2)
	obj6.y2 = obj6.centery + (obj6.height / 2)
	DrawLineSolid(cvs, obj6)

	'Commit the drawing is done in method ReDraw in PFDBase.
	'cvs.Invalidate
End Sub
#End Region

#Region DrawArrow
'Draw an arrow direction left,right,up,down with bordercolor and fillcolor.
'Properties:direction,centerx,centery,width,height,fillcolor,bordercolor,strokewidth
Public Sub DrawArrow(cvs As AsyncCanvas, obj As TPFDObject)
	Dim x, y As Int
	Dim path As B4XPath
	Dim degrees As Int
	Dim textalignment As String = PFDCommon.TEXT_ALIGNMENT_CENTER
	Dim cx As Float = obj.centerx
	Dim cy As Float = obj.centery

	'Check if there is a direction else set to left
	If obj.direction == PFDCommon.DIRECTION_NONE Then
		obj.direction = PFDCommon.DIRECTION_RIGHT
	End If
	
	'Create a base arrow with direction right.
	'MidRight
	x = obj.centerx + (obj.width / 2)
	y = obj.centery
	path.Initialize(x, y)
	'TopLeft
	path.LineTo(x - obj.width, y - (obj.height/2))
	'BottomLeft
	path.LineTo(x - obj.width, y + (obj.height/2))
	'MidLeft
	path.LineTo(x, y)

	'Set the font
	Dim fnt As B4XFont = PFDCommon.SetFont(obj)
	Dim fntrect As B4XRect = cvs.MeasureText(obj.value, fnt)
	Dim fh As Float = fntrect.Height/2

	'Select the direction, set the angle degrees and adjust cx or cy.
	Select obj.direction
		Case PFDCommon.DIRECTION_RIGHT
			degrees = 0
			cx = cx - fh
			cy = cy + fh
		Case PFDCommon.DIRECTION_LEFT
			degrees = 180
			cy = cy + fh
		Case PFDCommon.DIRECTION_DOWN
			degrees = 90
			cx = cx - fh
			cy = cy - fh
		Case PFDCommon.DIRECTION_UP
			degrees = -90
			cx = cx + fh
			cy = cy + fh
	End Select

	'Draw the inner shape
	cvs.DrawPathRotated(path, obj.fillcolor, True, 0, degrees, obj.centerx, obj.centery)
	'Draw the outer shape
	cvs.DrawPathRotated(path, obj.bordercolor, False, obj.strokewidth, degrees, obj.centerx, obj.centery)

	'Draw the value in object
	'Adjust the degrees for direction left else text is upside down.
	If degrees == 180 Then degrees = 0
	cvs.DrawTextRotated(obj.value, cx, cy, fnt, obj.textcolor, textalignment, degrees)

	'Commit the drawing is done in method ReDraw in PFDBase.
	'cvs.Invalidate
End Sub

'Draw an arrow with arguments given.
Public Sub DrawArrow2(cvs As AsyncCanvas, centerx As Int, centery As Int, w As Int, h As Int, direction As String, color As Int)
	Dim obj As TPFDObject
	obj.Initialize
	obj.centerx = centerx
	obj.centery = centery
	obj.width = w
	obj.height = h
	obj.bordercolor = color
	obj.fillcolor = color
	obj.strokewidth = 2
	obj.direction = direction
	DrawArrow(cvs, obj)
End Sub

'Draw a solid rotated arrow including line.
'The object value sets the arrow angle in degrees. This depnds on the arrow direction.
'If arrow direction is up, the line starts at bottom left and goes up if angle is -45, or down if angle 45.
'If arrow direction is down, the line starts at top right and goes down if angle is 135.
'Example object properties for arrow direction up right: direction=direction_up,centerx=200,centery=200,width=50,height=width,value=-45, strokewidth=2,fillcolor=xui.Color_Black
Public Sub DrawArrowSolidRotated(cvs As AsyncCanvas, obj As TPFDObject)
	'x As Float, y As Float, length As Float, angle As Float, color As Int)
	
	'Set the angle from the object value
	Dim angle As Float = obj.value
	' Convert angle to radians for trigonometric functions
	Dim rad As Float = angle * cPI / 180
    
	'Set the length of the line + arrow from the object width
	Dim length As Float = Sqrt(Power(obj.width,2) + Power(obj.height,2))

	'Check if there is a direction else set to up
	If obj.direction == PFDCommon.DIRECTION_NONE Then
		obj.direction = PFDCommon.DIRECTION_UP
	End If

	'Set the starting position of the line
	If obj.direction = PFDCommon.DIRECTION_UP Then
		Dim x As Float = obj.centerx - (obj.width/2) '- (obj.width * 0.1)
		Dim y As Float = obj.centery + (obj.height/2) '- (obj.height * 0.1)
	End If
	
	If obj.direction = PFDCommon.DIRECTION_DOWN Then
		Dim x As Float = obj.centerx + (obj.width/2) '- (obj.width * 0.1)
		Dim y As Float = obj.centery - (obj.height/2) '- (obj.height * 0.1)
	End If
	
	' Calculate the end point of the arrow line
	Dim xEnd As Float = x + length * Cos(rad)
	Dim yEnd As Float = y + length * Sin(rad)
    
	' Calculate the points for the arrowhead
	Dim arrowSize As Float = length * obj.strokewidth / 10	'0.3
	Dim arrowAngle As Float = 30 * cPI / 180  ' 30 degrees for arrowhead angle
    
	Dim xLeft As Float = xEnd - arrowSize * Cos(rad - arrowAngle)
	Dim yLeft As Float = yEnd - arrowSize * Sin(rad - arrowAngle)
    
	Dim xRight As Float = xEnd - arrowSize * Cos(rad + arrowAngle)
	Dim yRight As Float = yEnd - arrowSize * Sin(rad + arrowAngle)
    
	' Initialize the path for the arrow
	Dim path As B4XPath
	path.Initialize(x, y)
    
	' Draw the arrow shaft
	path.LineTo(xEnd, yEnd)
    
	' Draw the arrowhead
	path.LineTo(xLeft, yLeft)
	path.LineTo(xRight, yRight)
	path.LineTo(xEnd, yEnd)
    
	' Close the path to form the solid arrow shape
	path.LineTo(x, y)
    
	' Draw the filled arrow on the canvas
	cvs.DrawPath(path, obj.fillcolor, True, obj.strokewidth)  ' The 'True' parameter fills the path
    
	' Optionally, draw the outline of the arrow for better visibility
	'cvs.DrawPath(path, xui.color_Black, False, 3dip)

	' Draw the main arrow line
	cvs.DrawLine(x, y, xEnd, yEnd, obj.fillcolor, obj.strokewidth)

	'Commit the drawing is done in method ReDraw in PFDBase.
	'cvs.Invalidate
End Sub
#End Region

#Region DrawCicle
'Draw an circle with text inside.
'Properties: centerx,centery,width,bordercolor,strokewidth,value,font,fontsize.
'Notes: Set height=width.
Public Sub DrawCircle(cvs As AsyncCanvas, obj As TPFDObject)
	Dim x,y As Int
	Dim r As Float

	'Set the center pos and the radius
	x = obj.centerx
	y = obj.centery
	r = (obj.width - obj.strokewidth)/2
	
	'Draw the inner shape
	cvs.DrawCircle(x, y, r, obj.fillcolor, True, 0)
	'Draw the outer shape
	If obj.strokewidth > 0 Then cvs.DrawCircle(x, y, r, obj.bordercolor, False, obj.strokewidth)		

	'Draw the text inside the circle
	PFDCommon.DrawValueInObject(cvs,obj)
		
	'Draw the optional connector
	DrawConnector(cvs, obj)

	'Check Obj Rect
	'PFDCommon.DrawCheck(cvs, obj)

	'Commit the drawing is done in method ReDraw in PFDBase.
	'cvs.Invalidate
End Sub
#End Region

#Region DrawConnector
'Draw a connector at object direction which is a line with gridsize length.
Public Sub DrawConnector(cvs As AsyncCanvas, obj As TPFDObject)
	Dim x1,y1,x2,y2 As Int
	
	'Check the direction and set the start/end coordinates
	If obj.direction <> PFDCommon.DIRECTION_NONE Then
		'Set the connector line properties
		If obj.direction == PFDCommon.DIRECTION_TOP Then
			x1 = obj.centerx
			x2 = x1
			y1 = obj.centery - (obj.height / 2)
			y2 = y1 - PFDCommon.GRID_SIZE
		End If
		If obj.direction == PFDCommon.DIRECTION_BOTTOM Then
			x1 = obj.centerx
			x2 = x1
			y1 = obj.centery + (obj.height / 2)
			y2 = y1 + PFDCommon.GRID_SIZE
		End If
		If obj.direction == PFDCommon.DIRECTION_LEFT Then
			x1 = obj.centerx - (obj.width / 2)
			x2 = x1 - PFDCommon.GRID_SIZE
			y1 = obj.centery
			y2 = y1
		End If
		If obj.direction == PFDCommon.DIRECTION_RIGHT Then
			x1 = obj.centerx + (obj.width / 2)
			x2 = x1 + PFDCommon.GRID_SIZE
			y1 = obj.centery
			y2 = y1
		End If
		'Draw the connector line
		cvs.DrawLine(x1, y1, x2, y2, obj.bordercolor, obj.strokewidth)
	End If

	'Commit the drawing is done in method ReDraw in PFDBase.
	'cvs.Invalidate
End Sub

#Region DrawConnectorLLine
'Draw a connector line between 2 objects.
'The connector has 2 lines (line1,line2), L-form, with 4 directions left, right, up, down.
'Optional an arrow can be set depending direction:
'direction left=arrow left,down; right=arrow right,down; up=arrow up,right; down=up,left.
'Properties: width, height, value, fillcolor, strokewidth, arrow.
Public Sub DrawConnectorLLine(cvs As AsyncCanvas, obj As TPFDObject)
	Dim cx As Float = obj.centerx
	Dim cy As Float = obj.centery
	Dim w As Float = obj.width
	Dim w2 As Float = w / 2
	Dim h As Float = obj.height
	Dim h2 As Float = h / 2
	Dim aw As Float = obj.strokewidth * PFDCommon.ARROW_STROKE_WIDTH_FACTOR
	Dim aw2 As Float = aw / 2
	Dim ah As Float = obj.strokewidth * PFDCommon.ARROW_STROKE_HEIGHT_FACTOR
	Dim ah2 As Float = ah / 2
	Dim sw As Float = obj.strokewidth
	Dim sw2 As Float = sw / 2
	
	Dim line1 As TPFDLine
	Dim line2 As TPFDLine
	Dim arrow As TPFDArrow

	'Init lines
	line1.Initialize
	line2.Initialize

	'Adjust obj w&h to fit within shape selector
	If obj.shapeselector == obj.pfdobject Then
		w = PFDCommon.SHAPE_SELECTOR_WIDTH * PFDCommon.SHAPE_SELECTOR_RECT_FACTOR
		h = PFDCommon.SHAPE_SELECTOR_HEIGHT * PFDCommon.SHAPE_SELECTOR_RECT_FACTOR
		w2 = w/2
		h2 = h/2
	End If
	
	Select obj.direction
		Case PFDCommon.DIRECTION_LEFT
			'1--2
			'   |
			'   |
			'   3
			'Arrow LEFT or DOWN
			line1.x1 = cx - w2
			line1.y1 = cy - h2
			line1.x2 = line1.x1 + w
			line1.y2 = line1.y1
			line1.fillcolor = obj.fillcolor
			line1.strokewidth = obj.strokewidth
			If obj.arrow == PFDCommon.DIRECTION_LEFT Then
				arrow.Initialize
				arrow.cx = line1.x1 + aw2
				arrow.cy = line1.y1
				arrow.w = aw
				arrow.h = ah
				arrow.fillcolor = obj.fillcolor
				arrow.direction = PFDCommon.DIRECTION_LEFT
				PFDCommon.DrawPFDArrow(cvs, arrow)
				line1.x1 = line1.x1 + aw - aw2
			End If

			line2.x1 = line1.x2
			line2.y1 = line1.y2 - sw2
			line2.x2 = line2.x1
			line2.y2 = line2.y1 + h + sw2
			line2.fillcolor = obj.fillcolor
			line2.strokewidth = obj.strokewidth
			If obj.arrow == PFDCommon.DIRECTION_DOWN Then
				arrow.Initialize
				arrow.cx = line2.x2
				arrow.cy = line2.y2 - ah2
				arrow.w = aw
				arrow.h = ah
				arrow.fillcolor = obj.fillcolor
				arrow.direction = PFDCommon.DIRECTION_DOWN
				PFDCommon.DrawPFDArrow(cvs, arrow)
				line2.y2 = line2.y2 - ah + ah2
			End If
			
		Case PFDCommon.DIRECTION_RIGHT
			'2--1
			'|
			'|
			'3
			'Arrow RIGHT or DOWN
			line1.x1 = cx + w2
			line1.y1 = cy - h2
			line1.x2 = line1.x1 - w
			line1.y2 = line1.y1
			line1.fillcolor = obj.fillcolor
			line1.strokewidth = obj.strokewidth
			If obj.arrow == PFDCommon.DIRECTION_RIGHT Then
				arrow.Initialize
				arrow.cx = line1.x1 - aw2
				arrow.cy = line1.y1
				arrow.w = aw
				arrow.h = ah
				arrow.fillcolor = obj.fillcolor
				arrow.direction = PFDCommon.DIRECTION_RIGHT
				PFDCommon.DrawPFDArrow(cvs, arrow)
				line1.x1 = line1.x1 - aw + aw2
			End If

			line2.x1 = line1.x2
			line2.y1 = line1.y1 - sw2
			line2.x2 = line2.x1
			line2.y2 = line2.y1 + h + sw2
			line2.fillcolor = obj.fillcolor
			line2.strokewidth = obj.strokewidth
			If obj.arrow == PFDCommon.DIRECTION_DOWN Then
				arrow.Initialize
				arrow.cx = line2.x2
				arrow.cy = line2.y2 - aw2
				arrow.w = aw
				arrow.h = ah
				arrow.fillcolor = obj.fillcolor
				arrow.direction = obj.arrow
				PFDCommon.DrawPFDArrow(cvs, arrow)
				line2.y2 = line2.y2 - ah + ah2
			End If

		Case PFDCommon.DIRECTION_UP
			'1
			'|
			'|
			'2--3
			'Arrow UP or RIGHT
			line1.x1 = cx - w2
			line1.y1 = cy - h2
			line1.x2 = line1.x1
			line1.y2 = line1.y1 + h
			line1.fillcolor = obj.fillcolor
			line1.strokewidth = obj.strokewidth
			If obj.arrow == PFDCommon.DIRECTION_UP Then
				arrow.Initialize
				arrow.cx = line1.x1
				arrow.cy = line1.y1 + ah2
				arrow.w = aw
				arrow.h = ah
				arrow.fillcolor = obj.fillcolor
				arrow.direction = PFDCommon.DIRECTION_UP
				PFDCommon.DrawPFDArrow(cvs, arrow)
				line1.y1 = line1.y1 + ah - ah2
			End If

			line2.x1 = line1.x2 - sw2
			line2.y1 = line1.y2
			line2.x2 = line2.x1 + w + sw2
			line2.y2 = line2.y1
			line2.fillcolor = obj.fillcolor
			line2.strokewidth = obj.strokewidth
			If obj.arrow == PFDCommon.DIRECTION_RIGHT Then
				arrow.Initialize
				arrow.cx = line2.x2 - aw2
				arrow.cy = line2.y2
				arrow.w = aw
				arrow.h = ah
				arrow.fillcolor = obj.fillcolor
				arrow.direction = PFDCommon.DIRECTION_RIGHT
				PFDCommon.DrawPFDArrow(cvs, arrow)
				line2.x2 = line2.x2 - aw + aw2
			End If

		Case PFDCommon.DIRECTION_DOWN
			'   1
			'   |
			'   |
			'3--2
			'Arrow UP or LEFT
			line1.x1 = cx + w2
			line1.y1 = cy - h2
			line1.x2 = line1.x1
			line1.y2 = line1.y1 + h
			line1.fillcolor = obj.fillcolor
			line1.strokewidth = obj.strokewidth
			If obj.arrow == PFDCommon.DIRECTION_UP Then
				arrow.Initialize
				arrow.cx = line1.x1
				arrow.cy = line1.y1 + ah2
				arrow.w = aw
				arrow.h = ah
				arrow.fillcolor = obj.fillcolor
				arrow.direction = PFDCommon.DIRECTION_UP
				PFDCommon.DrawPFDArrow(cvs, arrow)
				line1.y1 = line1.y1 + ah - ah2
			End If

			line2.x1 = line1.x2 + sw2
			line2.y1 = line1.y2
			line2.x2 = line2.x1 - w - sw2
			line2.y2 = line2.y1
			line2.fillcolor = obj.fillcolor
			line2.strokewidth = obj.strokewidth
			If obj.arrow == PFDCommon.DIRECTION_LEFT Then
				arrow.Initialize
				arrow.cx = line2.x2 + aw2
				arrow.cy = line2.y2
				arrow.w = aw
				arrow.h = ah
				arrow.fillcolor = obj.fillcolor
				arrow.direction = PFDCommon.DIRECTION_LEFT
				PFDCommon.DrawPFDArrow(cvs, arrow)
				line2.x2 = line2.x2 + aw - aw2
			End If
	End Select

	PFDCommon.DrawPFDLine(cvs, line1)
	PFDCommon.DrawPFDLine(cvs, line2)

	'PFDCommon.DrawCheckRect(cvs, obj)
	'PFDCommon.DrawCheckPixel(cvs, obj)
End Sub
#End Region

#Region DrawConnectorULine
'Draw a connector line U-form between 2 objects.
'The connector has 3 lines (vert+hor+vert) in U-form, with directions left, right, up or down.
'The arrow can be set depending U direction left=up,down, right=up,down, down=left,right, up=left,right.
'Properties: width, height, value, fillcolor, strokewidth, arrow (LEFT,RIGHT), direction.
Private Sub DrawConnectorULine(cvs As AsyncCanvas, obj As TPFDObject)
	Dim cx As Float = obj.centerx
	Dim cy As Float = obj.centery
	Dim w As Float = obj.width
	Dim w2 As Float = w / 2
	Dim h As Float = obj.height
	Dim h2 As Float = h / 2
	Dim aw As Float = obj.strokewidth * PFDCommon.ARROW_STROKE_WIDTH_FACTOR
	Dim aw2 As Float = aw / 2
	Dim ah As Float = obj.strokewidth * PFDCommon.ARROW_STROKE_HEIGHT_FACTOR
	Dim ah2 As Float = ah / 2
	Dim sw As Float = obj.strokewidth
	Dim sw2 As Float = sw / 2
	
	Dim line1 As TPFDLine
	Dim line2 As TPFDLine
	Dim line3 As TPFDLine
	Dim arrow As TPFDArrow

	'Init lines
	line1.Initialize
	line2.Initialize
	line3.Initialize

	'Adjust obj w&h to fit within shape selector
	If obj.shapeselector == obj.pfdobject Then
		w = PFDCommon.SHAPE_SELECTOR_WIDTH * PFDCommon.SHAPE_SELECTOR_RECT_FACTOR
		h = PFDCommon.SHAPE_SELECTOR_HEIGHT * PFDCommon.SHAPE_SELECTOR_RECT_FACTOR
		w2 = w/2
		h2 = h/2
	End If
	
	Select obj.direction
		Case PFDCommon.DIRECTION_LEFT
			'1--2
			'   |
			'   |
			'4--3
			'Arrow UP or DOWN
			line1.x1 = cx - w2
			line1.y1 = cy - h2
			line1.x2 = line1.x1 + w
			line1.y2 = line1.y1
			line1.fillcolor = obj.fillcolor
			line1.strokewidth = obj.strokewidth
			If obj.arrow == PFDCommon.DIRECTION_UP Then
				line1.x1 = line1.x1 + aw - aw2
				arrow.Initialize
				arrow.cx = line1.x1
				arrow.cy = line1.y1
				arrow.w = aw
				arrow.h = ah
				arrow.fillcolor = obj.fillcolor
				arrow.direction = PFDCommon.DIRECTION_LEFT
				PFDCommon.DrawPFDArrow(cvs, arrow)
			End If

			line2.x1 = line1.x2
			line2.y1 = line1.y2 - sw2
			line2.x2 = line2.x1
			line2.y2 = line2.y1 + h + sw
			line2.fillcolor = obj.fillcolor
			line2.strokewidth = obj.strokewidth
			
			line3.x1 = line2.x2
			line3.y1 = line2.y2 - sw2
			line3.x2 = line3.x1 - w
			line3.y2 = line3.y1
			line3.fillcolor = obj.fillcolor
			line3.strokewidth = obj.strokewidth
			If obj.arrow == PFDCommon.DIRECTION_DOWN Then
				line3.x2 = line3.x2 + aw
				arrow.Initialize
				arrow.cx = line3.x2 - aw2
				arrow.cy = line3.y2
				arrow.w = aw
				arrow.h = ah
				arrow.fillcolor = obj.fillcolor
				arrow.direction = PFDCommon.DIRECTION_LEFT
				PFDCommon.DrawPFDArrow(cvs, arrow)
			End If
			
		Case PFDCommon.DIRECTION_RIGHT
			'2--1
			'|
			'|
			'3--4
			'Arrow UP or DOWN
			line1.x1 = cx + w2
			line1.y1 = cy - h2
			line1.x2 = line1.x1 - w
			line1.y2 = line1.y1
			line1.fillcolor = obj.fillcolor
			line1.strokewidth = obj.strokewidth
			If obj.arrow == PFDCommon.DIRECTION_UP Then
				line1.x1 = line1.x1 - aw + aw2
				arrow.Initialize
				arrow.cx = line1.x1
				arrow.cy = line1.y1
				arrow.w = aw
				arrow.h = ah
				arrow.fillcolor = obj.fillcolor
				arrow.direction = PFDCommon.DIRECTION_RIGHT
				PFDCommon.DrawPFDArrow(cvs, arrow)
			End If

			line2.x1 = line1.x2
			line2.y1 = line1.y2 - sw2
			line2.x2 = line2.x1
			line2.y2 = line2.y1 + h + sw
			line2.fillcolor = obj.fillcolor
			line2.strokewidth = obj.strokewidth
			
			line3.x1 = line2.x2
			line3.y1 = line2.y2 - sw2
			line3.x2 = line3.x1 + w
			line3.y2 = line3.y1
			line3.fillcolor = obj.fillcolor
			line3.strokewidth = obj.strokewidth
			If obj.arrow == PFDCommon.DIRECTION_DOWN Then
				line3.x2 = line3.x2 - aw
				arrow.Initialize
				arrow.cx = line3.x2 + aw2
				arrow.cy = line3.y2
				arrow.w = aw
				arrow.h = ah
				arrow.fillcolor = obj.fillcolor
				arrow.direction = PFDCommon.DIRECTION_RIGHT
				PFDCommon.DrawPFDArrow(cvs, arrow)
			End If

		Case PFDCommon.DIRECTION_UP
			'1  4
			'|  |
			'2--3
			'Arrow UP
			line1.x1 = cx - w2
			line1.y1 = cy - h2
			line1.x2 = line1.x1
			line1.y2 = line1.y1 + h + sw2
			line1.fillcolor = obj.fillcolor
			line1.strokewidth = obj.strokewidth
			If obj.arrow == PFDCommon.DIRECTION_LEFT Then
				line1.y1 = line1.y1 + ah - ah2
				arrow.Initialize
				arrow.cx = line1.x1
				arrow.cy = line1.y1 - ah2
				arrow.w = aw
				arrow.h = ah
				arrow.fillcolor = obj.fillcolor
				arrow.direction = PFDCommon.DIRECTION_UP
				PFDCommon.DrawPFDArrow(cvs, arrow)
			End If

			line2.x1 = line1.x2
			line2.y1 = line1.y2 - sw2
			line2.x2 = line2.x1 + w
			line2.y2 = line2.y1
			line2.fillcolor = obj.fillcolor
			line2.strokewidth = obj.strokewidth
			
			line3.x1 = line2.x2
			line3.y1 = line2.y2 + sw2
			line3.x2 = line3.x1
			line3.y2 = line3.y1 - h - sw2
			line3.fillcolor = obj.fillcolor
			line3.strokewidth = obj.strokewidth
			If obj.arrow == PFDCommon.DIRECTION_RIGHT Then
				line3.y2 = line3.y2 + ah - ah2
				arrow.Initialize
				arrow.cx = line3.x1
				arrow.cy = line3.y2
				arrow.w = aw
				arrow.h = ah
				arrow.fillcolor = obj.fillcolor
				arrow.direction = PFDCommon.DIRECTION_UP
				PFDCommon.DrawPFDArrow(cvs, arrow)
			End If

		Case PFDCommon.DIRECTION_DOWN
			'2--3
			'|  |
			'1  4
			'Arrow UP
			line1.x1 = cx - w2
			line1.y1 = cy + h2
			line1.x2 = line1.x1
			line1.y2 = line1.y1 - h - sw2
			line1.fillcolor = obj.fillcolor
			line1.strokewidth = obj.strokewidth
			If obj.arrow == PFDCommon.DIRECTION_LEFT Then
				arrow.Initialize
				arrow.cx = line1.x1
				arrow.cy = line1.y1 - ah2
				arrow.w = aw
				arrow.h = ah
				arrow.fillcolor = obj.fillcolor
				arrow.direction = PFDCommon.DIRECTION_DOWN
				PFDCommon.DrawPFDArrow(cvs, arrow)
				line1.y1 = line1.y1 - ah + ah2
			End If

			line2.x1 = line1.x2 - sw2
			line2.y1 = line1.y2
			line2.x2 = line2.x1 + w + sw2
			line2.y2 = line2.y1
			line2.fillcolor = obj.fillcolor
			line2.strokewidth = obj.strokewidth
			
			line3.x1 = line2.x2
			line3.y1 = line2.y2 - sw2
			line3.x2 = line3.x1
			line3.y2 = line3.y1 + h + sw
			line3.fillcolor = obj.fillcolor
			line3.strokewidth = obj.strokewidth
			If obj.arrow == PFDCommon.DIRECTION_RIGHT Then
				arrow.Initialize
				arrow.cx = line3.x2
				arrow.cy = line3.y2 - ah2
				arrow.w = aw
				arrow.h = ah
				arrow.fillcolor = obj.fillcolor
				arrow.direction = PFDCommon.DIRECTION_DOWN
				PFDCommon.DrawPFDArrow(cvs, arrow)
				line3.y2 = line3.y2 - ah + ah2
			End If

	End Select

	PFDCommon.DrawPFDLine(cvs, line1)
	PFDCommon.DrawPFDLine(cvs, line2)
	PFDCommon.DrawPFDLine(cvs, line3)

	'PFDCommon.DrawCheckRect(cvs, obj)
	'PFDCommon.DrawCheckPixel(cvs, obj)
End Sub
#End Region

#Region DrawConnectorZLine
'Draw a connector line Z-form between 2 objects.
'The connector has 3 lines in Z-form, with direction up or down.
'Properties: width, height, value, fillcolor, strokewidth, arrow.
Public Sub DrawConnectorZLine(cvs As AsyncCanvas, obj As TPFDObject)
	'Rect shape topxy, botxy
	Dim x1,y1,x2,y2 As Int
	'Shape Width & Height
	Dim w As Float = obj.width
	Dim h As Float = obj.height
	'Line Width & Height
	Dim lw As Float = obj.width/2
	Dim lh As Float = obj.height/2
	'Arrow
	Dim aw As Float = obj.strokewidth * PFDCommon.ARROW_STROKE_WIDTH_FACTOR
	Dim ah As Float = obj.strokewidth * PFDCommon.ARROW_STROKE_HEIGHT_FACTOR

	'Check direction set	
	If obj.direction == PFDCommon.DIRECTION_NONE Then
		obj.direction = PFDCommon.DIRECTION_DOWN
	End If

	'Adjust obj w&h to fit within shape selector
	If obj.shapeselector == obj.pfdobject Then
		w = PFDCommon.SHAPE_SELECTOR_WIDTH * PFDCommon.SHAPE_SELECTOR_RECT_FACTOR
		h = PFDCommon.SHAPE_SELECTOR_HEIGHT * PFDCommon.SHAPE_SELECTOR_RECT_FACTOR
		lw = w/2
		lh = h/2
	End If

	'Direction Down with 3 lines hor + vert down + hor
	'-+
	' |
	' +-
	If obj.direction == PFDCommon.DIRECTION_DOWN Then
		'TopLeft to TopMid
		x1 = obj.centerx - (w/2)
		y1 = obj.centery - (h/2)
		x2 = x1 + lw
		y2 = y1
		cvs.DrawLine(x1,y1,x2,y2,obj.fillcolor,obj.strokewidth)

		'TopMid to BotMid
		x1 = x2
		y1 = y2
		x2 = x1
		y2 = y2 + (lh*2)
		cvs.DrawLine(x1,y1,x2,y2,obj.fillcolor,obj.strokewidth)

		'BotMid to BotRight
		x1 = x2
		y1 = y2
		x2 = x1 + lw
		y2 = y1
		cvs.DrawLine(x1,y1,x2,y2,obj.fillcolor,obj.strokewidth)

		'Arrow
		Select obj.arrow
			Case PFDCommon.DIRECTION_RIGHT
				DrawArrow2(cvs, x2 - (aw/2), y2, aw, ah, PFDCommon.DIRECTION_RIGHT, obj.fillcolor)
			Case PFDCommon.DIRECTION_LEFT
				x2 = obj.centerx - (w/2)
				y2 = obj.centery - (h/2)
				DrawArrow2(cvs, x2 + (aw/2), y2, aw, ah, PFDCommon.DIRECTION_LEFT, obj.fillcolor)
		End Select

	End If

	'Direction Up with 3 lines hor + vert up + hor
	' +-
	' |
	'-+
	If obj.direction == PFDCommon.DIRECTION_UP Then
		'BotLeft to BotMid
		x1 = obj.centerx - (w/2)
		y1 = obj.centery + (h/2)
		x2 = x1 + lw
		y2 = y1
		cvs.DrawLine(x1,y1,x2,y2,obj.fillcolor,obj.strokewidth)

		'BotMid to TopMid
		x1 = x2
		y1 = y2
		x2 = x1
		y2 = y2 - (lh*2)
		cvs.DrawLine(x1,y1,x2,y2,obj.fillcolor,obj.strokewidth)

		'TopMid to TopRight
		x1 = x2
		y1 = y2
		x2 = x1 + lw
		y2 = y1
		cvs.DrawLine(x1,y1,x2,y2,obj.fillcolor,obj.strokewidth)

		'Arrow
		Select obj.arrow
			Case PFDCommon.DIRECTION_RIGHT
				DrawArrow2(cvs, x2 - (aw/2), y2, aw, ah, PFDCommon.DIRECTION_RIGHT, obj.fillcolor)
			Case PFDCommon.DIRECTION_LEFT
				x2 = obj.centerx - (w/2)
				y2 = obj.centery + (h/2)
				DrawArrow2(cvs, x2 + (aw/2), y2, aw, ah, PFDCommon.DIRECTION_LEFT, obj.fillcolor)
		End Select
	End If
	
	'Commit the drawing is done in method ReDraw in PFDBase.
	'cvs.Invalidate
End Sub
#End Region

'TODO: Test drawing a connector line with multiple points
'Create a connector line which consists out of multiple lines.
'Example: Line connection between point x,y 100,100 and 200,200 results in 3 lines:
'100,100 to 150,100 to 150,200 to 200,200
'Define the obj.value as string with CSV: (100,100);(150,100);(150,200);(200,200)
Public Sub DrawConnectorPLine(cvs As AsyncCanvas, obj As TPFDObject)
	'Get the lines with X,Y coordinates from CSV string
	Dim lines() As String = Regex.Split(";",obj.value)
	
	'Build the lines
	Dim x1,y1,x2,y2 As Int = 0
	For i = 0 To lines.Length - 1

		Dim line As String = lines(i)
		line = line.Replace("(","").replace(")","")

		Dim lineto() As String = Regex.Split(",",line)
		x1 = x2
		y1 = y2
		x2 = lineto(0)
		y2 = lineto(1)
		
		Select i
			Case 0
				'Draw start as pixel
				cvs.DrawPixel(x2, y2, obj.fillcolor)
			Case Else
				'Draw line from previous point
				cvs.DrawLine(x1, y1, x2, y2, obj.fillcolor, obj.strokewidth)
		End Select
	Next

	'Commit the drawing is done in method ReDraw in PFDBase.
	'cvs.Invalidate
End Sub
#End Region

#Region DrawImage
'Draw an image (PNG format) in a rectangle.
'If the strokewidth is greater 0 then rectangle is shown around the image.
'cvs - Canvas to draw upon.
'obj - Object with properties.
'The object image file must be PNG format and located in the dirapp or dirassets folder.
'Special case to draw fontawesome icon. Set obj.image to fontawesome:0xNNNN where NNNN is HEX code of the fontawesome icon.
'Example for image icon: fontawesome:0xF03E
Public Sub DrawImage(cvs As AsyncCanvas, obj As TPFDObject)
	'Image rect coordinates
	Dim x1,y1,x2,y2 As Int
	'Default folder of the image to load from
	Dim folder As String
	'Image filename taken from obj.image (must be lowercase)
	Dim imagefilename As String = obj.image.ToLowerCase
	'Flag to indicate image exists in dirapp folder
	Dim imagefileexists As Boolean = False
	'Flag to indicate image is fontawesome
	Dim imagefontawesome As Boolean = False
	'Image as b4xbitmap
	Dim bmp As B4XBitmap

	'Set the image rect dimensions
	x1 = obj.centerx - (obj.width/2)
	y1 = obj.centery - (obj.height/2)
	x2 = obj.centerx + (obj.width/2)
	y2 = obj.centery + (obj.height/2)

	'Check if there is an imagefilename, else leave
	If imagefilename.Length == 0 Then Return
	
	'Check if image is fontawesome icon, i.e. fontawesome:0xF03E
	If imagefilename.StartsWith(PFDCommon.IMAGE_FONTAWESOME_PREFIX) Then
		'Get the font icon HEX string from (example) fontawesome:0xF03E > F03E
		Dim faiconhex As String = imagefilename.replace($"${PFDCommon.IMAGE_FONTAWESOME_PREFIX}0x"$, "")
		bmp = Helper.FontAwesomeToImage(Chr(Bit.ParseInt(faiconhex,16)), obj.fontsize, xui.color_darkgray)
		imagefontawesome = True
	End If

	'If the image is not fontawesome then check if the image file exists in dirapp
	If Not(imagefontawesome) Then
		folder = File.dirapp
		imagefileexists = File.Exists(folder, obj.image)
		If Not(imagefileexists) Then
			Log($"[ERROR][DrawImage] Image file '${obj.image}' not found in folder ${File.dirapp}."$)
			Return
		End If
		Try
			'Create a bitmap from the image
			bmp = xui.LoadBitmapResize(folder, obj.image, obj.width, obj.height, True)
		Catch
			Log($"[ERROR][DrawImage] Can not draw image ${obj.image}.${CRLF}${LastException}"$)
			Return
		End Try
	End If
	
	'Create a rect of image size
	Dim rect As B4XRect
	rect.Initialize(x1,y1,x2,y2)
	
	'Draw the bitmap in the rect
	cvs.DrawBitmapRotated(bmp, rect, 0)

	'Draw the rect if strokewidth > 0
	If obj.strokewidth > 0 Then
		cvs.DrawRect(rect, obj.bordercolor, False, obj.strokewidth)
	End If

	'Draw the object value in the object middle
	PFDCommon.DrawValue(cvs, obj)

	'Commit the drawing is done in method ReDraw in PFDBase.
	'cvs.Invalidate
End Sub

'Draw an image (PNG format) in a rectangle.
'cvs - Canvas to draw upon.
'obj - Object with properties.
'img - Image PNG format as B4XBitmap
Public Sub DrawImage2(cvs As AsyncCanvas, obj As TPFDObject, bmp As B4XBitmap)
	Dim x1,y1,x2,y2 As Int

	x1 = obj.centerx - (obj.width/2)
	y1 = obj.centery - (obj.height/2)
	x2 = obj.centerx + (obj.width/2)
	y2 = obj.centery + (obj.height/2)
	
	'Check if there is an image filename given
	If obj.image.Length == 0 Then Return
	'Check if the image file exists
	If Not(File.Exists(File.DirApp, obj.image)) Then Return

	Try
		Dim rect As B4XRect
		rect.Initialize(x1,y1,x2,y2)
		cvs.ClearRect(rect)
		cvs.DrawBitmap(bmp, rect)
		
		PFDCommon.DrawTag2(cvs, obj)

		'Commit the drawing is done in method ReDraw in PFDBase.
		'cvs.Invalidate
	Catch
		Log($"[ERROR][DrawImage] Can not draw image ${obj.image}.${CRLF}${LastException}"$)
	End Try
End Sub
#End Region

#Region DrawLabel
'Draw a label which is a single text obj.
'cvs - Canvas to draw upon.
'obj - Object with properties.
Public Sub DrawLabel(cvs As AsyncCanvas, obj As TPFDObject)

	DrawTextRotated(cvs, obj)
	
	'Commit the drawing is done in method ReDraw in PFDBase.
	'cvs.Invalidate
End Sub
#End Region

#Region DrawLineFromPath
'Draw hor or vert line as a thin rect (obj.strokewidth) with length set by the obj.width.
'The line is drawn using b4xpath with rotation degrees (0=hor,90=vert).
'Optional arrow is set direction left or right for hor, else up or down for vert.
'The obj.fillcolor is used to set the line color.
Public Sub DrawLineFromPath(cvs As AsyncCanvas, obj As TPFDObject)
	Dim path As B4XPath
	'Rect coordinates topleft=x1,y1, botright=x2,y2
	Dim x1,y1,x2,y2 As Float
	'Line centerx,y
	Dim cx, cy As Float
	'Line begin & end
	Dim xbegin, ybegin, xend, yend As Float
	'Object half width
	Dim w2 As Float = obj.width/2
	'Strokewidth half
	Dim sw2 As Float = obj.strokewidth/2
	'Degrees for rotation
	Dim degrees As Float
	'Arrow size
	Dim aw As Float = obj.strokewidth * PFDCommon.ARROW_STROKE_WIDTH_FACTOR
	Dim ah As Float = obj.strokewidth * PFDCommon.ARROW_STROKE_HEIGHT_FACTOR

	'Check direction
	If Not(Helper.ItemInArray(obj.direction, Array As String(PFDCommon.DIRECTION_HORIZONTAL, PFDCommon.DIRECTION_VERTICAL))) Then
		obj.direction = PFDCommon.DIRECTION_HORIZONTAL
	End If
	
	'Set rotation degrees
	If obj.direction == PFDCommon.DIRECTION_HORIZONTAL Then
		degrees = 0
		cx = obj.centerx + sw2
		cy = obj.centery
		'Line begin&end = y is same
		xbegin = obj.centerx - w2
		ybegin = obj.centery
		xend = obj.centerx + w2
		yend = obj.centery
	End If
	If obj.direction == PFDCommon.DIRECTION_VERTICAL Then
		degrees = 90
		cx = obj.centerx
		cy = obj.centery + sw2
		'Line begin&end = x is same
		xbegin = obj.centerx
		ybegin = obj.centery - w2
		xend = obj.centerx
		yend = obj.centery + w2
	End If

	'Create the line path
	'TopLeft
	x1 = obj.centerx - w2
	y1 = obj.centery - sw2
	path.Initialize(x1, y1)
	'TopLeft to TopRight
	x2 = obj.centerx + w2
	y2 = y1
	path.LineTo(x2, y2)
	'TopRight to BotRight
	x2 = obj.centerx + w2
	y2 = obj.centery + obj.StrokeWidth
	path.LineTo(x2, y2)
	'BotRight to BotLeft
	x2 = obj.centerx - w2
	y2 = obj.centery + obj.StrokeWidth
	path.LineTo(x2, y2)
	'BotLeft to TopLeft
	path.LineTo(x1, y1)

	'Draw the outer shape
	cvs.DrawPathRotated(path, obj.fillcolor, True, obj.strokewidth, degrees, cx, cy)

	'Arrow
	Select obj.arrow
		Case PFDCommon.DIRECTION_RIGHT
			DrawArrow2(cvs, xend - (aw/2), yend, aw, ah, PFDCommon.DIRECTION_RIGHT, obj.fillcolor)
		Case PFDCommon.DIRECTION_LEFT
			DrawArrow2(cvs, xbegin + (aw/2), ybegin, aw, ah, PFDCommon.DIRECTION_LEFT, obj.fillcolor)
		Case PFDCommon.DIRECTION_DOWN
			DrawArrow2(cvs, xend, yend - (aw/2), aw, ah, PFDCommon.DIRECTION_DOWN, obj.fillcolor)
		Case PFDCommon.DIRECTION_UP
			DrawArrow2(cvs, xbegin, ybegin + (aw/2), aw, ah, PFDCommon.DIRECTION_UP, obj.fillcolor)
	End Select

End Sub
#End Region

#Region DrawLineRotated
'Draw a rotated line as a thin rect (obj.strokewidth) with length set by the obj.width.
'The line is drawn using b4xpath with rotation degrees set as value. Examples: 0=hor,90=vert.
'The obj.fillcolor is used to set the line color.
Public Sub DrawLineRotated(cvs As AsyncCanvas, obj As TPFDObject)
	Dim path As B4XPath
	'Rect coordinates topleft=x1,y1, botright=x2,y2
	Dim x1,y1,x2,y2 As Float
	'Line centerx,y
	Dim cx As Float = obj.centerx
	Dim cy As Float = obj.centery
	'Line half width
	Dim lw2 As Float = obj.width/2
	'Strokewidth half
	Dim sw2 As Float = obj.strokewidth/2
	'Degrees for rotation
	Dim degrees As Float = 0

	'Set rotation degrees
	If Helper.ValueIsNumber(obj.value) Then
		degrees = obj.value
	End If

	'TopLeft
	x1 = obj.centerx - lw2
	y1 = obj.centery - sw2
	path.Initialize(x1, y1)

	'TopLeft to TopRight
	x2 = obj.centerx + lw2
	y2 = obj.centery - sw2
	path.LineTo(x2, y2)
	'TopRight to BotRight
	x2 = obj.centerx + lw2
	y2 = obj.centery + obj.StrokeWidth
	path.LineTo(x2, y2)

	'BotRight to BotLeft
	x2 = obj.centerx - lw2
	y2 = obj.centery + obj.StrokeWidth
	path.LineTo(x2, y2)

	'BotLeft to TopLeft
	x2 = obj.centerx - lw2
	y2 = obj.centery - sw2
	path.LineTo(x2, y2)

	'Draw the outer shape
	Log(cvs.DrawPathRotated(path, obj.fillcolor, True, obj.strokewidth, degrees, cx, cy))
	
	'Draw Checks @ cx,cy
	'PFDCommon.DrawCheckPixel(cvs, obj)
	'PFDCommon.DrawCheckValue(cvs, obj)
End Sub
#End Region

#Region DrawLineRotatedArrow
'Draw a rotated solid line as a thin rect (obj.strokewidth) with an arrow and length set by the obj.width.
'The line is drawn using b4xpath with rotation degrees set as value. Examples: 0=hor,90=vert.
'The obj.fillcolor is used to set the line color.
Public Sub DrawLineRotatedArrow(cvs As AsyncCanvas, obj As TPFDObject)
	Dim path As B4XPath
	'For simplicity using 8 x,y points
	Dim x1,y1,x2,y2,x3,y3,x4,y4,x5,y5,x6,y6,x7,y7,x8,y8 As Float
	'Line centerx,y
	Dim cx As Float = obj.centerx
	Dim cy As Float = obj.centery
	'Line width
	Dim lw As Float = obj.width
	'Line half width
	Dim lw2 As Float = obj.width/2
	'Strokewidth
	Dim sw As Float = obj.strokewidth
	'Strokewidth half
	Dim sw2 As Float = obj.strokewidth/2
	'Arrow
	Dim aw As Float = obj.strokewidth * PFDCommon.ARROW_STROKE_WIDTH_FACTOR
	Dim aw2 As Float = aw/2
	'Degrees for rotation
	Dim degrees As Float = 0

	'Set line rotation degrees
	If Helper.ValueIsNumber(obj.value) Then
		degrees = obj.value
	End If

	'Start
	'Pt1 = MidLeft Arrow
	x1 = obj.centerx - lw2
	y1 = obj.centery
	path.Initialize(x1, y1)

	'Pt2 = TopRight Arrow
	x2 = x1 + aw
	y2 = y1 - aw2
	path.LineTo(x2, y2)

	'Pt3 = MidRight Arrow
	x3 = x2
	y3 = y2 + aw2 - sw2
	path.LineTo(x3, y3)

	'Pt4 = TopRight Line
	x4 = x3 + lw - aw
	y4 = y3
	path.LineTo(x4, y4)

	'Pt5 = TopRight to BotRight Line
	x5 = x4
	y5 = y4 + sw
	path.LineTo(x5, y5)

	'Pt6 = BotRight Line to TopRight Arrow
	x6 = x5 - lw + aw
	y6 = y5
	path.LineTo(x6, y6)

	'Pt7 = TopRight to BotRight Arrow
	x7 = x6
	y7 = y6 + aw2
	path.LineTo(x7, y7)

	'Pt8 = Pt1 = BotRight to MidLeft ArrowArrow
	x8 = obj.centerx - lw2
	y8 = obj.centery
	path.LineTo(x8, y8)

	'Draw the outer shape
	Log(cvs.DrawPathRotated(path, obj.fillcolor, True, obj.strokewidth, degrees, cx, cy))
	
	'Draw Checks @ cx,cy
	'PFDCommon.DrawCheckPixel(cvs, obj)
	'PFDCommon.DrawCheckValue(cvs, obj)
End Sub
#End Region

#Region DrawLineSolid
'Draw a horizontal solid line.
Public Sub DrawLineSolidHorizontal(cvs As AsyncCanvas, obj As TPFDObject)
	obj.direction = PFDCommon.DIRECTION_HORIZONTAL
	DrawLineSolid(cvs, obj)
End Sub

'Draw a vertical solid line.
Public Sub DrawLineSolidVertical(cvs As AsyncCanvas, obj As TPFDObject)
	obj.direction = PFDCommon.DIRECTION_VERTICAL
	DrawLineSolid(cvs, obj)
End Sub

'Draw a solid line.
'Gimmick if the value for the line is set:
'Set the arrow position on the line at percentage 0-100%.
Public Sub DrawLineSolid(cvs As AsyncCanvas, obj As TPFDObject)
	Dim x1,x2,y1,y2, aw, ah As Int
	
	'Arrow size
	aw = obj.strokewidth * PFDCommon.ARROW_STROKE_WIDTH_FACTOR
	ah = obj.strokewidth * PFDCommon.ARROW_STROKE_HEIGHT_FACTOR

	If obj.direction == PFDCommon.DIRECTION_NONE Then
		obj.direction = PFDCommon.DIRECTION_HORIZONTAL
	End If

	'Select the line direction hor or vert
	If obj.direction == PFDCommon.DIRECTION_HORIZONTAL Then
		'Draw Line
		x1 = obj.centerx - (obj.width / 2)
		y1 = obj.centery '- (obj.strokewidth / 2)
		x2 = x1 + obj.width
		y2 = y1
		cvs.DrawLine(x1, y1, x2, y2, obj.fillcolor, obj.strokewidth)

		'Draw Arrow
		Select obj.arrow
			Case PFDCommon.DIRECTION_LEFT
				x1 = x1 + (aw/2)
				y1 = y1
				If (obj.value.Length > 0 And Helper.ValueIsNumber(obj.value)) Then
					If obj.value > 0 And obj.value < 100 Then
						x1 = obj.centerx - (obj.width / 2)
						x1 = x1 + (obj.width * (obj.value / 100)) + (aw/2)
					End If
				End If
				DrawArrow2(cvs, x1, y1, aw, ah, obj.arrow, obj.fillcolor)
			Case PFDCommon.DIRECTION_RIGHT
				x2 = x2 - (aw/2)
				y2 = y2
				If (obj.value.Length > 0 And Helper.ValueIsNumber(obj.value)) Then
					If obj.value > 0 And obj.value < 100 Then
						x1 = obj.centerx - (obj.width / 2)
						x2 = x1 + (obj.width * (obj.value / 100)) - (aw/2)
					End If
				End If
				DrawArrow2(cvs, x2, y2, aw, ah, obj.arrow, obj.fillcolor)
		End Select
	End If

	If obj.direction == PFDCommon.DIRECTION_VERTICAL Then
		'Draw Line
		x1 = obj.centerx '- (obj.strokewidth / 2)
		y1 = obj.centery - (obj.height / 2)
		x2 = x1
		y2 = y1 + obj.height
		cvs.DrawLine(x1, y1, x2, y2, obj.fillcolor, obj.strokewidth)
		'Draw Arrow
		Select obj.arrow
			Case PFDCommon.DIRECTION_UP
				x1 = x1
				y1 = y1 + (ah/2)
				'Gimmick if the value for the line is set:
				'Set the arrow position on the line at percentage 0-100%
				If (obj.value.Length > 0 And Helper.ValueIsNumber(obj.value)) Then
					If obj.value > 0 And obj.value < 100 Then
						y1 = obj.centery - (obj.height / 2)
						y1 = y1 + (obj.height * (obj.value / 100)) + (ah/2)
					End If
				End If
				DrawArrow2(cvs, x1, y1, aw, ah, obj.arrow, obj.fillcolor)
			Case PFDCommon.DIRECTION_DOWN
				x2 = x2
				y2 = y2 - (ah/2)
				If (obj.value.Length > 0 And Helper.ValueIsNumber(obj.value)) Then
					If obj.value > 0 And obj.value < 100 Then
						y1 = obj.centery - (obj.height / 2)
						y2 = y1 + (obj.height * (obj.value / 100)) - (ah/2)
					End If
				End If
				DrawArrow2(cvs, x2, y2, aw, ah, obj.arrow, obj.fillcolor)
		End Select
	End If

	'Commit the drawing is done in method ReDraw in PFDBase.
	'cvs.Invalidate
End Sub

'Draw a solid line with properties given instead of an object.
Public Sub DrawLineSolid2(cvs As AsyncCanvas, x1 As Float, y1 As Float, x2 As Float, y2 As Float, color As Int, strokewidth As Float)
	cvs.DrawLine(x1, y1, x2, y2, color, strokewidth)
	
	'Commit the drawing is done in method ReDraw in PFDBase.
	'cvs.Invalidate
End Sub

'Draw a solid line using the XY properties of an object.
Public Sub DrawLineSolidXY(cvs As AsyncCanvas, obj As TPFDObject)
	cvs.DrawLine(obj.x1, obj.y1, obj.x2, obj.y2, obj.fillcolor, obj.strokewidth)
	
	'Commit the drawing is done in method ReDraw in PFDBase.
	'cvs.Invalidate
End Sub

'Draw a solid line in direction given by an angle.
'The starting point of the line is centerx, centery.
'Returned is the x,y line end point. Can be used as a starting point to draw another line.
'Example: Draw line with direction topright which is an angle of -30.
'obj.centerx=200;obj.centery=200;obj.width=60;obj.value=-30
'Dim pt As TPoint = DrawLineWithAngle(mCvs, obj)
Public Sub DrawLineSolidWithAngle(cvs As AsyncCanvas, obj As TPFDObject) As TPFDPoint
	Dim result As TPFDPoint
	Dim Angle As Float = obj.value
	Dim StartX As Float = obj.centerx
	Dim StartY As Float = obj.centerY
	Dim LineLength As Float = obj.width

	' Convert the angle from degrees to radians
	Dim radians As Float = Angle * cPI / 180
	' Calculate the end point using trigonometry
	Dim EndX As Float = Round(StartX + LineLength * Cos(radians))
	Dim EndY As Float = Round(StartY + LineLength * Sin(radians))

	' Draw the line
	cvs.DrawLine(StartX, StartY, EndX, EndY, obj.fillcolor, obj.strokewidth)

	'Set and return the x,y line end point
	result.Initialize
	result.x = EndX
	result.y = EndY
	Return result
End Sub

'Draw a solid line in direction given by an angle.
'Same as method DrawLineSolidWithAngle but not using an PFDObject as argument, but selective line properties.
'The starting point of the line is centerx, centery.
'Returned is the x,y line end point. Used as a starting point to draw another line.
'Example: Draw line with direction topright
'Dim pt As TPoint = DrawLineSolidWithAngle2(mCvs, 200, 200, -45, 50, xui.Color_Red, 5)
Public Sub DrawLineSolidWithAngle2(cvs As AsyncCanvas, StartX As Float, StartY As Float, Angle As Float, Length As Float, Color As Int, StrokeWidth As Int) As TPFDPoint
	Dim obj As TPFDObject
	
	obj.Initialize
	obj.centerx = StartX
	obj.centery = StartY
	obj.width = Length
	obj.value = Angle
	obj.fillcolor = Color
	obj.strokewidth = StrokeWidth
	Return DrawLineSolidWithAngle(cvs, obj)
End Sub
#End Region

#Region DrawLINEDASHED
'Draw a horizontal dashed line.
Public Sub DrawLineDashedHorizontal(cvs As AsyncCanvas, obj As TPFDObject)
	obj.direction = PFDCommon.DIRECTION_HORIZONTAL
	DrawLineDashed(cvs, obj)
End Sub

'Draw a vertical dashed line.
Public Sub DrawLineDashedVertical(cvs As AsyncCanvas, obj As TPFDObject)
	obj.direction = PFDCommon.DIRECTION_VERTICAL
	DrawLineDashed(cvs, obj)
End Sub

'Draw a dashed line.
'The dash length is set by the object strokewidth and the color is default white.
Public Sub DrawLineDashed(cvs As AsyncCanvas, obj As TPFDObject)
	Dim x1,x2,y1,y2, aw, ah As Int
	
	'Dashes
	Dim dashcolor As Int = xui.color_white
	Dim dashlength As Int = obj.strokewidth
	'Check if dashlength not too small
	If dashlength < PFDCommon.LINE_DASHED_DASH_LENGTH_MIN Then 
		dashlength = PFDCommon.LINE_DASHED_DASH_LENGTH_MIN
	End If

	'Arrow size
	aw = obj.strokewidth * PFDCommon.ARROW_STROKE_WIDTH_FACTOR
	ah = obj.strokewidth * PFDCommon.ARROW_STROKE_HEIGHT_FACTOR

	If obj.direction == PFDCommon.DIRECTION_NONE Then
		obj.direction = PFDCommon.DIRECTION_HORIZONTAL
	End If

	'Draw Line
	If obj.direction == PFDCommon.DIRECTION_HORIZONTAL Then
		'Draw Lines
		x1 = obj.centerx - (obj.width / 2)
		y1 = obj.centery '- (obj.height / 2)
		x2 = x1 + obj.width
		y2 = y1
		'Solid
		cvs.DrawLine(x1, y1, x2, y2, obj.fillcolor, obj.strokewidth)
		'Dashed - Set x1 & x2 to start & end at step
		x1 = x1 + dashlength
		x2 = x2 - dashlength
		For i = x1 To x2 Step dashlength * 2
			cvs.DrawLine(i, y1, i + dashlength, y1, dashcolor, obj.strokewidth)
		Next
		'Draw Arrow
		Select obj.arrow
			Case PFDCommon.DIRECTION_LEFT
				x1 = x1 + (aw/2)
				y1 = y1
				DrawArrow2(cvs, x1, y1, aw, ah, obj.arrow, obj.fillcolor)
			Case PFDCommon.DIRECTION_RIGHT
				x2 = x2 - (aw/2)
				y2 = y2
				DrawArrow2(cvs, x2, y2, aw, ah, obj.arrow, obj.fillcolor)
		End Select
	End If

	If obj.direction == PFDCommon.DIRECTION_VERTICAL Then
		'Draw Line
		x1 = obj.centerx '- (obj.width / 2)
		y1 = obj.centery - (obj.height / 2)
		x2 = x1
		y2 = y1 + obj.height
		'Solid
		cvs.DrawLine(x1, y1, x2, y2, obj.fillcolor, obj.strokewidth)
		'Dashed - Set y1 & y2 to start & end at step
		y1 = y1 + dashlength
		y2 = y2 - dashlength
		For i = y1 To y2 Step dashlength * 2
			cvs.DrawLine(x1, i, x2, i + dashlength, dashcolor, obj.strokewidth)
		Next
		'Draw Arrow
		Select obj.arrow
			Case PFDCommon.DIRECTION_UP
				x1 = x1
				y1 = y1 + (ah/2)
				DrawArrow2(cvs, x1, y1, aw, ah, obj.arrow, obj.fillcolor)
			Case PFDCommon.DIRECTION_DOWN
				x2 = x2
				y2 = y2 - (ah/2)
				DrawArrow2(cvs, x2, y2, aw, ah, obj.arrow, obj.fillcolor)
		End Select
	End If

	'Commit the drawing is done in method ReDraw in PFDBase.
	'cvs.Invalidate
End Sub

'Draw a Dashed line with properties given instead of an object.
Public Sub DrawLineDashed2(cvs As AsyncCanvas, x1 As Float, y1 As Float, x2 As Float, y2 As Float, color As Int, strokewidth As Float, dashcolor As Int, dashlength As Int)
	'Solid Line
	cvs.DrawLine(x1, y1, x2, y2, color, strokewidth)

	'Dashed Line - Set x1,x2 to start,end position at the step with length dashlength*2
	x1 = x1 + dashlength
	x2 = x2 - dashlength
	For i = x1 To x2 Step dashlength * 2
		cvs.DrawLine(i, y1, i + dashlength, y2, dashcolor, strokewidth)
	Next

	'Commit the drawing is done in method ReDraw in PFDBase.
	'cvs.Invalidate
End Sub
#End Region

#Region DrawOval
'Draw an oval with text inside.
Public Sub DrawOval(cvs As AsyncCanvas, obj As TPFDObject)
	Dim rect As B4XRect

	'Create rect to hold the oval shape
	rect.Initialize(obj.centerx - (obj.width/2), obj.centery - (obj.height/2), _
					obj.centerx + (obj.width/2), obj.centery + (obj.height/2))
	
	'Draw the inner shape
	cvs.DrawOval(rect, obj.fillcolor, True, 0)
	'Draw the outer shape
	If obj.strokewidth > 0 Then cvs.DrawOval(rect, obj.bordercolor, False, obj.strokewidth)

	'Draw the text inside the oval
	PFDCommon.DrawValueInObject(cvs,obj)
		
	'Draw the optional connector
	DrawConnector(cvs, obj)

	'Check Obj Rect
	'PFDCommon.DrawCheck(cvs, obj)

	'Commit the drawing is done in method ReDraw in PFDBase.
	'cvs.Invalidate
End Sub
#End Region

#Region DrawPane
'Draw a rectangle with rounded top corners.
Private Sub DrawRoundedTopRectangle(cvs As AsyncCanvas, Left As Float, Top As Float, Width As Float, Height As Float, Radius As Float, StrokeColor As Int, StrokeWidth As Float)
	Dim Path As B4XPath
	
	'Start directly at the top-left arc (no straight line)
	Path.Initialize(Left, Top + Radius)

	'Approximate the top-left corner (rounded) with small line segments
	Dim i As Float
	Dim StepAngle As Float = 5 ' Smaller step angle gives smoother arc
	For i = 180 To 270 Step StepAngle
		Dim x As Float = Left + Radius + Radius * CosD(i)
		Dim y As Float = Top + Radius + Radius * SinD(i)
		Path.LineTo(x, y)
	Next

	'Top horizontal line (straight, from top-left to top-right)
	Path.LineTo(Left + Width - Radius, Top)
    
	'Approximate the top-right corner (rounded) with small line segments
	For i = 270 To 360 Step StepAngle
		Dim x As Float = Left + Width - Radius + Radius * CosD(i)
		Dim y As Float = Top + Radius + Radius * SinD(i)
		Path.LineTo(x, y)
	Next

	'Right side vertical line (straight, from top-right to bottom-right)
	Path.LineTo(Left + Width, Top + Height)
    
	'Bottom horizontal line (straight, from bottom-right to bottom-left)
	Path.LineTo(Left, Top + Height)
	
	'Left side vertical line (straight, from bottom-left to top-left)
	Path.LineTo(Left, Top + Radius)

	'Draw the path on the canvas
	cvs.DrawPath(Path, StrokeColor, True, StrokeWidth)
End Sub

'Draw a rounded rectangle with a heading text.
'The height of the heading is 10% of pane height or 25% for small panes (like shape selector).
Public Sub DrawPane(cvs As AsyncCanvas, obj As TPFDObject)
	Dim x1,y1,x2,y2 As Int
	Dim hdgheight As Int
	Dim hdgheightoffset As Int = 10
	Dim rect As B4XRect
	Dim fntrect As B4XRect
	
	'Font
	Dim fnt As B4XFont = PFDCommon.SetFont(obj)
	fntrect = cvs.MeasureText("A", fnt)
	
	'Set heading height with checks
	hdgheight = obj.height / hdgheightoffset

	'Check height < cornerradius
	If hdgheight < obj.cornerradius Then hdgheight = obj.cornerradius

	'Check height fits font size
	If hdgheight < (fntrect.Height * 2) Then
		hdgheight = fntrect.Height * 2
	End If
	'Special case for a small pane like for the shape selector
	'Set the height to 25% of the pane height
	If hdgheight > (obj.height / 2) Then
		hdgheight = obj.height / 4
	End If

	'Set rect dimension
	x1 = obj.centerx - (obj.width/2)
	y1 = obj.centery - (obj.height/2)
	x2 = obj.centerx + (obj.width/2)
	y2 = obj.centery + (obj.height/2)

	'Init the rect
	rect.Initialize(x1,y1,x2,y2)

	'Draw the inner shape
	cvs.DrawRoundRect(rect, obj.fillcolor, True, 0, obj.cornerradius)
	'Draw the outer shape
	If obj.strokewidth > 0 Then cvs.DrawRoundRect(rect, obj.bordercolor, False, obj.strokewidth, obj.cornerradius)

	'Draw the heading rect with top rounded corners and bottom edge corners
	Dim objhdg As TPFDObject
	objhdg.Initialize
	objhdg.value = obj.value
	objhdg.textalignment = obj.textalignment
	objhdg.fillcolor = obj.bordercolor
	objhdg.textcolor = obj.textcolor
	objhdg.font = obj.font
	objhdg.centerx = obj.centerx
	objhdg.centery = obj.centery - (obj.height/2) + (hdgheight/2)
	objhdg.width = obj.width
	objhdg.height = hdgheight
	objhdg.cornerradius = obj.cornerradius

	DrawRoundedTopRectangle(cvs, x1, y1, obj.width, objhdg.height, obj.cornerradius, obj.bordercolor, obj.strokewidth)
	DrawLabel(cvs, objhdg)

	'Draw the optional connector
	DrawConnector(cvs, obj)

	'Commit the drawing is done in method ReDraw in PFDBase.
	'cvs.Invalidate
End Sub
#End Region

#Region DrawPath
'Draw path with lineto coordinates with the object width and height.
'The path coordinates are defined in CSV string with points x,y separated by ;.
'Ensure to close the path with line back to first point.
'Example<code>draw rectangle in top left corner of the object.
'obj.centerx = 200, obj.centery = 100
'obj.width = 100, obj.height = 100
''Define 5 points for the rectangle
'obj.value = "0,0;0,50;50,50;50,0;0,0"
'</code>
Public Sub DrawPath(cvs As AsyncCanvas, obj As TPFDObject)
	Dim p As B4XPath
	'TopLeft base pos
	Dim x As Float = obj.centerx - (obj.width/2)
	Dim y As Float = obj.centery - (obj.height/2)
	
	'Check if there is a value
	If obj.value.Length == 0 Then
		Helper.ToLog(False, $"[DRAWPATH][ERROR] No points defined in the value."$)
		Return
	End If
	
	Try
		Dim points() As String = Regex.Split(";", obj.value)
	
		'Check if there are points
		If points.Length == 0 Then
			Return
		End If
	
		'Init the path with point index 0
		Dim point() As String = Regex.Split(",", points(0))
		p.Initialize(point(0).As(Float)+x, point(1).As(Float)+y)

		'Remaining points
		For i = 1 To points.Length - 1
			Dim point() As String = Regex.Split(",", points(i))
			p.LineTo(point(0).As(Float)+x, point(1).As(Float)+y)
		Next
	
		cvs.DrawPath(p, obj.fillcolor, True, 0)
		cvs.DrawPath(p, obj.bordercolor, False, obj.strokewidth)		
	Catch
		Helper.ToLog(False, $"[ERROR][DrawPath] ${LastException}"$)
	End Try
End Sub
#End Region

#Region DrawPixel
'Draw a pixel which is a filled rectangle.
Public Sub DrawPixel(cvs As AsyncCanvas, obj As TPFDObject)
	Dim w As Float = obj.width/2
	'Adjust obj w&h to fit within shape selector
	If obj.shapeselector == obj.pfdobject Then
		w = PFDCommon.SHAPE_SELECTOR_WIDTH / 4
	End If
	cvs.DrawPixel2(obj.centerx, obj.centery, obj.fillcolor, w)
End Sub
#End Region

#Region DrawRectangle
'Draw a rectangle with value text in the middle.
Public Sub DrawRectangle(cvs As AsyncCanvas, obj As TPFDObject)
	Dim x1,y1,x2,y2 As Int
	Dim rect As B4XRect

	'Set rect dimension
	x1 = obj.centerx - (obj.width/2)
	y1 = obj.centery - (obj.height/2)
	x2 = obj.centerx + (obj.width/2)
	y2 = obj.centery + (obj.height/2)

	'Init the rect
	rect.Initialize(x1,y1,x2,y2)

	'Draw the inner shape
	cvs.DrawRoundRect(rect, obj.fillcolor, True, 0, obj.cornerradius)
	'Draw the outer shape
	If obj.strokewidth > 0 Then cvs.DrawRoundRect(rect, obj.bordercolor, False, obj.strokewidth, obj.cornerradius)

	'Draw the value in object
	PFDCommon.DrawValueInObject(cvs, obj)

	'Draw the optional connector
	DrawConnector(cvs, obj)

	'Commit the drawing is done in method ReDraw in PFDBase.
	'cvs.Invalidate
End Sub

'Draw rectangle from path and not using canvas drawrect.
'Drawpath draws the rect including the border within obj width and height.
'The border is not drawn on the borderline.
Public Sub DrawRectFromPath(cvs As AsyncCanvas, obj As TPFDObject)
	Dim path As B4XPath
	Dim x1,y1 As Int
	
	'TopLeft
	x1 = obj.centerx - (obj.width/2) - (obj.strokewidth/2)
	y1 = obj.centery - (obj.height/2) - (obj.strokewidth/2)
	path.Initialize(x1, y1)
	'TopLeft to BotLeft
	x1 = obj.centerx - (obj.width/2)
	y1 = obj.centery + (obj.height/2) + (obj.strokewidth/2)
	path.LineTo(x1, y1)
	'BotLeft to BotRight
	x1 = obj.centerx + (obj.width/2)
	y1 = obj.centery + (obj.height/2) + (obj.strokewidth/2)
	path.LineTo(x1, y1)
	'BotRight to TopRight
	x1 = obj.centerx + (obj.width/2)
	y1 = obj.centery - (obj.height/2)
	path.LineTo(x1, y1)
	'TopRight to TopLeft
	x1 = obj.centerx - (obj.width/2)- (obj.strokewidth/2)
	y1 = obj.centery - (obj.height/2)- (obj.strokewidth/2)
	path.LineTo(x1, y1)

	'Draw the inner shape
	cvs.DrawPath(path, obj.fillcolor, True, obj.StrokeWidth)
	'Draw the outer shape
	If obj.strokewidth > 0 Then cvs.DrawPath(path, obj.bordercolor, False, obj.strokewidth)
End Sub
#End Region

#Region DrawTextArrow
'Draw text arrow direction left or right with text wrapped.
'An offset is used to draw the arrow head and tail size.
Public Sub DrawTextArrow(cvs As AsyncCanvas, obj As TPFDObject)
	Dim x,y,w,h As Int
	Dim offset As Int
	Dim cx,cy As Int
	Dim degreesarrow As Int
	Dim degreestext As Int

	'Set the font
	Dim fnt As B4XFont = PFDCommon.SetFont(obj)
	Dim fntrect As B4XRect = cvs.MeasureText("A", fnt)

	'Check direction
	If obj.direction = PFDCommon.DIRECTION_NONE Then obj.direction = PFDCommon.DIRECTION_RIGHT

	'Set the width and height
	w = obj.width
	h = obj.height
	'Reverse w and h if direction up or down
	If obj.direction == PFDCommon.DIRECTION_UP Or obj.direction == PFDCommon.DIRECTION_DOWN Then
		w = obj.height
		h = obj.width
	End If
	'Set the arrow left and right offset.
	offset = Round(w / 5)

	'Draw a base texarrow pointing direction right
	' Initialize the path for the arrow
	Dim path As B4XPath
	'LeftMid
	x = obj.centerx - (w/2) + offset
	y = obj.centery
	path.Initialize(x, y)
	'LeftTopRight
	x = obj.centerx - (w/2)
	y = obj.centery - (h/2)
	path.LineTo(x,y)
	'RightTop
	x = obj.centerx + (w/2) - offset
	y = obj.centery - (h/2)
	path.LineTo(x,y)
	'RightMid
	x = obj.centerx + (w/2)
	y = obj.centery
	path.LineTo(x,y)
	'RightBot
	x = obj.centerx + (w/2) - offset
	y = obj.centery + (h/2)
	path.LineTo(x,y)
	'LeftBot
	x = obj.centerx - (w/2)
	y = obj.centery + (h/2)
	path.LineTo(x,y)
	'LeftMid
	x = obj.centerx - (w/2) + offset
	y = obj.centery
	path.LineTo(x,y)
	'LeftTop
	x = obj.centerx - (w/2)
	y = obj.centery - (h/2)
	path.LineTo(x,y)

	'Select the direction, set the rotation angle and cx,cy for drawing the value in the object
	Select obj.direction
		Case PFDCommon.DIRECTION_RIGHT
			degreesarrow = 0
			degreestext = 0
			cx = obj.centerx + (offset/3)
			cy = obj.centery
			
		Case PFDCommon.DIRECTION_LEFT
			degreesarrow = 180
			degreestext = 0
			cx = obj.centerx - (offset/3)
			cy = obj.centery

		Case PFDCommon.DIRECTION_DOWN
			degreesarrow = 90
			degreestext = 90
			cx = obj.centerx - (fntrect.height/2)
			cy = obj.centery + (offset/3)

		Case PFDCommon.DIRECTION_UP
			degreesarrow = 270
			degreestext = 270
			cx = obj.centerx + (fntrect.height/2)
			cy = obj.centery - (offset/3)
	End Select

	'Draw the inner shape
	cvs.DrawPathRotated(path, obj.fillcolor, True, 0, degreesarrow, obj.centerx, obj.centery)
	'Draw the outer shape
	If obj.strokewidth > 0 Then cvs.DrawPathRotated(path, obj.bordercolor, False, obj.strokewidth, degreesarrow, obj.centerx, obj.centery)

	'Draw the value in the object
	PFDCommon.DrawValueInObject2(cvs, obj, cx, cy, degreestext)

	'Commit the drawing is done in method ReDraw in PFDBase.
	'cvs.Invalidate
End Sub
#End Region

#Region DrawText
'Draw text wrapped.
'The text font, fontsize, textcolor & textalignment are used.
'The backgroundcolor is the PFD Drawing Board background color.
'Properties: value,centerx,centery,width,height,font,fontsize,textcolor,textalignment.
Public Sub DrawText(cvs As AsyncCanvas, obj As TPFDObject)
	Dim HEIGHTOFFSET As Int = 4dip
	'Word wrap the obj value to list of lines
	Dim WrappedLines As List = Helper.WordWrapString(cvs, obj)
	Dim fnt As B4XFont = PFDCommon.SetFont(obj)
	Dim fntrect As B4XRect = cvs.MeasureText("A", fnt)
	Dim x, y As Float

	'Set the initial x,y position on the canvas depending textalignment
	Select obj.textalignment
		Case PFDCommon.TEXT_ALIGNMENT_LEFT
			x = obj.centerx - (obj.width/2)
		Case PFDCommon.TEXT_ALIGNMENT_CENTER
			x = obj.centerx
		Case PFDCommon.TEXT_ALIGNMENT_RIGHT
			x = obj.centerx + (obj.width/2)
	End Select
	'Set y - ensure the middle line is at the center
	y = obj.centery - ( (fntrect.Height * WrappedLines.Size) / 2) - (fntrect.height / 2)
    
	'Draw the lines
	For Each Line As String In WrappedLines
		y = y + fntrect.Height + HEIGHTOFFSET
		cvs.DrawText(Line, x, y, fnt, obj.textcolor, obj.textalignment)
	Next
End Sub

'Draw text wrapped rotated.
'The rotations are RIGHT/LEFT=0 degrees, DOWN=90 degrees, UP=270 degrees.
'The text font, fontsize, textcolor & textalignment are used.
'The backgroundcolor is the PFD Drawing Board background color.
'Properties: value,centerx,centery,width,height,font,fontsize,textcolor,textalignment.
Public Sub DrawTextRotated(cvs As AsyncCanvas, obj As TPFDObject)
	'Word wrap the obj value to list of lines
	Dim WrappedLines As List = Helper.WordWrapString(cvs, obj)
	Dim fnt As B4XFont = PFDCommon.SetFont(obj)
	Dim fntrect As B4XRect = cvs.MeasureText("A", fnt)
	Dim HeightOffset As Int = fntrect.Height/2
	Dim degrees As Float
	Dim x, y As Float
	Dim direction As String = obj.direction
	
	'Set the degrees
	If direction == PFDCommon.DIRECTION_RIGHT Or direction == PFDCommon.DIRECTION_LEFT Then degrees = 0
	If direction == PFDCommon.DIRECTION_DOWN Then degrees = 90
	If direction == PFDCommon.DIRECTION_UP Then degrees = 270

	'Set the initial x,y position on the canvas depending textalignment

	'Select the direction, set the rotation angle and cx,cy for drawing the value in the object
	'Set the initial x,y position on the canvas
	Select degrees
		'Right or Left
		Case 0
			Select obj.textalignment
				Case PFDCommon.TEXT_ALIGNMENT_LEFT
					x = obj.centerx - (obj.width/2)
				Case PFDCommon.TEXT_ALIGNMENT_CENTER
					x = obj.centerx
				Case PFDCommon.TEXT_ALIGNMENT_RIGHT
					x = obj.centerx + (obj.width/2)
			End Select
			'Draw the lines
			If WrappedLines.Size == 1 Then
				y = obj.centery + (fntrect.height / 2)
				cvs.DrawTextRotated(WrappedLines.Get(0), x, y, fnt, obj.textcolor, obj.textalignment, degrees)
			Else
				y = obj.centery - ( (fntrect.Height * WrappedLines.Size) / 2) - (fntrect.height / 2) - HeightOffset
				For Each Line As String In WrappedLines
					y = y + fntrect.Height + HeightOffset
					cvs.DrawTextRotated(Line, x, y, fnt, obj.textcolor, obj.textalignment, degrees)
				Next
			End If
		
			'Down
		Case 90
			x = obj.centerx + ( (fntrect.Width * WrappedLines.Size) / 2) + (fntrect.height / 2) + HeightOffset
			Select obj.textalignment
				Case PFDCommon.TEXT_ALIGNMENT_LEFT
					y = obj.centery - (obj.height/2)
				Case PFDCommon.TEXT_ALIGNMENT_CENTER
					y = obj.centery
				Case PFDCommon.TEXT_ALIGNMENT_RIGHT
					y = obj.centery + (obj.height/2)
			End Select
			'Draw the lines
			If WrappedLines.Size == 1 Then
				x = obj.centerx - (fntrect.width/2)
				cvs.DrawTextRotated(WrappedLines.Get(0), x, y, fnt, obj.textcolor, obj.textalignment, degrees)
			Else
				For Each Line As String In WrappedLines
					x = x - fntrect.Width - HeightOffset
					cvs.DrawTextRotated(Line, x, y, fnt, obj.textcolor, obj.textalignment, degrees)
				Next
			End If

			'Up
		Case 270
			x = obj.centerx - ( (fntrect.Width * WrappedLines.Size) / 2) - (fntrect.height / 2) - HeightOffset
			Select obj.textalignment
				Case PFDCommon.TEXT_ALIGNMENT_LEFT
					y = obj.centery + (obj.height/2)
				Case PFDCommon.TEXT_ALIGNMENT_CENTER
					y = obj.centery
				Case PFDCommon.TEXT_ALIGNMENT_RIGHT
					y = obj.centery - (obj.height/2)
			End Select
			'Draw the lines
			If WrappedLines.Size == 1 Then
				x = obj.centerx + (fntrect.width/2)
				cvs.DrawTextRotated(WrappedLines.Get(0), x, y, fnt, obj.textcolor, obj.textalignment, degrees)
			Else
				For Each Line As String In WrappedLines
					x = x + fntrect.Width + HeightOffset
					cvs.DrawTextRotated(Line, x, y, fnt, obj.textcolor, obj.textalignment, degrees)
				Next
			End If
	End Select
End Sub
#End Region

#Region DrawTextBox
'Draw rounded text box with text wrapped.
'Properties: centerx,centery,width,height,bordercolor,strokewidth,value,font,fontsize.
Public Sub DrawTextbox(cvs As AsyncCanvas, obj As TPFDObject)
	Dim x1,y1,x2,y2 As Int
	Dim rect As B4XRect

	'Set rect dimension
	x1 = obj.centerx - (obj.width/2)
	y1 = obj.centery - (obj.height/2)
	x2 = obj.centerx + (obj.width/2)
	y2 = obj.centery + (obj.height/2)

	'Init the rect
	rect.Initialize(x1,y1,x2,y2)

	'Draw the inner shape
	cvs.DrawRoundRect(rect, obj.fillcolor, True, 0, obj.cornerradius)
	'Draw the outer shape
	If obj.strokewidth > 0 Then cvs.DrawRoundRect(rect, obj.bordercolor, False, obj.strokewidth, obj.cornerradius)

	'Adjust obj fontsize shape selector
	If obj.shapeselector == obj.pfdobject Then
		obj.fontsize = 8
	End If

	'Draw the value in object
	DrawTextRotated(cvs, obj)
	'PFDCommon.DrawValueInObject(cvs, obj)

	'Draw the optional connector
	DrawConnector(cvs, obj)

	'Commit the drawing is done in method ReDraw in PFDBase.
	'cvs.Invalidate
End Sub
#End Region

#Region DrawValueUnit
'Draw shape ValueUnit with 2 horizontal lines for value & unit.
'The unit can contain unicode characters, like Ohm sign \u2126.
Public Sub DrawValueUnit(cvs As AsyncCanvas, obj As TPFDObject)
	Dim cx, cy As Float
	Dim textalignment As String = PFDCommon.TEXT_ALIGNMENT_CENTER

	'Set the font
	Dim fnt As B4XFont = PFDCommon.SetFont(obj)
	Dim fntrect As B4XRect = cvs.MeasureText("A", fnt)

	'Draw value
	cx = obj.centerx
	cy = obj.centery - 1
	cvs.DrawText($"${obj.value}"$, cx, cy, fnt, obj.textcolor, textalignment)

	'Draw unit
	cx = obj.centerx
	cy = obj.centery + fntrect.Height + 1
	cvs.DrawText($"${Helper.DecodeUnicodeString(obj.unit)}"$, cx, cy, fnt, obj.textcolor, textalignment)

	'Commit the drawing is done in method ReDraw in PFDBase.
	'cvs.Invalidate
End Sub
#End Region

