﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=10
@EndOfDesignText@
#Region Code Module Information
'Static Code Module: PFDShapesTemplate
'File: PFDShapesTemplate.bas
'Static code module template for PFD Objects & Shapes.
#End Region

Sub Process_Globals
	'Core
	Private xui As XUI

	'PFD objects specific to this PFD flow type.
	'Each of the PFD objects (UPPERCASE) must match with external shapes file PFDCreator.shp!
	'Common PFD objects are defined in the module PFDShapesBasic.
	'Make Public to access from PFDOperator application..
	Public TEMPLATE_SHAPE_MYSHAPE As String = "MYSHAPE"
End Sub

#Region DrawObject
'Draw shape(s) selected from pfdobjects list.
'The shapes are defined as process_globals.
Public Sub DrawShapesFromList(cvs As AsyncCanvas, pfdobjects As List)
	'Loop over the pfd objects and draw the object shape
	For Each pfdobject As TPFDObject In pfdobjects
		DrawShape(cvs, pfdobject)
	Next
End Sub

'Draw a shape by shape type as defined in process_globals.
Public Sub DrawShape(cvs As AsyncCanvas, obj As TPFDObject)
	Select obj.pfdobject
		Case TEMPLATE_SHAPE_MYSHAPE:
			DrawMyShape(cvs, obj)
	End Select
End Sub
#End Region

#Region DrawMyShape
'Draw template shape myshape
Public Sub DrawMyShape(cvs As AsyncCanvas, obj As TPFDObject)
	Dim p As B4XPath
	
	'TopLeft
	p.Initialize(obj.centerx - (obj.width/2), obj.centery - (obj.height/2))
	'TopRight
	p.LineTo(obj.centerx + (obj.width/2), obj.centery - (obj.height/2))
	'BotLeft
	p.LineTo(obj.centerx - (obj.width/2), obj.centery + (obj.height/2))
	'BotRight
	p.LineTo(obj.centerx + (obj.width/2), obj.centery + (obj.height/2))
	'TopLeft
	p.LineTo(obj.centerx - (obj.width/2), obj.centery - (obj.height/2))
	'Draw the inner path
	cvs.DrawPath(p, obj.fillcolor, True, 0)
	'Draw the outer path
	cvs.DrawPath(p, obj.bordercolor, False, obj.strokewidth)
		
	PFDCommon.DrawValueInObject(cvs, obj)

	'Commit the drawing is done in method ReDraw in PFDBase.
	'cvs.Invalidate
End Sub
#End Region
